<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/playoffs.asp" -->
<!-- #include file="includes/playoffsPick.asp" -->
<!-- #include file="includes/playoffsRank.asp" -->
<!-- #include file="includes/side.asp" -->
<!-- #include file="includes/superbowl.asp" -->
<!-- #include file="includes/weekly.asp" -->
<%	'Limit access to the Administrator.
	call CheckAccess(true)

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Account Balances"
	call BuildPageHeader("tableSort.css", "tableSort.js") %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Define the accounts table sort commands.
	//=========================================================================
	var accountsNameSort = {
		initialSort : true,
		tbodyID     : "accountsBody",
		theadID     : "accountsHead",
		sortColumns : [
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [],
			headColumns : []
		}
	}
	var accountsFeesSort = {
		tbodyID     : "accountsBody",
		theadID     : "accountsHead",
		sortColumns : [
			{ column : 1, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [1],
			headColumns : [1]
		}
	}
	var accountsCreditsSort = {
		tbodyID     : "accountsBody",
		theadID     : "accountsHead",
		sortColumns : [
			{ column : 2, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [2],
			headColumns : [2]
		}
	}
	var accountsBalanceSort = {
		tbodyID     : "accountsBody",
		theadID     : "accountsHead",
		sortColumns : [
			{ column : 3, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [3],
			headColumns : [3]
		}
	}
	//]]></script>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Get a list of users.
	dim users
	users = GetUserList(true)

	'Determine if games for the current week have started.
	dim curWeek, curDateTime
	curWeek = GetCurrentWeek()
	curDateTime = GetCurrentDateTime()

	dim sql, rs
	dim i
	dim week, isLocked
	dim fees, credits
	dim totalReceived
	dim alt
	totalReceived = 0 %>
	<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
		<thead id="accountsHead">
			<tr align="right" class="header bottomEdge sortable">
				<th align="left"><a href="#" onclick="this.blur(); return tableSort.sort(accountsNameSort);" title="Sort by name.">Name</a></th>
				<th><a href="#" onclick="this.blur(); return tableSort.sort(accountsFeesSort);" title="Sort by total fees.">Total Fees</a></th>
				<th><a href="#" onclick="this.blur(); return tableSort.sort(accountsCreditsSort);" title="Sort by credits.">Total Credits</a></th>
				<th><a href="#" onclick="this.blur(); return tableSort.sort(accountsBalanceSort);" title="Sort by balance.">Balance</a></th>
			</tr>
		</thead>
		<tbody id="accountsBody">
<%	if IsArray(users) then
		alt = false
		for i = 0 to UBound(users)
			fees = 0

			'Determine how many weekly entries the player has and add up those
			'fees. Note that the current week is included only after the first
			'game has started.
			week = curWeek
			if curDateTime <= GetWeeklyStartDateTime(week) then
				week = week - 1
			end if
			sql = "SELECT COUNT(*) AS Total FROM WeeklyScoring" _
			   & " WHERE Username = '" & SqlEscape(users(i)) & "'" _
			   & " AND Week <= " & week
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				fees = rs.Fields("Total").Value * WEEKLY_ENTRY_FEE
			end if

			'Add side pool entry fee, if appropriate.
			if InSidePool(users(i)) and curDateTime >= GetWeeklyStartDateTime(SIDE_START_WEEK) then
				fees = fees + SIDE_ENTRY_FEE

				'Add buyback fees for every buyback used. Note that the current
				'week is included only if the player's pick is locked.
				if ENABLE_SURVIVOR_POOL and SURVIVOR_BUYBACK_LIMIT > 0 then
					isLocked = IsSidePickLocked(GetSidePick(users(i), curWeek), curWeek)
					for week = SIDE_START_WEEK to curWeek
						if UsedSurvivorBuyback(users(i), week) and (week < curWeek or isLocked) then
							fees = fees + SURVIVOR_BUYBACK_FEE
						end if
					next
				end if
			end if

			'Add playoffs pick'em and/or rank'em entry fees, if appropriate.
			if curDateTime >= GetPlayoffsStartDateTime() then
				if InPlayoffsPickPool(users(i)) then
					fees = fees + PLAYOFFS_PICK_ENTRY_FEE
				end if
				if InPlayoffsRankPool(users(i)) then
					fees = fees + PLAYOFFS_PICK_ENTRY_FEE
				end if
			end if

			'Add Super Bowl pool entry fee, if appropriate.
			if InSuperBowlPool(users(i)) and IsSuperBowlLocked() then
				fees = fees + SUPER_BOWL_ENTRY_FEE
			end if

			'Get credits.
			credits = GetCreditTotal(users(i))

			'Add player's credits to total received.
			totalReceived = totalReceived + credits

			if alt then %>
			<tr align="right" class="alt singleLine">
<%			else %>
			<tr align="right" class="singleLine">
<%			end if
			alt = not alt %>
				<td align="left"><a href="accountSummary.asp?username=<% = Server.UrlEncode(users(i)) %>"><% = users(i) %></a></td>
				<td><% = FormatAmount(fees) %></td>
				<td><% = FormatAmount(credits) %></td>
				<td><% = FormatAmount(credits - fees) %></td>
			</tr>
<%		next
	else %>
			<tr class="noSort">
				<td align="center" colspan="4"><em>No users found.</em></td>
			</tr>
<%	end if

		'Display fund summary.
		dim totalPaid
		dim n, payout
		totalPaid = 0

		'Get total payouts. The current week is excluded if it has not been
		'completed yet.
		n = GetCurrentWeek()
		if GetWeeklyTiebreakerActual(n) = "" then
			n = n - 1
		end if
		for i = 1 to n
			totalPaid = totalPaid + GetWeeklyPotAmount(i)
		next

		'Add the weekly overall payout, if appropriate.
		if ENABLE_OVERALL_WEEKLY and IsRegularSeasonComplete() then
			totalPaid = totalPaid + GetOverallPotAmount()
		end if

		'Add the survivor pool payout, if appropriate.
		if ENABLE_SURVIVOR_POOL then
			if IsArray(GetSurvivorWinnersList()) then
				payout = GetSurvivorPotAmount()
				totalPaid = totalPaid + payout
			end if
		end if

		'Add the margin pool payout, if appropriate.
		if ENABLE_MARGIN_POOL then
			if IsArray(GetMarginWinnersList()) then
				payout = GetMarginPotAmount()
				totalPaid = totalPaid + payout
			end if
		end if

		'Add the playoffs pick'em pool payout, if appropriate.
		if ENABLE_PLAYOFFS_PICK_POOL then
			if IsArray(GetPlayoffsPickWinnersList()) then
				totalPaid = totalPaid + GetPlayoffsPickEntryCount() * PLAYOFFS_PICK_ENTRY_FEE
			end if
		end if

		'Add the playoffs rank'em pool payout, if appropriate.
		if ENABLE_PLAYOFFS_RANK_POOL then
			if IsArray(GetPlayoffsRankWinnersList()) then
				totalPaid = totalPaid + GetPlayoffsRankEntryCount() * PLAYOFFS_RANK_ENTRY_FEE
			end if
		end if

		'Add the Super Bowl pool payout, if appropriate.
		if ENABLE_SUPER_BOWL_POOL then
			if IsArray(GetSuperBowlWinnersList()) then
				totalPaid = totalPaid + GetSuperBowlEntryCount() * SUPER_BOWL_ENTRY_FEE
			end if
		end if %>
		</tbody>
		<tbody>
			<tr class="header topEdge bottomEdge">
				<th align="left" colspan="4">Fund Summary</th>
			</tr>
			<tr>
				<td colspan="2">Total payments received:</td>
				<td align="right" colspan="2"><% = FormatAmount(totalReceived) %></td>
			</tr>
			<tr class="alt">
				<td colspan="2">Total winnings paid:</td>
				<td align="right" colspan="2"><% = FormatAmount(totalPaid) %></td>
			</tr>
			<tr class="subHeader topEdge">
				<th align="left" colspan="2"><strong>Balance:</strong></th>
				<th align="right" colspan="2"><% = FormatAmount(totalReceived - totalPaid) %></th>
			</tr>
		</tbody>
	</table>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>