<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/side.asp" -->
<!-- #include file="includes/playoffs.asp" -->
<!-- #include file="includes/playoffsPick.asp" -->
<!-- #include file="includes/playoffsRank.asp" -->
<!-- #include file="includes/superbowl.asp" -->
<!-- #include file="includes/weekly.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<%	PageSubTitle = "Account Summary"
	call BuildPageHeader("", "") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'If the user is the Administrator, check for a user name in the request.
	'Otherwise, show data for the current user.
	dim username
	username = Session(SESSION_USERNAME_KEY)
	if IsAdmin() then
		username = Trim(Request("username"))
	end if

	'For the Administrator, build a user selection list.
	if IsAdmin() then %>
		<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
			<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge">
				<th align="left">Administrator Access</th>
			</tr>
			<tr>
				<td class="adminSection freeForm">
					<p>You may view any player's account summary by selecting a username below.</p>
					<table border="0" cellpadding="0" cellspacing="0">
						<tr valign="middle">
							<td><strong>Select user:</strong></td>
							<td>
								<select name="username">
									<% call DisplayUserSelectList(GetUserList(true), username) %>
								</select>
							</td>
							<td><input type="submit" name="submit" value="Select" class="button" /></td>
						</tr>
					</table>
				</td>
			</tr>
			</table>
		</form>
<%	end if

	'Build a list of transactions for the given user.
	dim sql, rs
	dim curWeek, isLocked
	dim transactions
	dim totalCredits
	dim totalFees
	transactions = Array()
	if username <> "" then

		'Add a transaction for each credit record in the database.
		totalCredits = 0
		sql = "SELECT * FROM Credits" _
		   & " WHERE Username = '" & SqlEscape(username) & "'"
		set rs = DbConn.Execute(sql)
		if not (rs.EOF and rs.BOF) then
			do while not rs.EOF
				totalCredits = totalCredits + rs.Fields("Amount").Value
				call AddTransaction(rs.Fields("Timestamp").Value, rs.Fields("Description").Value, rs.Fields("Amount").Value)
			rs.MoveNext
			loop
		end if

		'Get the current date and time and week.
		dim curDateTime
		curDateTime = GetCurrentDateTime()
		curWeek = GetCurrentWeek()

		'Add a transaction for the survivor/margin pool, if appropriate.
		if ENABLE_SURVIVOR_POOL or ENABLE_MARGIN_POOL then
			if InSidePool(username) and curDateTime >= GetWeeklyStartDateTime(SIDE_START_WEEK) then
				call AddTransaction(GetWeeklyStartDateTime(SIDE_START_WEEK), SidePoolTitle & " Pool Entry Fee", -SIDE_ENTRY_FEE)
				totalFees = totalFees + SIDE_ENTRY_FEE
			end if
		end if

		'Add a transaction for every buyback used. Note that the current week
		'is included only if the user's pick is locked.
		if ENABLE_SURVIVOR_POOL and SURVIVOR_BUYBACK_LIMIT > 0 then
			if InSidePool(username) then
				isLocked = IsSidePickLocked(GetSidePick(username, curWeek), curWeek)
				for week = SIDE_START_WEEK to curWeek
					if UsedSurvivorBuyback(username, week) and (week < curWeek or isLocked) then
						call AddTransaction(GetWeeklyStartDateTime(week), "Week " & week & " Survivor Pool Buyback Fee", -SURVIVOR_BUYBACK_FEE)
						totalFees = totalFees + SURVIVOR_BUYBACK_FEE
					end if
				next
			end if
		end if

		'Add a transaction for each week played so far. Note that the current
		'week is included only after the first game has started.
		dim week
		week = curWeek
		if curDateTime <= GetWeeklyStartDateTime(week) then
			week = week - 1
		end if
		sql = "SELECT Week FROM WeeklyScoring" _
		   & " WHERE Username = '" & SqlEscape(username) & "'" _
		   & " AND Week <= " & week
		set rs = DbConn.Execute(sql)
		if not (rs.EOF and rs.BOF) then
			do while not rs.EOF
				week = rs.Fields("Week").Value
				call AddTransaction(GetWeeklyStartDateTime(week), "Week " & week & " Pool Entry Fee", -WEEKLY_ENTRY_FEE)
				totalFees = totalFees + WEEKLY_ENTRY_FEE
				rs.MoveNext
			loop
		end if
	end if

	'Add transaction for the playoffs pick'em and rank'em pools, if appropriate.
	dim playoffsDateTime
	if ENABLE_PLAYOFFS_PICK_POOL or ENABLE_PLAYOFFS_RANK_POOL then
		playoffsDateTime = GetPlayoffsStartDateTime()
		if curDateTime >= playoffsDateTime then
			if ENABLE_PLAYOFFS_PICK_POOL and InPlayoffsPickPool(username) then
				call AddTransaction(playoffsDateTime, "Playoffs Pick'em Entry Fee", -PLAYOFFS_PICK_ENTRY_FEE)
				totalFees = totalFees + PLAYOFFS_PICK_ENTRY_FEE
			end if
			if ENABLE_PLAYOFFS_RANK_POOL and InPlayoffsRankPool(username) then
				call AddTransaction(playoffsDateTime, "Playoffs Rank'em Entry Fee", -PLAYOFFS_PICK_ENTRY_FEE)
				totalFees = totalFees + PLAYOFFS_PICK_ENTRY_FEE
			end if
		end if
	end if

	'Add a transaction for the Super Bowl pool, if appropriate.
	dim superBowlDateTime
	if ENABLE_SUPER_BOWL_POOL then
		superBowlDateTime = GetSuperBowlStartDateTime()
		if curDateTime >= superBowlDateTime and InSuperBowlPool(username) then
			call AddTransaction(superBowlDateTime, "Super Bowl Entry Fee", -SUPER_BOWL_ENTRY_FEE)
			totalFees = totalFees + SUPER_BOWL_ENTRY_FEE
		end if
	end if

	'Sort the transactions
	dim i, j, temp
	for i = 0 to UBound(transactions) - 1
		for j = i + 1 to UBound(transactions)
			if transactions(i).timestamp > transactions(j).timestamp then
				set temp = transactions(i)
				set transactions(i) = transactions(j)
				set transactions(j) = temp
			end if
		next
	next

	'Build a list of pools won by the user.
	dim pools
	dim winners, n, pot
	dim pickPot, confPot
	dim numWeeks
	pools = Array()
	numWeeks = GetWeekCount()
	for i = 1 to numWeeks
		winners = GetWeeklyWinnersList(i)
		if InList(username, winners) then
			n = UBound(winners) + 1
			pot = GetWeeklyPotAmount(i)
			call AddPool("Week " & i & " Pool", pot / n)
		end if
	next
	if ENABLE_OVERALL_WEEKLY then
		winners = GetOverallPickWinnersList()
		pickPot = GetOverallPotAmount()
		if USE_CONFIDENCE_POINTS then
			confPot = pickPot * OVERALL_CONFIDENCE_WEEKLY_SHARE
			pickPot = pickPot - confPot
		end if
		if InList(username, winners) then
			n = UBound(winners) + 1
			call AddPool("Overall Weekly Picks", pickPot / n)
		end if
		if USE_CONFIDENCE_POINTS then
			winners = GetOverallConfidenceWinnersList()
			if InList(username, winners) then
				n = UBound(winners) + 1
				call AddPool("Overall Weekly Points", confPot / n)
			end if
		end if
	end if
	if ENABLE_SURVIVOR_POOL then
		winners = GetSurvivorWinnersList()
		if InList(username, winners) then
			n = UBound(winners) + 1
			pot = GetSurvivorPotAmount()
			call AddPool("Survivor Pool", pot / n)
		end if
	end if
	if ENABLE_MARGIN_POOL then
		winners = GetMarginWinnersList()
		if InList(username, winners) then
			n = UBound(winners) + 1
			pot = GetMarginPotAmount()
			call AddPool("Margin Pool", pot / n)
		end if
	end if
	if ENABLE_PLAYOFFS_PICK_POOL then
		winners = GetPlayoffsPickWinnersList()
		if InList(username, winners) then
			n = UBound(winners) + 1
			pot = GetPlayoffsPickEntryCount() * PLAYOFFS_PICK_ENTRY_FEE
			call AddPool("Playoffs Pick'em Pool", pot / n)
		end if
	end if
	if ENABLE_PLAYOFFS_RANK_POOL then
		winners = GetPlayoffsRankWinnersList()
		if InList(username, winners) then
			n = UBound(winners) + 1
			pot = GetPlayoffsRankEntryCount() * PLAYOFFS_RANK_ENTRY_FEE
			call AddPool("Playoffs Rank'em Pool", pot / n)
		end if
	end if
	if ENABLE_SUPER_BOWL_POOL then
		winners = GetSuperBowlWinnersList()
		if InList(username, winners) then
			n = UBound(winners) + 1
			pot = GetSuperBowlEntryCount() * SUPER_BOWL_ENTRY_FEE
			call AddPool("Super Bowl Pool", pot / n)
		end if
	end if


	'Build the display.
	if username <> "" then
		if IsAdmin() then %>
	<h2>Account Transactions for <% = username %></h2>
<%		else %>
	<h2>Account Transactions</h2>
<%		end if %>
	<table class="main" border="0" cellpadding="0" cellspacing="0">
		<tr class="header bottomEdge">
			<th align="left">Date</th>
			<th align="left">Time</th>
			<th align="left" style="width: 24em;">Description</th>
			<th align="right">Amount</th>
		</tr>
<%		dim total, alt
		total = 0
		if UBound(transactions) >= 0 then
			alt = false
			for i = 0 to UBound(transactions)
				if alt then %>
		<tr align="right" class="alt" valign="top">
<%				else %>
		<tr align="right" valign="top">
<%				end if
				alt = not alt %>
			<td><% = FormatTransactionDate(transactions(i).timestamp) %></td>
			<td><% = FormatFullTime(transactions(i).timestamp) %></td>
			<td align="left"><% = transactions(i).description %></td>
			<td><% = FormatAmount(transactions(i).amount) %></td>
		</tr>
<%			total = total + transactions(i).amount
			next
    	 else %>
		<tr>
			<td align="center" colspan="4"><em>No transactions found.</em></td>
		</tr>
<%  	 end if %>
		<tr class="header topEdge bottomEdge">
			<th align="left" colspan="4">Totals</th>
		</tr>
		<tr>
			<td colspan="3">Credits:</td>
			<td align="right"><% = FormatAmount(totalCredits) %></td>
		</tr>
		<tr class="alt">
			<td colspan="3">Fees:</td>
			<td align="right"><% = FormatAmount(totalFees) %></td>
		</tr>
		<tr class="subHeader topEdge">
			<th align="left" colspan="3">Balance:</th>
			<th align="right"><% = FormatAmount(total) %></th>
		</tr>
	</table>
<%		if IsAdmin() then %>
	<h2>Pool Winnings for <% = username %></h2>
<%		else %>
	<h2>Pool Winnings</h2>
<%		end if %>
	<table class="main" border="0" cellpadding="0" cellspacing="0" style="width: 100%;">
		<tr class="header bottomEdge">
			<th align="left">Pool Name</th>
			<th align="right">Amount</th>
		</tr>
<%		dim totalWinnings
		if UBound(pools) >= 0 then
			totalWinnings = 0
			alt = false
			for i = 0 to UBound(pools)
				if alt then %>
		<tr class="alt" valign="top">
<%				else %>
		<tr valign="top">
<%				end if
				alt = not alt %>
			<td><% = pools(i).name %></td>
			<td align="right"><% = FormatAmount(pools(i).amount) %></td>
		</tr>
<%				totalWinnings = totalWinnings + pools(i).amount
			next
    	 else %>
		<tr>
			<td align="center" colspan="4"><em>No pools won.</em></td>
		</tr>
<%  	 end if %>
		<tr class="header topEdge bottomEdge">
			<th align="left" colspan="4">Totals</th>
		</tr>
		<tr>
			<td>Winnings:</td>
			<td align="right"><% = FormatAmount(totalWinnings) %></td>
		</tr>
		<tr class="alt">
			<td>Fees:</td>
			<td align="right"><% = FormatAmount(totalFees) %></td>
		</tr>
		<tr class="subHeader topEdge">
			<th align="left">Net:</th>
			<th align="right"><% = FormatAmount(totalWinnings - totalFees) %></th>
		</tr>
	</table>
<%	end if %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Returns a formatted date string given a Date object.
	'--------------------------------------------------------------------------
	function FormatTransactionDate(dt)

		dim dd

		dd = Day(dt)
		if dd < 10 then
			dd = "0" & dd
		end if

		FormatTransactionDate = Month(dt) & "/" & dd & "/" & Year(dt)

	end function

	'--------------------------------------------------------------------------
	' Adds a transaction to the global list.
	'--------------------------------------------------------------------------
	sub AddTransaction(timestamp, description, amount)

		dim n

		n = UBound(transactions) + 1
		redim preserve transactions(n)
		set transactions(n) = new TransactionObj
		call transactions(n).setData(timestamp, description, amount)

	end sub

	'--------------------------------------------------------------------------
	' Adds a pool to the global list.
	'--------------------------------------------------------------------------
	sub AddPool(name, amount)

		dim n

		n = UBound(pools) + 1
		redim preserve pools(n)
		set pools(n) = new PoolObj
		call pools(n).setData(name, amount)

	end sub

	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' TransactionObj: Holds information for a single account transaction.
	'--------------------------------------------------------------------------
	class TransactionObj

		public timestamp
		public description
		public amount

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(t, d, a)

			'Set properties.
			timestamp = t
			description = d
			amount = a

		end sub

	end class

	'--------------------------------------------------------------------------
	' PoolObj: Holds information about a single pool the user has won.
	'--------------------------------------------------------------------------
	class PoolObj

		public name
		public amount

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(n, a)

			'Set properties.
			name = n
			amount = a

		end sub

	end class %>