<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" -->
<!-- #include file="includes/common.asp" -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/playoffs.asp" -->
<!-- #include file="includes/news.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Home Page"
	call BuildPageHeader("", "") %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Store the username in a cookie so it can be preselected on the login
	// page.
	//=========================================================================
	domUtils.onready(function () {
		try {
			if (domUtils.getCookie("<% = SESSION_USERNAME_KEY %>") != "<% = Session(SESSION_USERNAME_KEY) %>") {
				var expDate = new Date();
				expDate.setDate(expDate.getDate() + 14);
				domUtils.setCookie("<% = SESSION_USERNAME_KEY %>", "<% = Session(SESSION_USERNAME_KEY) %>", expDate);
			}
		}
		catch (ex) {}
	});
	//]]></script>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'If the current user is disabled, display a message.
	if IsDisabled() then
		call DisplayWarningMessage("Warning: Your account has been disabled. Please contact the Administrator.")
	end if %>
	<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
		<tr class="header bottomEdge">
			<th align="left">Are you ready for some football?</th>
		</tr>
		<tr>
			<td class="freeForm">
				<h2><%	= GetMainHeader() %></h2>
				<!-- News. -->
<%	'Display any news.
	call DisplayNews(4, GetNews()) %>
				<!-- End news. -->
<%	'List any early games.
	dim found, dateTime, sql, rs, week, dayName
	found = false
	dateTime = GetCurrentDateTime()
	sql = "SELECT * FROM Schedule" _
	   & " WHERE [DateTime] > " & DATABASE_DATETIME_DELIMITER _
       &  dateTime & DATABASE_DATETIME_DELIMITER _
	   & " ORDER BY [DateTime]"
	set rs = DbConn.Execute(sql)
	if not (rs.EOF and rs.BOF) then
		week = 0
		do while not rs.EOF
			dayName = Weekday(rs.Fields("DateTime").Value)
			if week <> rs.Fields("Week").Value and _
			   dayName <> vbSunday and _
			   dayName <> vbMonday then
				week = rs.Fields("Week").Value
				if not found then
					found = true %>
				<h2>Early Games</h2>
				<p>There are early games on the following dates, be sure to make your picks for these games on time:</p>
				<ul>
<%				end if %>
					<li><a href="weeklyEntry.asp?week=<% = rs.Fields("Week").Value %>">Week <% = rs.Fields("Week").Value %></a> - <% = FormatDateTime(rs.Fields("DateTime").Value, vbLongDate) %></li>
<%			end if
			rs.MoveNext
		loop
		if found then %>
				</ul>
<%		end if
	end if %>
				<p>See the <a href="helpRules.asp">pool rules</a> and <a href="helpSiteMap.asp">site map</a> for help.</p>
			</td>
		</tr>
	</table>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Returns an appropriate header based on the current date.
	'--------------------------------------------------------------------------
	function GetMainHeader()

		dim sql, rs
		dim currentDay, lastDay

		GetMainHeader = ""
		currentDay = GetCurrentDateTime()

		'Get the date of the last game in the regular season.
		sql = "SELECT MAX([DateTime]) AS LastDay FROM Schedule"
		set rs = DbConn.Execute(sql)
		if not (rs.EOF and rs.BOF) then
			lastDay = rs.Fields("LastDay").Value

			'Show the current week header up until two days after that game.
			if currentDay <= DateAdd("d", 2, lastDay) then
				GetMainHeader = "Week " & GetCurrentWeek()
				exit function
			end if
		end if

		if PlayoffsPoolsCount > 0 then

			'Get the date of the last playoff game before the Super Bowl.
			sql = "SELECT MAX([DateTime]) AS LastDay FROM PlayoffsSchedule" _
			   & " WHERE Round < " & GetPlayoffsRoundCount()
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				lastDay = rs.Fields("LastDay").Value

				'Show the playoffs header up until two days after that game.
				if currentDay <= DateAdd("d", 2, lastDay) then
					GetMainHeader = "Playoffs"
					exit function
				end if
			end if

			'Get the date of the Super Bowl.
			sql = "SELECT MAX([DateTime]) AS LastDay FROM PlayoffsSchedule"
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				lastDay = rs.Fields("LastDay").Value

				'Show the Super Bowl header up until two days after the game.
				if currentDay <= DateAdd("d", 2, lastDay) then
					GetMainHeader = "Super Bowl"
					exit function
				end if
			end if

		end if

		'The season must be over.
		GetMainHeader = "The Season is Over"

	end function %>

