<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" -->
<!-- #include file="includes/common.asp" -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/email.asp" -->
<!-- #include file="includes/encryption.asp" -->
<!-- #include file="includes/form.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Edit Profile"
	call BuildPageHeader("", "") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'If the user is the Administrator, check for a user name in the request.
	'Otherwise, show data for the current user.
	dim username
	username = Session(SESSION_USERNAME_KEY)
	if IsAdmin() then
		username = Trim(Request("username"))
	end if

	'For the Administrator, build a user selection list.
	if IsAdmin() then %>
		<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
			<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge">
				<th align="left">Administrator Access</th>
			</tr>
			<tr>
				<td class="adminSection freeForm">
					<p>You may view or edit any user's profile (including your own) by selecting a username below.</p>
					<table border="0" cellpadding="0" cellspacing="0">
						<tr valign="middle">
							<td><strong>Select user:</strong></td>
							<td>
								<select name="username">
									<% call DisplayUserSelectList(GetUserList(false), username) %>
								</select>
							</td>
							<td><input type="submit" name="submit" value="Select" class="button" /></td>
						</tr>
					</table>
				</td>
			</tr>
			</table>
		</form>
<%		if username <> "" then %>
		<h2>Profile for <% = username %></h2>
<%		end if
	end if

	'If and update was requested, process it.
	dim email, contact, news, schedule, spread, result, theme, disable
	dim sql, rs
	if Request.Form("submit") = "Update" and username <> "" then

		'Get the form fields.
		email    = Trim(Request.Form("email"))
		contact  = Trim(Request.Form("contact"))
		news     = Trim(Request.Form("news"))
		schedule = Trim(Request.Form("schedule"))
		spread   = Trim(Request.Form("spread"))
		result   = Trim(Request.Form("result"))
		theme    = Trim(Request.Form("theme"))
		disable  = Trim(Request.Form("disable"))
		if LCase(news)     <> "true" then news     = false end if
		if LCase(schedule) <> "true" then schedule = false end if
		if LCase(spread)   <> "true" then spread   = false end if
		if LCase(result)   <> "true" then result   = false end if
		if LCase(disable)  <> "true" then disable  = false end if

		'Valid the email address, if provided.
		if email <> "" and not IsValidEmailAddress(email) then
			FormFieldErrors.Add "email", "'" & email & "' does not appear to be a valid email address."
		end if

		'If notifications are requested, make sure and email address is specified.
		if (news or schedule or spread or result) and email = "" then
			FormFieldErrors.Add "email", "An email address is required to receive notifications."
		end if

		'If there were no errors, do the updates.
		if FormFieldErrors.Count = 0 then
			sql = "UPDATE Users SET" _
			   & " EmailAddress = '" & Encrypt(email) & "'," _
			   & " ContactInformation = '" & Encrypt(contact) & "'," _
			   & " NotifyOfNewsUpdates = '" & news & "'," _
			   & " NotifyOfScheduleUpdates = '" & schedule & "'," _
			   & " NotifyOfSpreadUpdates = '" & spread & "', " _
			   & " NotifyOfResultUpdates = '" & result & "'," _
			   & " TeamThemeID = '" & theme & "'"
			if IsAdmin() then
				sql = sql & ", DisableEntries = '" & disable & "'"
			end if
			sql = sql & " WHERE Username = '" & SqlEscape(username) & "'"
			call DbConn.Execute(sql)

			'Determine if the Administrator is updating some other user's
			'profile or not.
			if IsAdmin() and username <> ADMIN_USERNAME then

				'Yes, just display a message.
				call DisplaySuccessMessage("Update successful.")
			else

				'No, the current user is updating his or her own profile so
				'save the message in the session and redirect back to this
				'page (to pick up any theme change).
				Session(SESSION_THEME_KEY) = theme
				Session(SESSION_MESSAGE_KEY) = "Update successful."
				dim qStr
				qStr = ""
				if IsAdmin() then
					qStr = "?username=" & Server.UrlEncode(username)
				end if
				Response.Redirect(Request.ServerVariables("SCRIPT_NAME") & qStr)
			end if

		'Otherwise, show the form field errors.
		else
			call DisplayFormFieldErrorsMessage("Error: Invalid fields. Please correct and resubmit.")
		end if
	end if

	'If a message was saved in the session (during an update), show that
	'message and clear the session variable.
	if Session(SESSION_MESSAGE_KEY) <> "" then
		call DisplaySuccessMessage(Session(SESSION_MESSAGE_KEY))
		Session.Contents.Remove(SESSION_MESSAGE_KEY)
	end if

	'Build the form display.
	if username <> "" then
		dim newsCheckedStr, scheduleCheckedStr, spreadCheckedStr, resultCheckedStr, disableCheckedStr
		sql = "SELECT * FROM Users WHERE Username = '" & SqlEscape(username) & "'"
		set rs = DbConn.Execute(sql)
		if not (rs.EOF and rs.BOF) then
			email    = GetFieldValue("email",    Decrypt(rs.Fields("EmailAddress").Value))
			contact  = GetFieldValue("contact",  Decrypt(rs.Fields("ContactInformation").Value))
			news     = GetFieldValue("news",     rs.Fields("NotifyOfNewsUpdates").Value)
			schedule = GetFieldValue("schedule", rs.Fields("NotifyOfScheduleUpdates").Value)
			spread   = GetFieldValue("spread",   rs.Fields("NotifyOfSpreadUpdates").Value)
			result   = GetFieldValue("result",   rs.Fields("NotifyOfResultUpdates").Value)
			theme    = GetFieldValue("theme",    rs.Fields("TeamThemeID").Value)
			disable  = GetFieldValue("disable",  rs.Fields("DisableEntries").Value)

			'Set the checkbox states.
			newsCheckedStr = "" : scheduleCheckedStr = "" : spreadCheckedStr = "" : resultCheckedStr = ""
			if news     then newsCheckedStr     = CHECKED_ATTRIBUTE end if
			if schedule then scheduleCheckedStr = CHECKED_ATTRIBUTE end if
			if spread   then spreadCheckedStr   = CHECKED_ATTRIBUTE end if
			if result   then resultCheckedStr   = CHECKED_ATTRIBUTE end if
			if disable  then disableCheckedStr  = CHECKED_ATTRIBUTE end if

			'If there were errors on the form post processing, restore the checkboxes using the posted information.
			if FormFieldErrors.Count > 0 then

				'If the user unchecked a checkbox, be sure to leave it unchecked.
				if not FormFieldExists("news")     then newsCheckedStr     = "" end if
				if not FormFieldExists("schedule") then scheduleCheckedStr = "" end if
				if not FormFieldExists("spread")   then spreadCheckedStr   = "" end if
				if not FormFieldExists("result")   then resultCheckedStr   = "" end if
				if not FormFieldExists("disable")  then disableCheckedStr  = "" end if

			end if
		end if %>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
<%		if IsAdmin() then %>
		<div><input type="hidden" name="username" value="<% = username %>" /></div>
<%		end if %>
		<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge">
				<th align="left">Edit Your Profile</th>
			</tr>
			<tr>
				<td class="freeForm">
<%		dim str
		str = "Use this form to change your personal information"
		if SERVER_EMAIL_ENABLED then
			str = str & " and enable or disable email notifications"
		end if
		str = str & "."
		if ENABLE_TEAM_THEMES then
			str = str & " You can also personalize the look of the site based on your favorite team."
		end if %>
					<p><% = str %>
					Personal information is for use by the Administrator and <em>will not</em> be shared with other players.</p>
<%		if SERVER_EMAIL_ENABLED then %>
					<p><em>If you choose to receive notifications, please be sure your email address is correct.</em></p>
<%		end if %>
					<table border="0" cellpadding="0" cellspacing="0">
						<tr>
							<td><strong>Username:</strong></td>
							<td><% = username %></td>
						</tr>
						<tr>
							<td><strong>Email address:</strong></td>
							<td><input type="text" name="email" value="<% = Server.HtmlEncode(email) %>" size="30" class="<% = StyleFormField("", "email") %>" style="width: 18em;" /></td>
						</tr>
						<tr valign="top">
							<td><strong>Contact information:</strong></td>
							<td><textarea name="contact" rows="4" cols="30" style="width: 18em;"><% = Server.HtmlEncode(contact) %></textarea>
							</td>
						</tr>
<%		if SERVER_EMAIL_ENABLED then %>
						<tr>
							<td><strong>Email notifications:</strong></td>
							<td><input type="checkbox" id="news" name="news" value="true"<% = newsCheckedStr %> /> <label for="news">News announcements.</label></td>
						</tr>
						<tr>
							<td>&nbsp;</td>
							<td><input type="checkbox" id="schedule" name="schedule" value="true"<% = scheduleCheckedStr %> /> <label for="schedule">Scheduling changes.</label></td>
						</tr>
<%			if USE_POINT_SPREADS or SHOW_POINT_SPREADS then %>
						<tr>
							<td>&nbsp;</td>
							<td><input type="checkbox" id="spread" name="spread" value="true"<% = spreadCheckedStr %> /> <label for="spread">Point spread updates.</label></td>
						</tr>
<%			end if %>
						<tr>
							<td>&nbsp;</td>
							<td><input type="checkbox" id="result" name="result" value="true"<% = resultCheckedStr %> /> <label for="result">Game results posted.</label></td>
						</tr>
<%		end if
		if ENABLE_TEAM_THEMES then %>
						<tr>
							<td><strong>Use team theme:</strong></td>
							<td>
								<select name="theme">
									<option value=""></option>
<%			set rs = GetTeamsRecordset()
			do while not rs.EOF %>
									<option value="<% = rs.Fields("TeamID").Value %>"<% if rs.Fields("TeamID").Value = theme then Response.Write(" selected=""selected""") end if %>><% = rs.Fields("City").Value & " " & rs.Fields("Name").Value %></option>
<%				rs.MoveNext
			loop %>
								</select>
							</td>
						</tr>
<%		end if

		'For the Administrator, show the option to disable the user.
		if IsAdmin() and username <> ADMIN_USERNAME then
			dim str1, str2
			str1 = "pool entries"
			str2 = "entries"
			if ENABLE_MESSAGE_BOARD then
				str1 = str1 & " or message board posts"
				str2 = str2 & " or posts"
			else
			end if %>
						<tr>
							<td colspan="2">
								<p class="adminSection" style="margin: 1ex 0px;">When disabled, a player may still log in but cannot make or change <% = str1 %>.
								(The player is permitted to delete any open <% = str2 %>, however).
								The player will receive a message to that effect on log in.</p>
							</td>
						</tr>
						<tr valign="middle">
							<td><strong>Disable user:</strong></td>
							<td><input type="checkbox" id="disable" name="disable" value="true"<% = disableCheckedStr %> /> <label for="disable">Prevent player from making <% = str2 %>.</label></td>
						</tr>
<%		end if %>
					</table>
				</td>
			</tr>
		</table>
		<p><input type="submit" name="submit" value="Update" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></p>
	</form>
<%	end if %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>