<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/email.asp" -->
<!-- #include file="includes/encryption.asp" -->
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/superbowl.asp" -->
<%	'Limit access to the Administrator.
	call CheckAccess(true)

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Edit Super Bowl Pool"
	call BuildPageHeader("", "") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'If there are any entries, show a warning message.
	if Request.ServerVariables("Content_Length") = 0  then
		if GetSuperBowlEntryCount() > 0 then
			call DisplayWarningMessage("Warning: There are existing entries for this pool. Updating propositions may invalidate them.")
		end if
	end if

	'If there is form data, process it.
	dim sql, rs
	dim n, i
	dim propID, desc, hdr, delete
	dim newDesc, newHdr
	dim missingDescMsg, missingHdrMsg
	dim notify, infoMsg
	if Request.ServerVariables("Content_Length") > 0 and not IsCancelRequest() then

		'Validate fields.
		newDesc = Trim(Request.Form("newDesc"))
		newHdr  = Trim(Request.Form("newHdr"))
		if Len(newDesc) > 0 then
			if Len(newHdr) = 0 then
				FormFieldErrors.Add "newHdr", "Missing new proposition header."
			end if
		elseif Len(newHdr) > 0 then
			if Len(newDesc) = 0 then
				FormFieldErrors.Add "newDesc", "Missing new proposition description."
			end if
		end if

		n = GetSuperBowlPropCount()
		missingDescMsg = "Missing description."
		missingHdrMsg  = "Missing header."
		for i = 1 to n
			desc = Trim(Request.Form("desc-"   & i))
			hdr  = Trim(Request.Form("hdr-"    & i))
			if Len(desc) = 0 then
				FormFieldErrors.Add "desc-" & i, missingDescMsg
				missingDescMsg = ""
			end if
			if Len(hdr) = 0 then
				FormFieldErrors.Add "hdr-" & i, missingHdrMsg
				missingHdrMsg = ""
			end if
		next

		'If there were any errors, display the error message. Otherwise, do the
		'updates.
		if FormFieldErrors.Count > 0 then
			call DisplayFormFieldErrorsMessage("Error: Invalid fields. Please correct and resubmit.")
		else

			'Delete or update exisiting propositions.
			for i = 1 to n
				propID = Trim(Request.Form("id-"     & i))
				desc   = Trim(Request.Form("desc-"   & i))
				hdr    = Trim(Request.Form("hdr-"    & i))
				delete = Trim(Request.Form("delete-" & i))

				if LCase(delete) ="true" then
					sql = "DELETE FROM SuperBowlProps WHERE PropID = " & propID
				else
					sql = "UPDATE SuperBowlProps" _
					  & " SET Description = '" & SqlEscape(desc) & "'," _
					  & " Header = '" & SqlEscape(hdr) & "'" _
					  & " WHERE PropID = " & propID
				end if
				call DbConn.Execute(sql)
			next

			'Add a new proposition.
			if Len(newDesc) > 0 then
				sql = "INSERT INTO SuperBowlProps" _
				   & " (Description, Header)" _
				   & " VALUES('" & SqlEscape(newDesc) & "', '" & SqlEscape(newHdr) & "')"
				call DbConn.Execute(sql)
			end if

			'Clear those fields.
			newDesc = ""
			newHdr  = ""

			'Send out email notifications, if checked.
			infoMsg = "Update successful."
			notify = Trim(Request.Form("notify"))
			if LCase(notify) = "true" then
				infoMsg = "Update successful, notifications sent."
				call SendNotifications()
			end if

			'Updates done, show an informational message.
			call DisplaySuccessMessage(infoMsg)
		end if
	end if

	'Build the display. %>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<table class="main" cellpadding="0" cellspacing="0">
			<tr class="header">
				<th align="left" colspan="2">Super Bowl Proposition</th>
				<th align="left">Header</th>
				<th>Delete</th>
			</tr>
<%	'Get proposition bets.
	dim alt
	sql = "SELECT * FROM SuperBowlProps ORDER BY PropID"
	set rs = DbConn.Execute(sql)
	n = 1
	alt = false
	if not (rs.EOF and rs.BOF) then
		do while not rs.EOF
			propID = rs.Fields("PropID").Value
			desc   = rs.Fields("Description").Value
			hdr    = rs.Fields("Header").Value

			'If there were any errors on an update, restore the submitted
			'field values.
			if FormFieldErrors.Count > 0 then
				desc = GetFieldValue("desc-" & n, desc)
				hdr  = GetFieldValue("hdr-"  & n, hdr)
			end if

			if alt then %>
			<tr class="alt">
<%			else %>
			<tr>
<%			end if
			alt = not alt %>
				<td align="right"><input type="hidden" name="id-<% = n %>" value="<% = propID %>" /><% = n %>.</td>
				<td><input type="text" name="desc-<% = n %>" value="<% = desc %>" size="40" class="<% = StyleFormField("", "desc-" & n) %>" /></td>
				<td><input type="text" name="hdr-<% = n %>" value="<% = hdr %>" size="20" class="<% = StyleFormField("", "hdr-" & n) %>" /></td>
				<td align="center"><input type="checkbox" id="delete-<% = n %>-D" name="delete-<% = n %>" value="true" /></td>
			</tr>
<%			rs.MoveNext
			n = n + 1
		loop
	else %>
			<tr>
				<td>&nbsp;</td>
				<td align="center" colspan="2"><em>No propositions found.</em></td>
				<td>&nbsp;</td>
			</tr>
<%	end if %>
			<tr class="header topEdge BottomEdge">
				<th align="left" colspan="4">Add a New Proposition</th>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td><input type="text" name="newDesc" value="<% = newDesc %>" size="40" /></td>
				<td><input type="text" name="newHdr" value="<% = newHdr %>" size="20" /></td>
				<td>&nbsp;</td>
			</tr>
<%	if SERVER_EMAIL_ENABLED then %>
			<tr class="subHeader topEdge">
				<th align="left" colspan="4"><input type="checkbox" id="notify" name="notify" value="true" /> <label for="notify">Send update notification to users.</label></th>
			</tr>
<%	end if %>
		</table>
		<p><input type="submit" name="submit" value="Update" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></p>
	</form>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Sends an email notification to any users who have elected to receive
	' them.
	'--------------------------------------------------------------------------
	sub SendNotifications()

		dim subj, body
		dim sql, rs
		dim n, num, desc, result
		dim list, email

		subj = "Super Bowl Pool Update Notification"
		body = "The Super Bowl pool has been updated." & vbCrLf & vbCrLf

		'Show the playoffs schedule.
		sql = "SELECT * FROM SuperBowlProps ORDER BY PropID"
		set rs = DbConn.Execute(sql)
		n = 1
		do while not rs.EOF
			desc = rs.Fields("Description").Value
			result = rs.Fields("Result").Value
			num = n
			if n < 10 then
				num = " " & num
			end if
			if IsNull(result) then
				result = "n/a"
			end if
			body = body & num & ". " & desc & " - " & result & vbCrLf
			n = n + 1
			rs.MoveNext
		loop
		body = body & vbCrLf

		list = GetNotificationList("NotifyOfNewsUpdates")
		for each email in list
			call SendMail(email, subj, body)
		next

	end sub %>

