<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/form.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'If quick picks is disabled, redirect to the home page.
	if not ENABLE_QUICK_PICKS then
		Response.Redirect("./")
	end if

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Edit Team Rankings"
	call BuildPageHeader("", "") %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Module: autoSort
	//
	// Used to re-order the teams display when the user changes a ranking.
	//=========================================================================
	var autoSort = function (){

		var tbodyEl = null;

		//---------------------------------------------------------------------
		// Initializes the auto sort feature.
		//---------------------------------------------------------------------
		function init() {

			// Get the table body, exit if not found.
			tbodyEl = document.getElementById("teamRankings");
			if (tbodyEl == null)
				return;

			// Get the select field in each row.
			for (var i = 0; i < tbodyEl.rows.length; i++) {
				tbodyEl.rows[i].selectEl = null;
				try {
					var cellEl = tbodyEl.rows[i].cells[tbodyEl.rows[i].cells.length - 1];
					var elList = cellEl.getElementsByTagName("SELECT");
					tbodyEl.rows[i].selectEl = elList[0];
				}
				catch (ex) {}
			}
		}

		//---------------------------------------------------------------------
		// Returns the currently selected rank of a team within a table row.
		//---------------------------------------------------------------------
		function getRank(row) {

			var rank = 0;

			if (row.selectEl != null) {
				var n = parseInt(row.selectEl.value, 10);
				if (!isNaN(n))
					rank = n;
			}

			return rank;
		}

		//=====================================================================
		// Initialization code.
		//=====================================================================

		// Initialize on page load.
		domUtils.onready(init);

		//=====================================================================
		// Public properties and methods.
		//=====================================================================
		return {

			//-----------------------------------------------------------------
			// Sorts the teams by selected rank.
			//-----------------------------------------------------------------
			sort : function () {

				var i, j;
				var topIndex;
				var tmpEl;

				// If the table body does not exist, exit.
				if (tbodyEl == null)
					return;

				// Get each teams currently selected rank.
				for (i = 0; i < tbodyEl.rows.length; i++) {
					tbodyEl.rows[i].selectedRank = getRank(tbodyEl.rows[i]);

					// If no rank is currently set, use the row position.
					if (tbodyEl.rows[i].selectedRank == 0)
						tbodyEl.rows[i].selectedRank = i + 1;
				}

				// Sort the rows by that rank.
				for (i = 0; i < tbodyEl.rows.length - 1; i++) {

					// Start by assuming the current row has the top rank.
					topIndex = i;

					// Search the remaining rows for a better rank.
					for (j = i + 1; j < tbodyEl.rows.length; j++)
						if (tbodyEl.rows[j].selectedRank <= tbodyEl.rows[topIndex].selectedRank)
							topIndex = j;

					// By now, we have the remaining row with the best rank.
					// Remove it from the table and reinsert it before the
					// current row.
					if (topIndex > i) {
						tmpEl = tbodyEl.removeChild(tbodyEl.rows[topIndex]);
						tbodyEl.insertBefore(tmpEl, tbodyEl.rows[i]);
					}
				}

				// Set the selected value in each row and restyle the table.
				for (i = 0; i < tbodyEl.rows.length; i++) {
					if (tbodyEl.rows[i].selectEl != null)
						tbodyEl.rows[i].selectEl.value = (i + 1);
					if (i % 2 != 0)
						domUtils.addClass(tbodyEl.rows[i], "alt");
					else
						domUtils.removeClass(tbodyEl.rows[i], "alt");
				}

				return false;
			}
		}
	}();
	//]]></script>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'If the user is the Administrator, check for a user name in the request.
	'Otherwise, show data for the current user.
	dim username
	username = Session(SESSION_USERNAME_KEY)
	if IsAdmin() then
		username = Trim(Request("username"))
	end if

	'For the Administrator, build a user selection list.
	if IsAdmin() then %>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<table class="main" border="0" cellpadding="0" cellspacing="0">
		<tr class="header bottomEdge">
			<th align="left">Administrator Access</th>
		</tr>
		<tr>
			<td class="adminSection freeForm">
				<p>You may view or edit any player's team rankings by selecting a username below.</p>
				<table border="0" cellpadding="0" cellspacing="0">
					<tr valign="middle">
						<td><strong>Select user:</strong></td>
						<td>
							<select name="username">
								<% call DisplayUserSelectList(GetUserList(true), username) %>
							</select>
						</td>
						<td><input type="submit" name="submit" value="Select" class="button" /></td>
					</tr>
				</table>
			</td>
		</tr>
		</table>
	</form>
<%		if username <> "" then %>
	<h2>Team Rankings for <% = username %></h2>
<%		end if
	end if

	'Get the current week.
	dim curWeek
	curWeek = GetCurrentWeek()

	'Get the user's current team rankings.
	dim ranks, hasRanks
	dim sql, rs
	ranks = ""
	hasRanks = false
	if username <> "" then
		sql = "SELECT TeamRankings FROM Users WHERE Username = '" & SqlEscape(username) & "'"
		set rs = DbConn.Execute(sql)
		if not (rs.EOF and rs.BOF) then
			ranks = rs.Fields("TeamRankings").Value
		end if
		if not IsNull(ranks) then
			ranks = Split(ranks, ",")
			hasRanks = true
		end if
	end if

	'Create an array of team objects.
	dim teams, n
	dim i, j
	n = GetTeamCount()
	redim teams(n- 1)
	set rs = GetTeamsRecordSet()
	if not (rs.EOF and rs.BOF) then
		i = 0
		do while not rs.EOF
			set teams(i) = new TeamObj
			teams(i).setData(rs)
			i = i + 1
			rs.MoveNext
		loop
	end if

	'If there is form data, process it.
	dim needDeleteConfirmation, rankingsDeleted
	dim rank
	dim rankMissingMsg
	dim teamList, rankList
	dim temp
	needDeleteConfirmation = false
	rankingsDeleted = false

	'Process a delete request.
	if Request.Form("submit") = "Delete" then

		if LCase(Request.Form("confirmDelete")) <> "true" then
			needDeleteConfirmation = true
			call DisplayWarningMessage("To confirm deletion, check the box below and press <code>Delete</code> again. Pressing any other button will cancel the deletion.")
		else

			'Delete the player's team rankings.
			sql = "UPDATE Users SET TeamRankings = NULL WHERE Username = '" & SqlEscape(username) & "'"
			call DbConn.Execute(sql)
			rankingsDeleted = true
			hasRanks = false

			'Reload the teams.
			ranks = ""
			rs.MoveFirst
			i = 0
			do while not rs.EOF
				set teams(i) = new TeamObj
				teams(i).setData(rs)
				rs.MoveNext
				i = i + 1
			loop

			call DisplaySuccessMessage("Entry has been deleted.")
		end if

	'Process an update request.
	elseif Request.Form("submit") = "Update" then

		'Prevent entries by the Admin.
		if username = ADMIN_USERNAME then
			call DisplayErrorMessage("Error: User '" & ADMIN_USERNAME & "' may not make picks.")

		'If the user is disabled, prevent the entry.
		elseif IsDisabled() then
			call DisplayErrorMessage("Error: Your account has been disabled, changes not accepted. Please contact the Administrator.")

		'Otherwise, process the request.
		else

			'Validate the rank fields
			rankMissingMsg = "You must set a rank for each team."
			for i = 0 to UBound(teams)
				rank = Trim(Request.Form("rank-" & (i + 1)))

				'Make sure there are no missing or invalid ranks.
				if rank = "" then
					FormFieldErrors.Add "rank-" & (i + 1), rankMissingMsg
					rankMissingMsg = ""
				else
					if not IsValidInteger(rank) then
						FormFieldErrors.Add "rank-" & (i + 1), "'" & rank & "' is not a number."
					elseif CInt(rank) < 1 or CInt(rank) > UBound(teams) + 1 then
						FormFieldErrors.Add "rank" & (i + 1), "'" & rank & "' is out of range."
					end if
				end if
			next

			'Make sure the ranks for each team are unique.
			redim rankUsed(UBound(teams) + 1)
			for i = 0 to UBound(teams)
				rankUsed(i) = false
			next
			for i = 0 to UBound(teams)
				rank = Trim(Request.Form("rank-" & (i + 1)))
				if rank <> "" then
					if rankUsed(rank) then
						FormFieldErrors.Add "rank-" & (i + 1), "'" & rank & "' is already assigned to a different team."
					else
						rankUsed(rank) = true
					end if
				end if
			next

		end if

		'If there were any errors, display the error messages. Otherwise, do
		'the updates.
		if FormFieldErrors.Count > 0 then
			call DisplayFormFieldErrorsMessage("Error: Invalid fields. Please correct and resubmit.")
		else

			'Get the team IDs and ranks.
			redim teamList(UBound(teams))
			redim rankList(UBound(teams))
			for i = 0 to UBound(teams)
				teamList(i) = Trim(Request.Form("id-"   & (i + 1)))
				rankList(i) = Trim(Request.Form("rank-" & (i + 1)))
			next

			'Sort them.
			for i = 0 to UBound(teams) - 1
				for j = i + 1 to UBound(teams)
					if CInt(rankList(i)) > CInt(rankList(j)) then
						temp = rankList(i)
						rankList(i) = rankList(j)
						rankList(j) = temp
						temp = teamList(i)
						teamList(i) = teamList(j)
						teamList(j) = temp
					end if
				next
			next

			'Reset ranks.
			ranks = teamList

			'Create the list.
			teamList = Join(teamList, ",")

			'Update the user's rankings.
			sql = "UPDATE Users SET TeamRankings = '" & teamList & "' WHERE Username ='" & SqlEscape(username) & "'"
			call DbConn.Execute(sql)

			'Reload the teams.
			rs.MoveFirst
			i = 0
			do while not rs.EOF
				set teams(i) = new TeamObj
				teams(i).setData(rs)
				rs.MoveNext
				i = i + 1
			loop

			'Updates complete, give a message.
			call DisplaySuccessMessage("Team rankings updated.")
		end if
	end if

	'Sort teams by the user's rankings, if any.
	for i = 0 to UBound(teams) - 1
		for j = i + 1 to UBound(teams)
			if teams(i).rank > teams(j).rank then
				set temp = teams(i)
				set teams(i) = teams(j)
				set teams(j) = temp
			end if
		next
	next

	'Build the display.
	if username <> "" then
		dim alt %>
	<form id="teamRankingsForm" action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
<%		if IsAdmin() then %>
		<div>
			<input type="hidden" name="username" value="<% = username %>" />
		</div>
<%		end if %>
		<table border="0" cellpadding="0" cellspacing="0"><tr><td style="padding: 0px;">
		<table class="main" border="0" cellpadding="0" cellspacing="0">
			<thead>
				<tr class="header bottomEdge" valign="bottom">
					<th align="left" colspan="2">Edit Your Team Rankings</th>
				</tr>
			</thead>
			<tbody id="teamRankings">
<%		alt = false
		for i = 0 to UBound(teams)
			if alt then %>
				<tr class="alt singleLine">
<%			else %>
				<tr class="singleLine">
<%			end if
			alt = not alt %>
					<td style="width: 28em;"><input type="hidden" name="id-<% = (i + 1) %>" value="<% = teams(i).id %>" /><% call DisplayTeamLogo(teams(i).id) %><% = teams(i).name %><% call DisplayTeamRecord(teams(i).id, curWeek, USE_POINT_SPREADS) %></td>
					<td align="right">
						<select name="rank-<% = (i + 1) %>" class="<% = StyleFormField("numeric", "rank-" & (i + 1)) %>" onchange="this.blur(); autoSort.sort();">
							<option value=""></option>
<%				if rankingsDeleted then
					rank = ""
				elseif FormFieldErrors.Exists("rank-" & (i + 1)) then
					rank = Request.Form("rank-" & (i + 1))
				else
					rank = teams(i).rank
				end if
				for j = 1 to UBound(teams) + 1 %>
							<option value="<% = j %>"<% if CStr(rank) = CStr(j) then Response.Write(" selected=""selected""") end if %>><% if j < 10 then Response.Write ("&nbsp;&nbsp;#" & j) else Response.Write("#" & j) end if %></option>
<%				next %>
						</select>
					</td>
				</tr>
<%		next %>
			</tbody>
		</table>
		<p></p>
		<table border="0" cellpadding="0" cellspacing="0" style="width: 100%;">
			<tr valign="middle">
				<td style="padding: 0px;"><input type="submit" name="submit" value="Update" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></td>
<%		'If the player currently has rankings, add a delete button
		if hasRanks then

			'If delete was requested, add a confirmation checkbox.
			if needDeleteConfirmation then %>
				<td align="right" style="padding: 0px;"><input type="checkbox" id="confirmDelete" name="confirmDelete" value="true" /> <label for="confirmDelete">Confirm Deletion</label>&nbsp;</td>
<%			end if %>
				<td align="right" style="padding: 0px;"><input type="submit" name="submit" value="Delete" class="button" /></td>
<%		end if %>
			</tr>
		</table>
		</td></tr></table>
	</form>
<%	end if %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************
	'--------------------------------------------------------------------------
	' TeamObj: Holds information for a single team.
	'--------------------------------------------------------------------------
	class TeamObj

		public id, name, rank

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(rs)

			'Initialize properties.
			id   = rs.Fields("TeamID").Value
			name = rs.Fields("City").Value & " " & rs.Fields("Name").Value
			rank = ""

			'Find the team's current rank.
			dim i
			if IsArray(ranks) then
				for i = 0 to Ubound(ranks)
					if ranks(i) = id then
						rank = i + 1
						exit for
					end if
				next
			end if

		end sub

	end class %>
