<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Pool Rules"
	call BuildPageHeader("", "") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
	<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
		<tr class="header bottomEdge">
			<th align="left">Help</th>
		</tr>
		<tr>
			<td class="freeForm">
				<h1>Pool Rules</h1>

				<h2>Weekly Pool</h2>

				<p>Each week constitutes a new pool.
				You may play as many or as few weeks as you like but you are allowed only one entry per week.
				Each entry costs <% = FormatAmount(WEEKLY_ENTRY_FEE) %> which goes into the pot paid to that week's winner(s).
<%	if ENABLE_OVERALL_WEEKLY then %>
				<em>Note, however, that <% = (100 * OVERALL_WEEKLY_SHARE) & "%" %> of each week's pot is reserved for an overall award given at the end of the regular season.</em>
<%	end if %>
				</p>

				<p>To enter, fill in the entry form by making your pick for each game.
				The goal is to pick the winning
<%	if USE_POINT_SPREADS then %>
				team, based on the point spread (see below).</p>
<%	else %>
				team.</p>
<%		if SHOW_POINT_SPREADS then %>
				<p><em>Note that points spreads are shown for informational purposes only.
				You want to pick the team that will actually win the game, not who will beat or cover the spread.</em></p>
<%		end if
	end if
	if ALLOW_TIE_PICKS then %>
				You can also pick a game to end it a tie.
<%		if not USE_POINT_SPREADS then %>
				However, tie games are relatively rare in the NFL.
<%		end if
	end if %>
				</p>

				<p>You will also be asked to guess the total points scored in the Monday Night Football game (or whatever the last scheduled game of that week is).
				This will be used as a tiebreaker.</p>

				<p>The winner for each week will be the player with the highest score.
				In the event of a tie, the player who guessed closest to the actual point total of the tiebreaker game will win.
				Should any players still be tied after applying the tiebreaker, the pot will be divided equally among those players.</p>

				<p><em>For the tiebreaker, it does not matter if your point total is over or under the actual score total.
				It is only the difference that counts.</em></p>

				<h3>Scoring</h3>
<%	if USE_CONFIDENCE_POINTS then %>
				<p>When making an entry, you must assign confidence points to each game.
				The point values range from one to however many games there are that week and you may use each number only once.
				You should assign the highest point values to the picks you are most confident about.</p>

				<p>Your score will be the total of the confidence points assigned to each correctly picked game.</p>
<%	else %>
				<p>Your score is simply the number of games you correctly picked.</p>
<%	end if
	if not ALLOW_TIE_PICKS then %>
				<p><em>In the event a game ends in a tie, you will receive
<%		if USE_CONFIDENCE_POINTS then %>
				half of your assigned confidence points
<%		else %>
				half a point
<%		end if %>
				for that game, provided you made a pick for it.
				</em></p>
<%	end if
	if USE_POINT_SPREADS then %>
				<h3>Point Spreads</h3>

				<p>You must consider the point spread for games when making picks.
				The Administrator will set the point spread for each game every week.
				Check with him or her to find out when you can expect these to be available.</p>

				<p>The point spread is also refered to as the line.
				On the entry form you'll see this next to the visiting team.
				If the line as not been set for a game, it will be displayed as "n/l" (no line).</p>

				<p>The value shown always applies to the <em>visiting team.</em>
				A negative point spread means that the visitors are favored by that many points, a positive spread means that the visitors are the underdog.
				If the point spread shows "even" it means that neither team is favored.</p>

				<p>You want to pick the team that will win "against the spread."
				For example, if a team is favored by 6 points, they must win by 7 points (or more) to be considered the winner.
				As another example, say a team is a 3&frac12; point underdog but they lose by only 3 points, they would considered the winner.</p>

				<p>To put it another way, when determining the outcome of the game, the point spread is added to the visiting team's score and then compared to the home team's score.</p>
<%	end if %>
				<h3>Making and Changing Weekly Entries</h3>

				<p>When filling in an entry form, you do not have to make a pick for each game.
				All that is required is that you enter a point total for the tiebreaker.
				This is helpful if there are early games scheduled for a given week (games played on a Thursday, Friday or Saturday).
				You may make your picks for these games beforehand and complete the rest later.</p>
<%	if USE_CONFIDENCE_POINTS then %>
				<p>Note that when you make a pick, you must also assign a confidence point value to it as well.
				Valid point values are 1, 2, 3 and so on, up to the number of games scheduled that week.
				Remember that each number can only be used once.</p>
<%	end if %>
				<h3>Locked Games</h3>

				<p>Games are automatically locked out on the entry form according to their scheduled date and time.
				Early games are locked at the start of the individual game.
				All remaining games (including any Monday night games) are locked at the scheduled start time of the first <em>Sunday</em> game.</p>

				<p><em>Times displayed on the schedule are Eastern.</em></p>

				<p>You may change your pick for any game up until the time that game is locked.
<%	if USE_CONFIDENCE_POINTS then %>
				This includes changing your confidence points.
<%	end if %>
				You may also change your tiebreaker point total up until the time that all entries are locked on <em>Sunday</em>.</p>

				<p>You can delete your entry, if desired, provided no games for that week have been locked.</p>

				<p>Entries must be completed on time.
				Once a game is locked, you may not change your pick for it.
				If you did not make a pick for a particular game, it is counted as a loss.
				If you submit a partial entry and either forget or are unable to complete it, you are still responsible for the entry fee.</p>

				<p><em>The Administrator may make exceptions for extenuating circumstances on an individual basis.
				By participating you agree to abide by the above rules and accept any decisions made by the Administrator.</em></p>

				<p>If you have trouble accessing the site, logging in or otherwise completing your entry, please contact the <a href="mailto:<% = ADMIN_EMAIL %>">Administrator</a> for help.</p>
<%	if ENABLE_QUICK_PICKS then %>
				<h3>Quick Picks</h3>

				<p>This feature let's you quickly fill in your weekly entry using one of these options to make a pick in each game:</p>
				<ul>
					<li><strong>All Away</strong> picks all the visiting teams.</li>
					<li><strong>All Home</strong> picks all the home teams.</li>
<%		if USE_POINT_SPREADS or SHOW_POINT_SPREADS then %>
					<li><strong>All Favorites</strong> picks all the favored teams based on the point spread shown.</li>
					<li><strong>All Underdogs</strong> picks all the underdog teams.</li>
<%		end if %>
					<li><strong>By Rank</strong> picks teams based on your personal team rankings.
					Note that this option is only available after you have set your personal team rankings (see below).</li>
					<li><strong>Random</strong> picks teams at random.</li>
					<li><strong>Clear</strong> unchecks all picks.</li>
				</ul>
<%		if USE_CONFIDENCE_POINTS then %>
				<p>You can also quickly assign confidence points using one of these options:</p>
				<ul>
<%			if USE_POINT_SPREADS or SHOW_POINT_SPREADS then %>
					<li><strong>By Spread</strong> assigns points based on the point spread for your pick.
					Higher points are assigned to the more heavily favored picks, lower points go to the less favored picks.</li>
<%			end if %>
					<li><strong>By Rank</strong> assigns points based on the relative difference in your ranking between your pick and the opposing team.
					Again, you must first set your personal team rankings (see below) in order to use this option.</li>
					<li><strong>Random</strong> assigns points at random.</li>
					<li><strong>Clear</strong> clears all confidence point assignments.</li>
				</ul>
<%		end if %>
				<p>By default, quick picks are applied to all unlocked games, overwriting any current selections.
				You can prevent this for specific games by checking the <strong>Keep</strong> box next to the game.
				Unchecking the box will again allow the game to be updated with a quick pick.</p>
<%		if IsAdmin() then %>
				<p class="adminSection">When the Administrator updates an entry on behalf of a player, locked games can be overwritten as well.
				For convenience, locked games with an existing selection are initially checked to prevent accidental overwriting.
				They may be unchecked if desired.</p>
<%		end if %>
				<p>You can use any combination of quick picks and manual selections prior to submitting your entry.
				Remember to also enter a tiebreak point total.</p>

				<h4>Editing Your Team Rankings</h4>

				<p>Use the edit team rankings form to set your personal team rankings.
				To assign a rank to a team, select the desired rank from the drop down list (#1 being the team you consider the best, #2 the second-best and so on).
				The display will automatically update to show the new order.</p>

				<p>When you are satisfied with your rankings, press the <code>Update</code> button to save your data.
				You can then use these rankings make quick picks on the weekly entry form.</p>
<%	end if
	if ENABLE_OVERALL_WEEKLY then %>
				<h3>Overall Award</h3>

				<p>After all weekly pools are concluded,
<%		if USE_CONFIDENCE_POINTS then %>
				two overall awards will be given.
				One to the player with the most points scored over the regular season and the other to
<%		else %>
				the overall award will be given to
<%		end if %>
				the player who made the most correct picks over the entire regular season.</p>

				<p>Note that it is
<%		if USE_CONFIDENCE_POINTS then %>
				the total points scored and 
<%		end if %>
				the total number of correct picks that counts, not the percentage.
				This is done to favor players who play more rather than ones who score well but only play a few weeks.</p>

				<p>The size of the overall award will depend on the total number of weekly entries made.
<%		if USE_CONFIDENCE_POINTS then %>
				<% = (100 * OVERALL_CONFIDENCE_WEEKLY_SHARE) & "%" %> of this goes to the total points winner while the remainder goes to the correct picks winner.
				If there is a tie between two or more players in either category, that award will be split equally among them.
<%		else %>
				If there is a tie between two or more players, the award will be split equally among them.
<%		end if %>
				</p>
<%	end if
	if ENABLE_SURVIVOR_POOL or ENABLE_MARGIN_POOL then %>
				<h2><% = SidePoolTitle %> Pool</h2>
				<p>This pool is separate from the weekly picks pool.
				<em>If you choose to participate, you must enter during the first week (or whichever week the Administrator has chosen to start the pool).</em>
				The entry fee is <% = FormatAmount(SIDE_ENTRY_FEE) %>.</p>

<%		if IsAdmin() then %>
				<p class="adminSection">As the Administrator, you can allow a player to join the pool late.
				To do so, you'll need to make an entry for that player for the first week.
				How you choose the pick for that entry is up to you.</p>
<%		end if %>
				<p>The pool runs over the entire regular season.
				Each week, you must pick one team among those playing that you think will win its game.
				You can use each team only once.</p>
<%			if USE_POINT_SPREADS then %>
				<p>Note that point spreads are not used in this pool.
				You want to pick teams to win straight up.</p>
<%			end if %>

<%		if ENABLE_SURVIVOR_POOL then
			if ENABLE_MARGIN_POOL then %>
				<p>This pool is actually a combination of two similar yet distinct pool formats described below.
				<em>You make only one pick each week, that pick applies to both the survivor pool and the margin pool.</em></p>

				<h3>Survivor Pool</h3>
<%			end if %>
				<p>The goal of the survivor pool is to outlast your fellow players.
				If your team wins, you survive and continue on to the next week.
				If your team loses,
<%			if SURVIVOR_STRIKE_OUT > 1 then %>
				it counts as a miss.
				Miss <% = Number2Text(SURVIVOR_STRIKE_OUT) %> games and
<%			end if %>
				you are eliminated.</p>

				<p>Note that if you do not make a pick for a given week, it
				counts as a loss.
				If the game ends in a tie, it is considered a
<%			if SURVIVOR_STRIKE_ON_TIE then %>
				loss.
<%			else %>
				win.
<%			end if %>
				In the event all active players are eliminated in a single week, those players will be reinstated and continue to the next week.</p>

				<p>When only one player remains, he or she wins the pot.
				If more than one player survives to the end of the regular season,
<%			if SURVIVOR_STRIKE_OUT > 1 then %>
				the number of correct picks will be used as a tiebreaker.
				Should two or more players still be tied,
<%			end if %>
				 they will split the pot equally.</p>
<%			if SURVIVOR_BUYBACK_LIMIT > 0 then %>
				<h4>Buybacks</h4>

				<p>If you are eliminated from the survivor pool, you have the option to buyback in for a fee.
				You are allowed
<%				if SURVIVOR_BUYBACK_LIMIT = 1 then %>
				one buyback which costs <% = FormatAmount(SURVIVOR_BUYBACK_FEE) %>.
<%				else %>
				up to <% = Number2Text(SURVIVOR_BUYBACK_LIMIT) %> buybacks during the course of the season.
				Each buyback will cost you <% = FormatAmount(SURVIVOR_BUYBACK_FEE) %>.
<%				end if %>
				If you choose to use a buyback, you must do so the week following your elimination.
<%				if SURVIVOR_MAX_BUYBACK_WEEK > 0 then %>
				No buybacks are permitted after Week <% = SURVIVOR_MAX_BUYBACK_WEEK %>.
<%				end if %>
				All buyback fees go into the survivor pool pot.</p>

				<p>Keep in mind that the tiebreaker for the survivor pool is the number of correct picks.
				If, for example, you and one other player both survive the entire season but you used a buyback while the other player did not, that player would win by virtue of having made more correct picks.
				Also note that buybacks cannot be used after the pool has been won.</p>
<%			end if
		end if %>
<%		if ENABLE_MARGIN_POOL then
			if ENABLE_SURVIVOR_POOL then %>
				<h3>Margin Pool</h3>
<%			end if %>
				<p>The goal of the margin pool is to pick the team you think will win it's game by the greatest scoring margin.
				If your team wins, the point difference is added to your total.
				If your team loses,
<%			if MARGIN_DEDUCT_LOSS then %>
				the point difference is subtracted from your total.
<%			else %>
				you get no points for that week.
<%			end if %>
				</p>
				<p>If you do not make a pick for a given week, it counts as a
<%			if MARGIN_DEDUCT_LOSS then %>
				loss and your point total will be deducted using the greatest losing margin among all games for that week.
<%				else %>
				loss.
<%			end if %>
				</p>

				<p>Whichever player scores the most points at the end of the regular season wins the pool.
				In the event of a tie, the number of correct picks will be used as a tiebreaker.
				Should two or more players still be tied, those players will split the pot equally.</p>
<%		end if %>
<%		if ENABLE_SURVIVOR_POOL and ENABLE_MARGIN_POOL then %>
				<h3>Additional Notes</h3>

				<p>Even if you are eliminated from the survivor pool, no one is ever eliminated from the margin pool so don't forget to make a pick each week.</p>

				<p>The pot will be distributed between the two pools as follows: <% = (100 * SIDE_SURVIVOR_SHARE) & "%" %> will be awarded to the winner(s) of the survivor pool while the remainder will be awarded to the winner(s) of the margin pool.</p>
<%		end if %>
				
				<h3>Making and Changing <% = SidePoolTitle %> Picks</h3>

				<p>As with the weekly pool, you may make or change your pick for the <% = LCase(SidePoolTitle) %> pool up until all games for that particular week are locked.
				If you pick a team playing an early game, you cannot change that pick once that game is locked.
				Likewise, you cannot pick a team whose game has been locked.</p>

				<p>You can make your picks in advance for upcoming weeks.
				Note, however, that when you make a pick, that team is no longer available for use in other weeks.
				So if you later decide you want to use that team in a different week, you'll first need to change or delete the existing entry for it.</p>
<%	end if
	if PlayoffsPoolsCount > 0 then %>
				<h2><% = PlayoffsPoolsHeader %></h2>
<%		if ENABLE_PLAYOFFS_PICK_POOL then
			if PlayoffsPoolsCount > 1 then %>
				<h3><% = PlayoffsPickPoolPrefix %>Pool</h3>
<%			end if %>
				<p>This pool works similar to a weekly pool
<%		if USE_CONFIDENCE_POINTS or USE_POINT_SPREADS then %>
				(including the use of
<%			if USE_CONFIDENCE_POINTS and USE_POINT_SPREADS then %>
				confidence points and point spreads)
<%			elseif USE_CONFIDENCE_POINTS then %>
				confidence points)
<%			elseif USE_POINT_SPREADS then %>
				point spreads)
<%			end if
		end if %>
				with some minor differences.
				All the postseason games are included.
				Scoring is the same as in a weekly pool except that there is no tiebreaker.
				Players who tie for the winning score will split the pot equally.
				If you choose to participate, the entry fee is <% = FormatAmount(PLAYOFFS_PICK_ENTRY_FEE) %>.</p>

				<p>Entries are broken up into individual playoff rounds:</p>

				<ul>
					<li>Wild Card Games (four games)</li>
					<li>Divisional Playoffs (four games)</li>
					<li>Conference Championships (two games)</li>
					<li>Super Bowl</li>
				</ul>

				<p>Once the Administrator has set the opposing teams for each game in a round, you can make your picks for those games.
				As with the weekly pools, you can make or change any pick until those games are locked.</p>

				<p><em>All games for a given round are locked at the start time of the first game in that round.</em></p>

				<p>After all games in the current round have been decided, the Administrator will set the games for the next round.
				You must then go back to the entry form and make your picks for them.</p>
<%		end if
		if ENABLE_PLAYOFFS_RANK_POOL then
			if PlayoffsPoolsCount > 1 then %>
				<h3><% = PlayoffsRankPoolPrefix %>Pool</h3>
<%			end if %>
				<p>In this pool you rank each playoff team using confidence points, before any of the playoff games start.
				Confidence points range from one to the number of playoff teams.
				Each team must be assigned a value and you may use each value only once.</p>

				<p>For every game a given team wins, the points you assigned to that team are added to your total score.
				So you want to assign the highest point values to the teams you think will go the farthest in the playoffs.</p>
<%			if USE_POINT_SPREADS then %>
				<p>Note that point spreads are not considered in this pool.
				You get points for a team only when it wins straight up.</p>
<%			end if %>

				<p>After all games have been completed, the player who has the highest score wins.
				If there is a tie for the top score, the pot will be split equally among the tied players.</p>
				<p>If you choose to participate, the entry fee is <% = FormatAmount(PLAYOFFS_RANK_ENTRY_FEE) %>.
				<em>Entries for this pool must be completed before the scheduled start time of the first playoff game.</em></p>
<%		end if
		if ENABLE_SUPER_BOWL_POOL then
			if PlayoffsPoolsCount > 1  then %>
				<h3>Super Bowl Pool</h3>
<%			end if %>
				<p>In the Super Bowl pool, you are given a series of questions in the form of <em>which team will:</em></p>

					<ul>
						<li>Score the first touchdown,</li>
						<li>Commit the first turnover,</li>
						<li>Score the most points in the 1<sup>st</sup> quarter,</li>
						<li>Gain the most rushing yards,</li>
						<li>Complete the longest pass play,</li>
						<li>...and so on.</li>
					</ul>

					<p>You must pick one of the opposing teams in each instance.
					If the teams tie in a category, no point is awarded.
					The player who gets the most correct wins.
					In the event of a tie for the win, the pot will be split equally among the tied players.</p>

					<p>If you play, the entry fee is <% = FormatAmount(SUPER_BOWL_ENTRY_FEE) %>
					<em>Entries for this pool must be completed before the scheduled start time of the game.</em></p>

<%		end if
		if IsAdmin() then %>
				<p class="adminSection">As the Administrator, you will need to
<%			if ENABLE_PLAYOFFS_RANK_POOL then %>
				set the playoffs teams, 
<%			end if %>
				 update the playoffs schedule and enter the game scores in order to run
<%			if PlayoffsPoolsCount > 1 then %>
				 these pools.
<%			else %>
				the pool.
<%			end if %>
				</p>
<%		end if
	end if %>
			<p>To make picks, view results and find additional information, see the <a href="helpSiteMap.asp">site map</a>.</p>
			</td>
		</tr>
	</table>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions.                                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Formats a number as a word, if appropriate.
	'--------------------------------------------------------------------------
	function Number2Text(n)

		dim text

		Number2Text = n
		text = Array("zero", "one", "two", "three", "four", "five", "six", _
		             "seven", "eight", "nine", "ten")
		if n < UBound(text) then
			Number2Text = text(n)
		end if

	end function %>