<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Site Map"
	call BuildPageHeader("", "") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
	<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
		<tr class="header bottomEdge">
			<th align="left">Help</th>
		</tr>
		<tr>
			<td class="freeForm">
				<h1>Site Map</h1>

				<p><em>You must be logged in to access most pages.</em></p>

				<p>Note that on many pages, such results and statistics pages, the displays are sortable.
				You can sort a particular field by clicking on the column header.
				Clicking on the same column header again to reverse the sort order.</p>

				<p><a href="default.asp">Home</a><br />
				This is the first page displayed after you log in.
				Check here for news, announcements and updates regarding the pool.</p>
<%	if ENABLE_MESSAGE_BOARD then %>
				<p><a href="messageBoard.asp">Message Board</a><br />
				Do some trash talking, speculate on which team will win the Super Bowl or just share your thoughts with your fellow players.
				You can always edit or remove your posts if you say something you later regret.</p>

				<p>Note that the Administrator reserves the right to remove any posts deemed inappropriate, so please play nice.
<%		if MAX_POST_COUNT > 0 or MAX_POST_AGE > 0 then %>
				Also note that old posts may be removed periodically to save space.
<%		end if %>
				</p>
<%	end if %>
				<h2>Weekly Pool</h2>

				<p><a href="weeklyEntry.asp">Entry Form</a><br />
				Make or edit your picks for the current week.
				You can also make picks in advance for upcoming weeks using the links provided.
				See the <a href="helpRules.asp">pool rules</a> for details on entering picks.</p>
<%	if IsAdmin() then %>
				<p class="adminSection">As the Administrator, you can use this form to edit any player's picks, even for games that have been locked.
				You can also delete entries as long as the week has not been concluded.</p>
<%	end if %>
				<p><a href="weeklyResults.asp">Results</a><br />
				This page shows each player's picks, tiebreaker and score for a given week.
<%	if HIDE_OTHERS_PICKS then %>
				Note that picks made by other players are hidden from view until those games are locked.
				The Administrator may view all picks, however, regardless of their lock status.
<%	end if %>
				</p>

				<p>Game scores are updated by the Administrator, who should have them entered by late Monday night or early Tuesday morning of each week.
				Results for each week's pool are generated automatically so once all the scores are in, the winner(s) will be shown here.</p>

				<p><a href="weeklySummary.asp">Summary</a><br />
				Here you will find a list of the winners for each week's pool.
				Click on a week number to view the results page for that individual week.</p>

				<p>You can also find statistics showing each player's overall performance in the weekly pool.
<%	if ENABLE_OVERALL_WEEKLY then %>
				Once the regular season is complete, this page will also show the
<%		if USE_CONFIDENCE_POINTS then %>
				winners of the overall awards.
<%		else %>
				winner of the overall award.
<%		end if
	end if %>
				</p>

				<p><a href="weeklyScoringCharts.asp">Scoring Charts</a><br />
				Here you'll find a graphical view of the pick
<%	if USE_CONFIDENCE_POINTS then %>
				and confidence point
<%	else %>
<%	end if %>
				scores for all players in each of the weekly pools.
				You can also select an individual player to see how they ranked against the others.</p>

				<p><a href="topWeeklyScores.asp">Top Scores</a><br />
				Lists the current top scores
<%	if USE_CONFIDENCE_POINTS then %>
				(by correct picks and confidence point score)
<%	end if %>
				for the weekly pools.</p>

				<p><a href="weeklyPickStatistics.asp">Pick Statistics</a><br />
				On this page you can find cumulative pick statistics for each team over the weeks played so far.
				This includes how often a team was picked to win or lose and the overall results of those picks.
<%	if USE_CONFIDENCE_POINTS then %>
				Similar data is provided for confidence point assignments.
<%	end if %>
				The data includes all players picks but can be filtered to show information for an individual player.</p>
<%	if USE_POINT_SPREADS or SHOW_POINT_SPREADS then %>
				<p><a href="weeklySpreadStatistics.asp">Point Spread Statistics</a><br />
				Here you can find a summary of the weekly point spread assigned to each team.
				It also shows the combined record of favored teams both straight up and against the spread.</p>
<%	end if
	if ENABLE_SURVIVOR_POOL or ENABLE_MARGIN_POOL then %>
				<h2><% = SidePoolTitle %> Pool</h2>

				<p><a href="sideEntry.asp">Entry Form</a><br />
				Make or edit your pick for the <% = LCase(SidePoolTitle) %> pool.
				You can also make picks in advance for upcoming weeks using the links provided.
				See <a href="helpRules.asp">pool rules</a> for details on entering picks.</p>
<%		if IsAdmin() then %>
				<p class="adminSection">As the Administrator, you can use this form to edit/delete any player's <% = LCase(SidePoolTitle) %> pool picks, just like the weekly pool entries.</p>
<%		end if %>
				<p><a href="sideStandings.asp">Standings</a><br />
				Here you can find the current standings of all players in the <% = LCase(SidePoolTitle) %> pool.
<%		if ENABLE_SURVIVOR_POOL and ENABLE_MARGIN_POOL then %>
				When either of these pools
<%		else %>
				Once the pool
<%		end if %>
				is concluded, the winner(s) will be listed as well.</p>
<%	end if
	if ENABLE_MARGIN_POOL then %>
				<p><a href="marginStatistics.asp">Margin Statistics</a><br />
				This page shows the scoring margin for every game in the weekly schedule, listed from highest to lowest.
				You can select an individual player to highlight that player's pick in all completed games.</p>

				<p>The page also lists scoring information for each team, including their best and worst scoring margins, average win and loss margin and overall points scored/allowed data.</p>
<%	end if
	if ENABLE_SURVIVOR_POOL then %>
				<p><a href="survivorStatistics.asp">Survivor Statistics</a><br />
				On this page you can see how players picked each individual team week by week along with the results of those picks.
				It also provides a weekly player status summary.</p>
<%	end if
	if PlayoffsPoolsCount > 0 then %>
				<h1><% = PlayoffsPoolsHeader %></h1>
<%		if ENABLE_PLAYOFFS_PICK_POOL then
			if PlayoffsPoolsCount > 1 then %>
				<h3><% = PlayoffsPickPoolPrefix %>Pool</h3>
<%			end if %>
				<p><a href="playoffsPickEntry.asp"><% = PlayoffsPickPoolPrefix %>Entry Form</a><br />
				Make or edit your picks for the <% = LCase(PlayoffsPickPoolTitle) %> pool.
				Note that you will not be able to make pick a game until the Administrator has updated the playoffs schedule.</p>
<%			if IsAdmin() then %>
				<p class="adminSection">As the Administrator, you can use this form to edit/delete any player's entry.</p>
<%			end if %>
				<p><a href="playoffsPickResults.asp"><% = PlayoffsPickPoolPrefix %>Results</a><br />
				Shows each player's picks and score for the <% = LCase(PlayoffsPickPoolTitle) %> pool.</p>
<%		end if
		if ENABLE_PLAYOFFS_RANK_POOL then
			if PlayoffsPoolsCount > 1 then %>
				<h3><% = PlayoffsRankPoolPrefix %>Pool</h3>
<%			end if %>
				<p><a href="playoffsRankEntry.asp"><% = PlayoffsRankPoolPrefix %>Entry Form</a><br />
				Make or edit your confidence point assignments to each playoff team for the <% = LCase(PlayoffsRankPoolTitle) %> pool.
				Note that you will not be able to enter until the Administrator has set the playoffs teams.</p>
<%			if IsAdmin() then %>
				<p class="adminSection">As the Administrator, you can use this form to edit/delete any player's entry.</p>
<%			end if %>
				<p><a href="playoffsPickResults.asp"><% = PlayoffsRankPoolPrefix %>Results</a><br />
				Shows each player's rankings and score for the <% = LCase(PlayoffsRankPoolTitle) %> pool.</p>
<%		end if
		if ENABLE_SUPER_BOWL_POOL then
			if PlayoffsPoolsCount > 1 then %>
				<h3><% = SuperBowlPoolPrefix %>Pool</h3>
<%			end if %>
				<p><a href="wuperBowlEntry.asp"><% = SuperBowlPoolPrefix %>Entry Form</a><br />
				Make or edit your picks for the Super Bowl pool.
				Note that you will not be able to make any picks until the Administrator has set the Super Bowl teams and propositions.</p>
<%			if IsAdmin() then %>
				<p class="adminSection">As the Administrator, you can use this form to edit/delete any player's entry.</p>
<%			end if %>
				<p><a href="playoffsPickResults.asp"><% = SuperBowlPoolPrefix %>Results</a><br />
				Shows each player's score for the Super Bowl pool.</p>
<%		end if
	end if %>
				<h2>Schedules</h2>

				<p><a href="weeklySchedule.asp">Weekly Schedule</a><br />
				This page let's you view the schedule week-by-week.
				By default the current week will be displayed but you can jump to any week using the links at the bottom of the page.
				The display includes scores when available.</p>

				<p><a href="teamSchedules.asp">Team Schedules</a><br />
				You can view any team's schedule here by selecting its name from the drop-down list.
				Again, scores are displayed when available.</p>

<%	if PlayoffsPoolsCount > 1 then %>
				<p><a href="playoffsSchedule.asp">Playoffs Schedule</a><br />
				Here you can view the schedule and scores for the playoff games.</p>
<%	end if %>
				<p><a href="standings.asp">Standings</a><br />
				This page displays the current standings for all NFL teams.
				From here you can click on a team name to view its schedule.</p>

				<h2>My Account</h2>

				<p><a href="accountSummary.asp">Account Summary</a><br />
				Here you'll find a list of all credits and debits on your account along with your current balance (note that Eastern Time is used when logging the date and time of transactions).
				You'll also find a summary of any pool winnings you've earned.</p>

				<p>Entry fees for each pool are automatically charged to your account once the pool starts.
				Any payments you've made should be recorded by the Administrator when received.</p>

				<p>Winnings are to be paid out in full each week, so they are not automatically credited to your account.
				However, if you have an any outstanding debt, the Administrator may first deduct the appropriate amount from your winnings and record it as a payment.</p>

				<p>You can also make arrangements with the Administrator to have all or part of any winnings credited to your account if you wish to pay in advance for upcoming weeks.</p>

				<p>If you find any discrepancies on your account, please report them to the <a href="mailto:<% = ADMIN_EMAIL %>">Administrator</a> as soon as possible.</p>
<%	if IsAdmin() then %>
				<p class="adminSection">As the Administrator, you can use this page to view any player's account summary.</p>
<%	end if
	if ENABLE_PAYPAL_ADDON then %>
				<p><a href="makePayment.asp">Make Payment</a><br />
				Here you can find how to make a payment including online payments via <a href="http://www.paypal.com">PayPal</a>.</p>
<%	end if
	if ENABLE_QUICK_PICKS then %>
				<p><a href="editTeamRankings.asp">Edit Team Rankings</a><br />
				Use this page to set your personal team rankings.
				These rankings can be used on the weekly entry form to quickly pick
<%		if USE_CONFIDENCE_POINTS then %>
				games and/or assign confidence points.
<%		else %>
				games.
<%		end if %>
				You can edit or delete your rankings at any time.</p>
<%		if IsAdmin() then %>
				<p class="adminSection">As the Administrator, you can use this page to edit any player's team rankings.</p>
<%		end if
	end if %>
				<p><a href="changePassword.asp">Change Password</a><br />
				You can use this form to change your password.
				If you've forgotten your password, contact the <a href="mailto:<% = ADMIN_EMAIL %>">Administrator</a> and you will be issued a new one.</p>

				<p><a href="editProfile.asp">Edit Profile</a><br />
				This page allows you to update your personal information.
				For your protection, the data is encrypted and can only be viewed by you and the Administrator.</p>

				<p>It is intended to allow the Administrator to contact you.
				For example, if you want your pool winnings paid by check, provide your full name and mailing address in your contact information.</p>
<%	if SERVER_EMAIL_ENABLED then %>
				<p>You can also choose to receive email notifications for different events, such as news announcements, scheduling changes, game updates, etc.</p>
<%	end if
	if ENABLE_TEAM_THEMES then %>
				<p>Finally, you can personalize the look of the site based on your favorite team.</p>
<%	end if
	if IsAdmin() then %>
				<p class="adminSection">
				As the Administrator, you can use this page to view or edit any player's profile.
				You can also disable a player here.
				Disabled players cannot make or change pool entries, but may delete an open entry provided that none of the games have been locked.
<%		if ENABLE_MESSAGE_BOARD then %>
				Likewise, they are not permitted to add or edit posts on the message board, but may remove any of their existing posts.
<%		end if %>
				</p>
<%	end if %>
				<p><a href="userLogout.asp">Login/Logout</a><br />
				Login here with your username and password.
				If you're having trouble logging in, contact the <a href="mailto:<% = ADMIN_EMAIL %>">Administrator</a>.</p>

				<p>If you are inactive for several minutes, your session may timeout.
				When this happens, the next time you try to access a page you will automatically be sent back to the login page.
				Just sign in again and you may then continue with whatever you were doing.</p>

				<p>For information on how to play, see the <a href="helpRules.asp">pool rules</a>.</p>
			</td>
		</tr>
	</table>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
