<%	'**************************************************************************
	'* ASP Football Pool                                                      *
	'* Version 4.0                                                            *
	'*                                                                        *
	'* Do not remove this notice.                                             *
	'*                                                                        *
	'* Copyright 1999-2010 by Mike Hall.                                      *
	'* Distributed under the terms of the GNU General Public License.         *
	'* Please see http://www.brainjar.com for more information.               *
	'**************************************************************************

	'**************************************************************************
	'* Configuration code.                                                    *
	'*                                                                        *
	'* Set these options to suit your particular installation, enable the     *
	'* features you want and define your pool format(s). See the readMe.html  *
	'* file for more information on each setting.                             *
	'*                                                                        *
	'* This file should be included at the beginning of every page.           *
	'**************************************************************************

	'This code must run first.
	option explicit
	Response.Buffer = true

	'--------------------------------------------------------------------------
	' Site settings.
	'--------------------------------------------------------------------------

	'Session timeout (in minutes).
	const SESSION_TIMEOUT = 60

	'Site URL, used for the emails sent to users.
	const POOL_URL = "http://example.net"

	'Page title.
	const PAGE_TITLE = "2011 Football Pool"

	'Administrator email address.
	const ADMIN_EMAIL = "admin@example.net"

	'Flag indicating whether the server can send email or not.
	const SERVER_EMAIL_ENABLED = true

	'Sign up invitation code.
	const SIGN_UP_INVITATION_CODE = "getajob"

	'Time zone difference between host server and database schedule (Eastern).
	const TIME_ZONE_DIFF = -6

	'Location of the database.
	'const DATABASE_FILE_PATH = "./data/NFL.mdb"

	'For best performance, leave false unless the server does not have the Jet
	'OLE DB provider installed.
	const USE_ACCESS_ODBC_DRIVER = false

	'Key used for encrypting private data.
	const DATA_ENCRYPTION_KEY = "4k0s*b92mqld:pdw7d4sklda8adz@d{a"

	'Session variables.
	const SESSION_MESSAGE_KEY  = "SK_Message"
	const SESSION_THEME_KEY    = "SK_Theme"
	const SESSION_USERNAME_KEY = "SK_Username"

    '--------------------------------------------------------------------------
    'Database connection string (Can be Access or SQL Server).
    '--------------------------------------------------------------------------
    'const DATABASE_CONNECTION_STRING = "Data Source=D:\mysite\Database\FootballPool.mdb; Provider=Microsoft.Jet.OLEDB.4.0;"
    const DATABASE_CONNECTION_STRING = "Provider=sqloledb;Data Source=[server]; Initial Catalog=FootBallpool; User ID=XXXXXXX; Password='XXXXXXX';"
 
    'Delimiter for datetime literals in SQL statements (Use "#" for Access, "'" for SQL Server).
    'const DATABASE_DATETIME_DELIMITER = "#"
    const DATABASE_DATETIME_DELIMITER = "'" 

	'--------------------------------------------------------------------------
	' Display settings.
	'--------------------------------------------------------------------------

	'Enable team themes flag.
	const ENABLE_TEAM_THEMES = true

	'Show point spreads flag. Used to display the line even if picks are not
	'made against the spread.
	const SHOW_POINT_SPREADS = false

	'Show team logos flag.
	const SHOW_TEAM_LOGOS = true

	'Text string used when displaying the Super Bowl in playoffs schedules.
	const SUPER_BOWL_INFO = "XLV - Cowboys Stadium - Arlington, TX"

	'--------------------------------------------------------------------------
	' General pool settings.
	'--------------------------------------------------------------------------

	'Hide other players picks until the games are locked flag.
	const HIDE_OTHERS_PICKS = true

	'Use confidence points flag (weekly and playoffs pick'em pools).
	const USE_CONFIDENCE_POINTS = false

	'Use point spreads flag (weekly and playoffs pick'em pools).
	const USE_POINT_SPREADS = false

	'--------------------------------------------------------------------------
	' Weekly pool settings.
	'
	' Note: You can include an overall award based on total picks (and if
	' confidence points are used, there will be a second overall award based on
	' total points). A portion of each weekly pool will be reserved for the
	' overall award(s).
	'--------------------------------------------------------------------------

	'Cost of a weekly pool entry.
	const WEEKLY_ENTRY_FEE = 10

	'Allow tie picks flag.
	const ALLOW_TIE_PICKS = false

	'Enable quick picks flag.
	const ENABLE_QUICK_PICKS  = true

	'Enable overall award(s).
	const ENABLE_OVERALL_WEEKLY = true

	'Amount to take from each weekly pool towards the overall pot. This is a
	'percentage of the total weekly pot.
	const OVERALL_WEEKLY_SHARE = .10

	'Amount of pot that goes to the player with the most overall confidence
	'points. (Applies only when confidence points are used, the player with the
	'most overall correct picks gets the remainder.)
	const OVERALL_CONFIDENCE_WEEKLY_SHARE = .50

	'--------------------------------------------------------------------------
	' Side pool settings.
	'
	' Note: You can choose to play this as a survivor pool, a margin pool or
	' a combination of both. In a combined pool, users pick a single team each
	' week and that pick applies to both pools.
	'--------------------------------------------------------------------------

	'Enable survivor pool flag.
	const ENABLE_SURVIVOR_POOL = false

	'Enable margin pool flag.
	const ENABLE_MARGIN_POOL = false

	'Cost of a survivor/margin pool entry.
	const SIDE_ENTRY_FEE = 50

	'Starting week of the side pool.
	const SIDE_START_WEEK = 1

	'Amount of pot that goes to the survivor pool winner(s).
	'(Applies only when a combined survivor/margin pool is used, the winner(s)
	'of the margin pool get the remainder.)
	const SIDE_SURVIVOR_SHARE = .50

	'Number of losing picks that will eliminate a player.
	const SURVIVOR_STRIKE_OUT = 1

	'Count a tie game as a losing survivor pick flag.
	const SURVIVOR_STRIKE_ON_TIE = true

	'Maximum number of time a player may buy back into the survivor pool.
	'(Set to zero to disable buybacks.)
	const SURVIVOR_BUYBACK_LIMIT = 2

	'Cost of a buyback.
	const SURVIVOR_BUYBACK_FEE = 25

	'Last week players will be permitted to buy back into the suvivor pool.
	'(Set to zero for no limit.)
	const SURVIVOR_MAX_BUYBACK_WEEK = 0

	'Deduct points on a losing margin pick flag.
	'Note that when true, if a player does not make a pick then the largest
	'margin among all the week's games will be deducted.
	const MARGIN_DEDUCT_LOSS = true

	'--------------------------------------------------------------------------
	' Playoffs pick'em pool settings.
	'--------------------------------------------------------------------------

	'Enable playoffs pick'em pool flag.
	const ENABLE_PLAYOFFS_PICK_POOL = false

	'Cost of a playoffs pick'em pool entry.
	const PLAYOFFS_PICK_ENTRY_FEE = 25

	'--------------------------------------------------------------------------
	' Playoffs rank'em pool settings.
	'--------------------------------------------------------------------------

	'Enable playoffs rank'em pool flag.
	const ENABLE_PLAYOFFS_RANK_POOL = false

	'Cost of a playoffs rank'em pool entry.
	const PLAYOFFS_RANK_ENTRY_FEE = 25

	'--------------------------------------------------------------------------
	' Super Bowl pool settings.
	'--------------------------------------------------------------------------

	'Enable Super Bowl pool flag.
	const ENABLE_SUPER_BOWL_POOL = false

	'Cost of a Super Bowl pool entry.
	const SUPER_BOWL_ENTRY_FEE = 25

	'--------------------------------------------------------------------------
	' Message board settings.
	'--------------------------------------------------------------------------

	'Enable message board flag.
	const ENABLE_MESSAGE_BOARD = true

	'Define maximum message length allowed.
	const MAX_MESSAGE_LENGTH = 2000

	'Define the number of days to keep posts. Set to zero to keep posts
	'indefinitely.
	const MAX_POST_AGE = 30

	'Define the maximum number of posts to keep (when this limit is exceeded,
	'the oldest posts will be removed first). Set to zero to keep an unlimited
	'number of posts.
	const MAX_POST_COUNT = 250

	'Number of posts displayed per page.
	const POST_PAGE_SIZE = 10

	'--------------------------------------------------------------------------
	' Add-ons.
	'
	' Note that these components rely on external web sources and are subject
	' to changes with those sources. If problems occur, you can disable them
	' here.
	'--------------------------------------------------------------------------

	'Enable online payments (via PayPal) flag.
	const ENABLE_PAYPAL_ADDON = false

	'Online payment settings.
	const PAYPAL_BUSINESS       = "admin@example.net"
	const PAYPAL_ITEM_NAME      = "2010 Football Pool"
	const PAYPAL_INVOICE_PREFIX = "FP10-"

	'Number of log entries to display per page.
	const PAYPAL_LOG_PAGE_SIZE  = 10

	'Enable live scoreboard and scores loader flag.
	const ENABLE_SCORES_ADDON = true

	'**************************************************************************
	'* End configuration code.                                                *
	'**************************************************************************
 %>
