<%	'**************************************************************************
	'* Common code for handling form displays and processing.                 *
	'**************************************************************************

	'**************************************************************************
	'* Global variables.                                                      *
	'**************************************************************************

	'Holds error messages for invalid form fields.
	dim FormFieldErrors
	set FormFieldErrors = Server.CreateObject("Scripting.Dictionary")

	'--------------------------------------------------------------------------
	' Returns true if the 'Cancel' button was clicked.
	'--------------------------------------------------------------------------
	function IsCancelRequest()

		IsCancelRequest = false
		if Request.Form("submit") = "Cancel" then
			IsCancelRequest = true
		end if

	end function

	'--------------------------------------------------------------------------
	' Returns true if the specified field name exists in the posted form data.
	'--------------------------------------------------------------------------
	function FormFieldExists(fldName)

		dim name

		FormFieldExists = false
		for each name in Request.Form
			if name = fldName then
				FormFieldExists = true
				exit function
			end if
		next

	end function
	'--------------------------------------------------------------------------
	' Checks the posted form data for the specified field. If it exists, that
	' value is returned. Otherwise, it returns the given value.
	'--------------------------------------------------------------------------
	function GetFieldValue(fldName, fldValue)

		'If the 'Cancel' button was clicked, just use the given value.
		if IsCancelRequest() then
			GetFieldValue = fldValue
			exit function
		end if

		'If a value is found in the posted data, use it. Otherwise, use the
		'given value.
		if FormFieldExists(fldName) then
			GetFieldValue = Request.Form(fldName)
		else
			GetFieldValue = fldValue
		end if

	end function


	'--------------------------------------------------------------------------
	' Checks if the specified form field has an error recorded for it. If so,
	' a special error class name is appended to the given class names string.
	' Otherwise, the class names string is returned unchanged.
	'--------------------------------------------------------------------------
	function StyleFormField(classNames, fldName)

		StyleFormField = classNames
		if FormFieldErrors.Exists(fldName) then
			if Len(StyleFormField) > 0 then
				StyleFormField = StyleFormField & " "
			end if
			StyleFormField = StyleFormField & "fieldError"
		end if

	end function

	'--------------------------------------------------------------------------
	' Displays an error message listing the errors found for all form fields.
	'--------------------------------------------------------------------------
	sub DisplayFormFieldErrorsMessage(msg)

		dim str, name

		str = msg & "<ul>"
		for each name in FormFieldErrors
			if FormFieldErrors(name) <> "" then
				str = str & "<li>" & FormFieldErrors(name) & "</li>"
			end if
		next
		str = str & "</ul>"
		call DisplayErrorMessage(str)

	end sub %>
