<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/payments.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'If the PayPal add-on is disabled, redirect to the home page.
	if not ENABLE_PAYPAL_ADDON then
		Response.Redirect("./")
	end if

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Make Payment"
	call BuildPageHeader("", "") %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Module: onlinePayment
	//
	// Used to update the payment amount, fee and total display when the user
	// changes a payment field.
	//=========================================================================
	var onlinePayment = function () {

		var formEl, amountEl, feeEl, totalEl;

		//---------------------------------------------------------------------
		// Initializes the payment form.
		//---------------------------------------------------------------------
		function init() {

			// Get the payment form and display elements.
			formEl   = document.getElementById("paymentForm");
			amountEl = document.getElementById("paymentAmount");
			feeEl    = document.getElementById("processingFee");
			totalEl  = document.getElementById("totalCharge");

			// Initialize the display.
			updateDisplay();
		}

		//---------------------------------------------------------------------
		// Totals the selected pool entry fees and/or specified amount.
		//---------------------------------------------------------------------
		function getPaymentAmount() {

			var amount = 0;

			// Add the specified number of the weekly pool fees, if any.
			var n = formEl.elements["numWeeks"].value;
			if (!isNaN(parseInt(n, 10)))
				amount += n * <% = WEEKLY_ENTRY_FEE %>;
<%	if ENABLE_SURVIVOR_POOL or ENABLE_MARGIN_POOL or PlayoffsPoolsCount > 0 then %>
			// Add fees for any other pools, if checked.
<%		if ENABLE_SURVIVOR_POOL or ENABLE_MARGIN_POOL then %>
			if (formEl.elements["side"].checked)
				amount += <% = SIDE_ENTRY_FEE %>;
<%		end if
		if ENABLE_PLAYOFFS_PICK_POOL then %>
			if (formEl.elements["playoffsPick"].checked)
				amount += <% = PLAYOFFS_PICK_ENTRY_FEE %>;
<%		end if
		if ENABLE_PLAYOFFS_RANK_POOL then %>
			if (formEl.elements["playoffsRank"].checked)
				amount += <% = PLAYOFFS_RANK_ENTRY_FEE %>;
<%		end if
		if ENABLE_SUPER_BOWL_POOL then %>
			if (formEl.elements["superbowl"].checked)
				amount += <% = SUPER_BOWL_ENTRY_FEE %>;
<%		end if
	end if %>
			// Check for a specific amount to add.
			var x = formEl.elements["otherAmount"].value;

			// If it starts with a dollar sign, remove it.
			if (x.length > 0 && x.substring(0,1) == "$")
				x = x.substring(1);

			// Check the value.
			x = parseFloat(x);
			if (!isNaN(x) && x > 0.0) {

				// It's a valid amount, round it off to two decimal places and
				// add it to the total.
				var s = x.toFixed(2);
				formEl.elements["otherAmount"].value = s;
				x = parseFloat(s);
				amount += x;
			}
			else {

				// It's not a valid amount, clear the input field.
				formEl.elements["otherAmount"].value = "";
			}

			return amount;
		}

		//---------------------------------------------------------------------
		// Calculates the processing fee for the given amount.
		//---------------------------------------------------------------------
		function getProcessingFee(amount)
		{
			var fee = 0;
			if (amount > 0) {

				// The fee is 30 cents plus 2.9% of the amount.
				fee = ((amount + .3) / 0.971) - amount;
				fee = Math.round(100 * fee) / 100;
			}

			return fee;
		}

		//---------------------------------------------------------------------
		// Updates the amount, fee and total charge display.
		//---------------------------------------------------------------------
		function updateDisplay() {

			// Show the payment total.
			var paymentAmount = getPaymentAmount(formEl);
			amountEl.firstChild.nodeValue = "$" + paymentAmount.toFixed(2);

			// Show the processing fee.
			var processingFee = getProcessingFee(paymentAmount);
			feeEl.firstChild.nodeValue = "$" + processingFee.toFixed(2);
	
			// Show the total charge.
			var totalCharge = paymentAmount + processingFee;
			totalEl.firstChild.nodeValue = "$" + totalCharge.toFixed(2);
		}

		//---------------------------------------------------------------------
		// Used to generate an invoice number.
		//---------------------------------------------------------------------
		function hexStr(n) {

			var hexDigits = "0123456789ABCDEF";
			var i, s;

			// Format the first 32-bits of a number as a hexadecimal string.
			s = "";
			for (i = 7; i >= 0; i--)
				s += hexDigits.charAt((n >> (i * 4)) & 0x0F);

			return s;
		}

		//---------------------------------------------------------------------
		// Initialization code.
		//---------------------------------------------------------------------

		// Initialize on page load.
		domUtils.onready(init);

		//=====================================================================
		// Public properties and methods.
		//=====================================================================
		return {

			//-----------------------------------------------------------------
			// Updates the payment amount, fee and total charge display.
			//-----------------------------------------------------------------
			update : function (formEl) {

				// Show the payment total.
				var paymentAmount = getPaymentAmount(formEl);
				amountEl.firstChild.nodeValue = "$" + paymentAmount.toFixed(2);

				// Show the processing fee.
				var processingFee = getProcessingFee(paymentAmount);
				feeEl.firstChild.nodeValue = "$" + processingFee.toFixed(2);
	
				// Show the total charge.
				var totalCharge = paymentAmount + processingFee;
				totalEl.firstChild.nodeValue = "$" + totalCharge.toFixed(2);
			},

<%	if isAdmin() then %>
			//-----------------------------------------------------------------
			// Admin is not permitted to make payments.
			//-----------------------------------------------------------------
			submit : function () {

				return true;
			}
<%	else %>
			//-----------------------------------------------------------------
			// Function to populate and submit the the PayPal form based on the
			// online payment amount.
			//-----------------------------------------------------------------
			submit : function () {

				// Get the payment amount and processing fee.
				var amount = getPaymentAmount(formEl);
				var fee    = getProcessingFee(amount);

				// If no amount was found, submit the form so we can show an
				// error message.
				if (amount == 0)
					return true;

				// Create an invoice number.
				var n = (new Date()).valueOf();
				var invoice = "<% = PAYPAL_INVOICE_PREFIX %>" + hexStr(n);

				// If the amount is valid, submit the PayPal form.
				if (amount > 0) {
					var el = document.getElementById("paypalForm");
					el.elements["amount"].value   = amount;
					el.elements["handling"].value = fee;
					el.elements["invoice"].value  = invoice;
					el.submit();
				}

				return false;
			}
<%	end if %>
		}
	}();
	//]]></script>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	dim weekly, side, playoffs, superbowl
	dim numWeeks, i
	numWeeks = GetWeekCount()

	'Handle a form post.
	if Request.ServerVariables("Content_Length") > 0 and not IsCancelRequest() then
		if IsAdmin() then
			call DisplayErrorMessage("Error: User '" & ADMIN_USERNAME & "' may not make payments.")
		else
			call DisplayErrorMessage("Error: No payment specified.")
		end if
	end if %>
	<form id="paymentForm" action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge">
				<th align="left" colspan="4">Pay Online via PayPal</th>
			</tr>
			<tr>
				<td class="freeForm" colspan="4">
					<p>You may make an online payment via <a href="http://www.paypal.com/">PayPal</a>.
					Note that PayPal charges a processing fee (<% = PAYPAL_FEE_STR %>) <em>which you must pay in addition to the pool fees.</em>
					This fee will appear as a handling charge on your payment invoice.</p>
					<p>To see what payments and fees you currently have on record, check your <a href="accountSummary.asp">account summary</a>.
					To make a payment online set the amount below using any combination of the following:</p>
					<ul>
						<li>Select how many weekly pools to include,</li>
<%	if ENABLE_SURVIVOR_POOL or ENABLE_MARGIN_POOL or PlayoffsPoolsCount > 0 then %>
						<li>Check any other pool fees to include,</li>
<%	end if %>
						<li>And/or enter a specific amount to include.</li>
					</ul>
					<p>The PayPal fee will automatically be calculated and added to the total.
					Hit <code>Submit</code> to be taken to the PayPal web site.</p>
					<table border="0" cellpadding="0" cellspacing="0">
						<tr>
							<td>
								<select name="numWeeks" onchange="onlinePayment.update();">
									<option value=""></option>
<%	for i = 1 to numWeeks %>
									<option value="<% = i %>"><% if i < 10 then Response.Write("&nbsp;&nbsp;") end if : Response.Write(i) %></option>
<%	next %>
								</select>
							</td>
							<td>Weekly Pool(s)</td>
							<td align="right">x <% = FormatAmount(WEEKLY_ENTRY_FEE) %></td>
							<td>(per week)</td>
						</tr>
<%	if ENABLE_SURVIVOR_POOL or ENABLE_MARGIN_POOL then %>
						<tr>
							<td align="right"><input type="checkbox" id="side" name="side" value="true" onclick="onlinePayment.update();" /></td>
							<td><label for="side"><% = SidePoolTitle %> Pool</label></td>
							<td align="right"><% = FormatAmount(SIDE_ENTRY_FEE) %></td>
							<td>&nbsp;</td>
						</tr>
<%	end if
	if ENABLE_PLAYOFFS_PICK_POOL then %>
						<tr>
							<td align="right"><input type="checkbox" id="playoffsPick" name="playoffsPick" value="true" onclick="onlinePayment.update();" /></td>
							<td><label for="playoffsPick"><% = PlayoffsPickPoolTitle %> Pool</label></td>
							<td align="right"><% = FormatAmount(PLAYOFFS_PICK_ENTRY_FEE) %></td>
							<td>&nbsp;</td>
						</tr>
<%	end if
	if ENABLE_PLAYOFFS_RANK_POOL then %>
						<tr>
							<td align="right"><input type="checkbox" id="playoffsRank" name="playoffsRank" value="true" onclick="onlinePayment.update();" /></td>
							<td><label for="playoffsRank"><% = PlayoffsRankPoolTitle %> Pool</label></td>
							<td align="right"><% = FormatAmount(PLAYOFFS_RANK_ENTRY_FEE) %></td>
							<td>&nbsp;</td>
						</tr>
<%	end if
	if ENABLE_SUPER_BOWL_POOL then %>
						<tr>
							<td align="right"><input type="checkbox" id="superbowl" name="superbowl" value="true" onclick="onlinePayment.update();" /></td>
							<td><label for="superbowl">Super Bowl Pool</label></td>
							<td align="right"><% = FormatAmount(SUPER_BOWL_ENTRY_FEE) %></td>
							<td>&nbsp;</td>
						</tr>
<%	end if %>
						<tr>
							<td>&nbsp;</td>
							<td><label for="otherAmount">Other</label></td>
							<td align="right">$<input type="text" id="otherAmount" name="otherAmount" class="numeric" size="5" onchange="onlinePayment.update();" /></td>
							<td>(enter a specific amount)</td>
						</tr>
						<tr>
							<td class="totalLine">&nbsp;</td>
							<td align="right" class="totalLine">Total Payment:</td>
							<td align="right" class="totalLine"><span id="paymentAmount"><% = FormatAmount(0) %></span></td>
						</tr>
						<tr>
							<td align="right" colspan="2">Processing Fee:</td>
							<td align="right"><span id="processingFee"><% = FormatAmount(0) %></span></td>
						</tr>
						<tr>
							<td align="right" colspan="2"><strong>Total Charge:</strong></td>
							<td align="right" class="totalLine"><strong><span id="totalCharge"><% = FormatAmount(0) %></span></strong></td>
						</tr>
					</table>
				</td>
			</tr>
			</table>
			<p><input type="submit" name="submit" value="Submit" class="button" onclick="return onlinePayment.submit();" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></p>
		</form>
	<!-- PayPal form. -->
	<form id="paypalForm" action="<% = PAYPAL_PAYMENT_URL %>" method="post">
		<div>
			<input type="hidden" name="amount" value="" />
			<input type="hidden" name="business" value="<% = PAYPAL_BUSINESS %>" />
			<input type="hidden" name="cancel_return" value="<% = GetAbsoluteUrl(PAYPAL_CANCEL_PAGE) %>" />
			<input type="hidden" name="cmd" value="_xclick" />
			<input type="hidden" name="currency_code" value="USD" />
			<input type="hidden" name="custom" value="<% = Session(SESSION_USERNAME_KEY) %>" />
			<input type="hidden" name="handling" value="" />
			<input type="hidden" name="invoice" value="" />
			<input type="hidden" name="item_name" value="<% = PAYPAL_ITEM_NAME %>" />
			<input type="hidden" name="no_shipping" value="1" />
			<input type="hidden" name="notify_url" value="<% = GetAbsoluteUrl(PAYPAL_NOTIFY_PAGE) %>" />
			<input type="hidden" name="return" value="<% = GetAbsoluteUrl(PAYPAL_RETURN_PAGE) %>" />
			<input type="hidden" name="rm" value="2" />
			<input type="hidden" name="tax" value="0" />
		</div>
	</form>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Returns the absolute URL for the given page.
	'--------------------------------------------------------------------------
	function GetAbsoluteUrl(filename)

		GetAbsoluteUrl = POOL_URL
		if Right(GetAbsoluteUrl, 1) <> "/" then
			GetAbsoluteUrl = GetAbsoluteUrl & "/"
		end if
		GetAbsoluteUrl = GetAbsoluteUrl & filename

	end function %>
