<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/email.asp" -->
<!-- #include file="includes/encryption.asp" -->
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/passwords.asp" -->
<!-- #include file="includes/playoffs.asp" -->
<!-- #include file="includes/playoffsPick.asp" -->
<!-- #include file="includes/playoffsRank.asp" -->
<!-- #include file="includes/side.asp" -->
<!-- #include file="includes/superbowl.asp" -->
<!-- #include file="includes/weekly.asp" -->
<%	'Limit access to the Administrator.
	call CheckAccess(true)

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Manage Users"
	call BuildPageHeader("", "") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'If there is form data, process it.
	dim sql, rs, salt, restoreFields, badChar
	badChar = ""
	restoreFields = false
	if Request.ServerVariables("Content_Length") > 0 and not IsCancelRequest() then

		'Assume we will need to restore the form fields.
		restoreFields = true

		'Set the form field names based on which form was submitted.
		dim usernameField, password1Field, password2Field
		dim username, email, password1, password2, formStr
		usernameField = ""
		password1Field = ""
		password2Field = ""
		formStr = "Request"
		if Request.Form("submit") = "Add" then
			usernameField = "addUsername"
			password1Field = "addPassword1"
			password2Field = "addPassword2"
			formStr = "Add user request"
		elseif Request.Form("submit") = "Delete" then
			usernameField = "deleteUsername"
			formStr = "Delete user request"
		elseif Request.Form("submit") = "Reset" then
			usernameField = "resetUsername"
			password1Field = "resetPassword1"
			password2Field = "resetPassword2"
			formStr = "Password reset request"
		end if

		'Get the form field values.
		username  = Request.Form(usernameField)
		password1 = Request.Form(password1Field)
		password2 = Request.Form(password2Field)
		email     = Request.Form("addEmail")

		'Check the username field.
		if username = "" then
			FormFieldErrors.Add usernameField, "You must select a username."
		else

			'For new user adds, make sure the username is valid and does not already exist.
			if Request.Form("submit") = "Add" then
				badChar = CheckUsername(username)
				if badChar <> "" then
					FormFieldErrors.Add "username", "Usernames may not contain a '" & Server.HtmlEncode(badChar) & "' character."
				elseif Len(username) > USERNAME_MAX_LEN then
					FormFieldErrors.Add "username", "Usernames may not exceed " & USERNAME_MAX_LEN & " characters."
				else
					sql = "SELECT * FROM Users WHERE Username = '" & SqlEscape(username) &"'"
					set rs = DbConn.Execute(sql)
					if not (rs.EOF and rs.BOF) then
						FormFieldErrors.Add usernameField, "Username '" & username & "' already exists, try another."
					end if
				end if
			end if

			'For user deletes, make sure the user has no account transactions
			'or closed pool entries in the database.
			if Request.Form("submit") = "Delete" then

				'Check for account transactions.
				sql = "SELECT DISTINCT Username FROM Credits" _
				  &  " WHERE Username = '" & SqlEscape(username) & "'"
				set rs = DbConn.Execute(sql)
				if not (rs.EOF and rs.BOF) then
					FormFieldErrors.Add usernameField, "User '" & username & "' has one or more account transactions, cannot delete."
				else
					if AnyClosedEntries(username) then
						FormFieldErrors.Add usernameField, "User '" & username & "' has one or more closed pool entries, cannot delete."
					end if
				end if
			end if
		end if

		'For new user adds, check the email field.
		if Request.Form("submit") = "Add" and email <> "" then
			if not IsValidEmailAddress(email) then
				FormFieldErrors.Add "addEmail", "'" & email & "' does not appear to be a valid email address."
			end if
		end if

		'For new user adds and password resets, check the password fields.
		if Request.Form("submit") = "Add" or Request.Form("submit") = "Reset" then
			if password1 = "" or password2 = "" then
				FormFieldErrors.Add password1Field, "You must enter a password twice, where indicated."
				FormFieldErrors.Add password2Field, ""
			elseif password1 <> "" and password1 <> password2 then
				FormFieldErrors.Add password1Field, "Passwords did not match."
				FormFieldErrors.Add password2Field, ""
			elseif Len(password1) < PASSWORD_MIN_LEN then
				FormFieldErrors.Add password1Field, "Password must be at least " & PASSWORD_MIN_LEN & " characters long."
				FormFieldErrors.Add password2Field, ""
			end if
		end if

		'If there where no errors, do the appropriate update.
		if FormFieldErrors.Count = 0 then
			if Request.Form("submit") = "Add" then

				'Add the new user.
				salt = CreateSalt()
				sql = "INSERT INTO Users" _
				  & " (Username, EmailAddress, Salt, [Password])" _
				  & " VALUES('" & SqlEscape(username) & "'," _
				  & " '" & Encrypt(email) & "'," _
				  & " '" & salt & "'," _
				  & " '" & Hash(salt & password1) & "')"
				call DbConn.Execute(sql)
				call DisplaySuccessMessage("User '" & username &"' has been added.")

			elseif Request.Form("submit") = "Delete" then

				'Delete user data from all tables.
				sql = "DELETE FROM Users WHERE Username = '" & SqlEscape(username) & "'"
				call DbConn.Execute(sql)
				sql = "DELETE FROM WeeklyPicks WHERE Username = '" & SqlEscape(username) & "'"
				call DbConn.Execute(sql)
				sql = "DELETE FROM WeeklyScoring WHERE Username = '" & SqlEscape(username) & "'"
				call DbConn.Execute(sql)
				sql = "DELETE FROM SidePicks WHERE Username = '" & SqlEscape(username) & "'"
				call DbConn.Execute(sql)
				sql = "DELETE FROM PlayoffsPicks WHERE Username = '" & SqlEscape(username) & "'"
				call DbConn.Execute(sql)
				sql = "DELETE FROM PlayoffsRanks WHERE Username = '" & SqlEscape(username) & "'"
				call DbConn.Execute(sql)
				sql = "DELETE FROM SuperBowlPicks WHERE Username = '" & SqlEscape(username) & "'"
				call DbConn.Execute(sql)
				sql = "DELETE FROM Messages WHERE Username = '" & SqlEscape(username) & "'"
				call DbConn.Execute(sql)
				call DisplaySuccessMessage("User '" & username &"' has been deleted.")

			elseif Request.Form("submit") = "Reset" then

				'Change user's the password.
				salt = CreateSalt()
				sql = "UPDATE Users SET" _
				   & " Salt = '" & salt & "', " _
				   & " [Password] = '" & Hash(salt & password1) & "'" _
				   & " WHERE Username = '" & SqlEscape(username) & "'"
				call DbConn.Execute(sql)
				call DisplaySuccessMessage("Password for user '" & username &"' has been reset.")
			end if

			'The request was completed so do not restore the form fields.
			restoreFields = false

		'Otherwise, show the errors.
		else
			call DisplayFormFieldErrorsMessage(formStr & " failed, see below.")
		end if

	end if

	'Build the form displays. %>
	<!-- Add a new user form. -->
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge">
				<th align="left">Add a New User</th>
			</tr>
			<tr>
				<td class="freeForm">
					<p>To add a new user, enter a new username and password (twice, for confirmation) in the fields provided.</p>
					<table border="0" cellpadding="0" cellspacing="0">
						<tr valign="middle">
							<td><strong>Username:</strong></td>
							<td><input type="text" name="addUsername" value="<% if restoreFields then Response.Write(Request.Form("addUsername")) end if %>" class="<% = StyleFormField("", "addUsername") %>" /></td>
						</tr>
						<tr valign="middle">
							<td><strong>Email address:</strong></td>
							<td><input type="text" name="addEmail" value="<% if restoreFields then Response.Write(Request.Form("addEmail")) end if %>" size="30" class="<% = StyleFormField("", "email") %>" /></td>
						</tr>
						<tr valign="middle">
							<td><strong>Password:</strong></td>
							<td><input type="password" name="addPassword1" value="" class="<% = StyleFormField("", "addPassword1") %>" /></td>
						</tr>
						<tr valign="middle">
							<td><strong>Confirm password:</strong></td>
							<td><input type="password" name="addPassword2" value="" class="<% = StyleFormField("", "addPassword2") %>" /></td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
		<p><input type="submit" name="submit" value="Add" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></p>
	</form>
<%	'Get a list of users.
	dim users, i
	users = GetUserList(true)
	if IsArray(users) then %>
	<!-- Delete a user form. -->
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge">
				<th align="left">Delete a User</th>
			</tr>
			<tr>
				<td class="freeForm">
					<p>To delete an existing user, select the username below.
					Note that you may not delete users who have made entries for completed games or who have account transactions.</p>
					<table border="0" cellpadding="0" cellspacing="0">
						<tr valign="middle">
							<td><strong>Username:</strong></td>
							<td>
								<select name="deleteUsername" class="<% = StyleFormField("", "deleteUsername") %>">
									<% call DisplayUserSelectList(users, Request.Form("deleteUsername")) %>
								</select>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
		<p><input type="submit" name="submit" value="Delete" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></p>
	</form>
	<!-- Reset a user's password form. -->
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge">
				<th align="left">Reset a User's Password</th>
			</tr>
			<tr>
				<td class="freeForm">
					<p>To reset the password of an existing user, select the username and enter the new password (twice, for confirmation) in the fields provided.</p>
					<table border="0" cellpadding="0" cellspacing="0">
						<tr valign="middle">
							<td><strong>Username:</strong></td>
							<td>
								<select name="resetUsername" class="<% = StyleFormField("", "resetUsername") %>">
									<% call DisplayUserSelectList(users, Request.Form("resetUsername")) %>
								</select>
							</td>
						</tr>
						<tr valign="middle">
							<td><strong>New password:</strong></td>
							<td><input type="password" name="resetPassword1" value="" class="<% = StyleFormField("", "resetPassword1") %>" /></td>
						</tr>
						<tr valign="middle">
							<td><strong>Confirm new password:</strong></td>
							<td><input type="password" name="resetPassword2" value="" class="<% = StyleFormField("", "resetPassword2") %>" /></td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
		<p><input type="submit" name="submit" value="Reset" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></p>
	</form>
<%	end if %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Returns true if the user has any entries for pools that have been closed.
	'--------------------------------------------------------------------------
	function AnyClosedEntries(username)


		dim sql, rs
		dim week, numWeeks

		AnyClosedEntries = false

		'Check weekly pools.
		numWeeks = GetWeekCount()
		for week = 1 to numWeeks
			if InWeeklyPool(username, week) and GetCompletedGameCount(week) = GetGameCount(week) then
				AnyClosedEntries = true
				exit function
			end if
		next

		'Check the side pool.
		if ENABLE_SURVIVOR_POOL or ENABLE_MARGIN_POOL then
			sql = "SELECT COUNT(*) AS Total" _
			    & " FROM SidePicks, Schedule" _
			    & " WHERE Username = '" & SqlEscape(username) & "'" _
			    & " AND (Pick = VisitorID OR Pick = HomeID)" _
			    & " AND Result IS NOT NULL"
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				if (rs.Fields("Total").Value <> 0) then
					AnyClosedEntries = true
					exit function
				end if
			end if
		end if

		'Check the playoffs pick'em and rank'em pools.
		if ENABLE_PLAYOFFS_PICK_POOL or ENABLE_PLAYOFFS_RANK_POOL then
			if GetPlayoffsCompletedGameCount() = GetPlayoffsGameCount() then
				if InPlayoffsPickPool(username) or InPlayoffsRankPool(username) then
					AnyClosedEntries = true
					exit function
				end if
			end if
		end if

		'Check the Super Bowl pool.
		if ENABLE_SUPER_BOWL_POOL then
			if InSuperBowlPool(username) and IsArray(GetSuperBowlWinnersList()) then
				AnyClosedEntries = true
				exit function
			end if
		end if

	end function %>