<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/side.asp" -->
<!-- #include file="includes/weekly.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'If the margin pool is disabled, redirect to the home page.
	if not ENABLE_MARGIN_POOL then
		Response.Redirect("./")
	end if

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Margin Statistics"
	call BuildPageHeader("tableSort.css", "tableSort.js") %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Define the teams table sort commands.
	//=========================================================================
	var teamsNameSort = {
		initialSort : true,
		tbodyID     : "teamsBody",
		theadID     : "teamsHead",
		sortColumns : [
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [],
			headColumns : []
		}
	}
	var teamsRecordSort = {
		tbodyID     : "teamsBody",
		theadID     : "teamsHead",
		sortColumns : [
			{ column : 2, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [1, 2],
			headColumns : [1]
		}
	}
	var teamsBestSort = {
		tbodyID     : "teamsBody",
		theadID     : "teamsHead",
		sortColumns : [
			{ column : 3, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [3, 4],
			headColumns : [2]
		}
	}
	var teamsWorstSort = {
		tbodyID     : "teamsBody",
		theadID     : "teamsHead",
		sortColumns : [
			{ column : 5, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [5, 6],
			headColumns : [3]
		}
	}
	var teamsAvgWinSort = {
		tbodyID     : "teamsBody",
		theadID     : "teamsHead",
		sortColumns : [
			{ column : 7, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [7],
			headColumns : [4]
		}
	}
	var teamsAvgLossSort = {
		tbodyID     : "teamsBody",
		theadID     : "teamsHead",
		sortColumns : [
			{ column : 8, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [8],
			headColumns : [5]
		}
	}
	var teamsPFSort = {
		tbodyID     : "teamsBody",
		theadID     : "teamsHead",
		sortColumns : [
			{ column : 9, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [9],
			headColumns : [6]
		}
	}
	var teamsPASort = {
		tbodyID     : "teamsBody",
		theadID     : "teamsHead",
		sortColumns : [
			{ column : 10, descending : false },
			{ column :  0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [10],
			headColumns : [ 7]
		}
	}
	var teamsNetSort = {
		tbodyID     : "teamsBody",
		theadID     : "teamsHead",
		sortColumns : [
			{ column : 11, descending : true  },
			{ column :  0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [11],
			headColumns : [ 8]
		}
	}
	var teamsNetPPGSort = {
		tbodyID     : "teamsBody",
		theadID     : "teamsHead",
		sortColumns : [
			{ column : 12, descending : true  },
			{ column :  0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [12],
			headColumns : [ 9]
		}
	}
	//]]></script>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Get the selected user.
	dim username
	username = Trim(Request("username"))

	'Get number weeks in the season and max games per week.
	dim numWeeks, numTeams, numGames
	numWeeks = GetWeekCount()
	numTeams = GetTeamCount()
	numGames = Round((numTeams - 1) / 2)

	'Initialize the games array.
	dim games()
	redim games(numWeeks - 1, numGames - 1)

	'Fill the games array.
	dim rs
	dim i, j
	dim vid, hid, result, margin
	dim x, y, tmp
	for i = 0 to numWeeks - 1

		set rs = GetGamesRecordset(i + 1)

		'Get data for all games this week.
		for j = 0 to numGames - 1
			set games(i, j) = new GameObj
			vid    = Null
			hid    = Null
			result = Null
			margin = -1
			if not rs.EOF then
				result = rs.Fields("Result").Value
				vid = rs.Fields("VisitorID").Value
				hid = rs.Fields("HomeID").Value
				if not IsNull(result) then
					margin = Abs(rs.Fields("VisitorScore").Value - rs.Fields("HomeScore").Value)
				end if
				rs.MoveNext
			end if
			games(i, j).vid    = vid
			games(i, j).hid    = hid
			games(i, j).result = result
			games(i, j).margin = margin
		next

		'Sort the week's games by margin.
		for x = 0 to numTeams - 2
			for y = x + 1 to numGames - 1
				if games(i, x).margin < games(i, y).margin then
					set tmp = games(i, x)
					set games(i, x) = games(i, y)
					set games(i, y) = tmp
				end if
			next
		next
	next

	'If a username was specified, get that player's picks
	dim picks
	if username <> "" then
		if InSidePool(username) then
			redim picks(numWeeks)
			for i = 0 to numWeeks - 1
				picks(i) = GetSidePick(username, i + 1)
			next
		end if
	end if

	'Get the current user.
	dim currentUser
	currentUser = Session(SESSION_USERNAME_KEY)

	'Build the display. %>
	<h2>Score Margins <span class="headerNote">(Ranked Largest to Smallest)</span></h2>
	<table class="main" border="0" cellpadding="0" cellspacing="0">
		<tr class="header bottomEdge">
			<th colspan="<% = numWeeks %>">Week</th>
		</tr>
		<tr class="subHeader bottomEdge">
<%	dim alt, str, className
	dim pick, vstr, hstr
	dim hidePick
	for i = 0 to numWeeks - 1 %>
			<th align="center" style="width: 2.75em;"><% = i + 1 %></th>
<%	next %>
		</tr>
<%	alt = false
	for j = 0 to numGames - 1
		if alt then %>
		<tr align="center" class="alt">
<%		else %>
		<tr align="center">
<%		end if
		alt = not alt
		for i = 0 to numWeeks - 1
			vid       = games(i, j).vid
			hid       = games(i, j).hid
			result    = games(i, j).result
			margin    = "--"
			className = ""

			'Get the user's pick.
			pick = ""
			hidePick = false
			if IsArray(picks) then
				pick = picks(i)

				'Determine if the pick should be hidden.
				if HIDE_OTHERS_PICKS and not (IsAdmin() or currentUser = username or IsSidePickLocked(pick, i + 1)) then
					hidePick = true
				end if
			end if

			'Format the game display.
			vstr = vid
			hstr = hid
			if IsNull(vid) then
				str = "&nbsp;<br />&nbsp;<br />&nbsp;"
			else
				if not IsNull(result) then
					if result = vid then
						vstr = FormatCorrectPick(vid)
					elseif result = hid then
						hstr = FormatCorrectPick(hid)
					end if
					margin = games(i, j).margin
					if MARGIN_DEDUCT_LOSS then
						margin = "&plusmn;" & margin
					else
						margin = "+" & margin
					end if
				end if
				if not hidePick then
					if pick = vid then
						vstr = vstr & "-x"
					elseif pick = hid then
						hstr = hstr & "-x"
					end if
				end if
				str = vstr & "<br />" & margin & "<br />" & hstr

				'If a user was specified, highlight that player's pick.
				if username <> "" and (pick = vid or pick = hid) then

					'Highlight the pick.
					if not hidePick then
						className = " sortedCol"
					end if

				end if
			end if %>
			<td class="small<% = className %>"><% = str %></td>
<%		next %>
		</tr>
<%	next

	'If a username was specified, show that player's picks.
	dim score, rank
	dim total
	total = 0
	if username <> "" and InSidePool(username) then %>
		<tr class="header topEdge bottomEdge">
			<th align="left" colspan="<% = numWeeks %>">Picks for <% = username %></th>
		</tr>
		<tr align="center">
<%		for i = 0 to numWeeks - 1
			pick = GetSidePick(username, i + 1)
			score = GetMarginScore(username, i + 1)

			'Determine if the pick should be hidden.
			hidePick = false
			if HIDE_OTHERS_PICKS and not (IsAdmin() or currentUser = username or IsSidePickLocked(pick, i + 1)) then
				hidePick = true
			end if

			'Format the pick and score.
			if hidePick then
				pick = "---"
				score = "--"
			else
				if pick = "" then
					pick = "---"
				end if
				if not IsNumeric(score) then
					score = "--"
				else
					total = total + score
					if score > 0 then
						pick = FormatCorrectPick(pick)
					elseif score = 0 then
						pick = FormatTie(pick)
					elseif score < 0 then
						if pick <> "---" then
							pick = FormatIncorrectPick(pick)
						end if
					end if
					score = FormatMarginScore(score)
				end if
			end if %>
			<td class="small"><% = pick %><br /><% = score %></td>
<%		next %>
		</tr>
		<tr class="subHeader topEdge">
			<th align="left" colspan="<% = numWeeks - 2 %>">Total:</th>
			<th align="right" colspan="2"><% = total %>&nbsp;pts.</th>
		</tr>
<%	end if %>
	</table>
<%	'List the players for selection. %>
	<p></p>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
	<table border="0" cellpadding="0" cellspacing="0">
		<tr valign="middle">
			<td><strong>Select player:</strong></td>
			<td>
				<select name="username">
					<% call DisplayUserSelectList(GetSidePlayersList(), username) %>
				</select>
			</td>
			<td><input type="submit" value="Select" class="button" /></td>
		</tr>
	</table>
	</form>
<%	'Initialize the best, worst footnotes count.
	dim footnotesCount
	footnotesCount = 0

	'Calculate team scoring data.
	dim teams
	redim teams(numTeams - 1)
	i = 0
	set rs = GetTeamsRecordset()
	if not (rs.EOF and rs.BOF) then
		do while not rs.EOF
			set teams(i) = new TeamObj
			teams(i).setData(rs.Fields("TeamID").Value)
			teams(i).name = rs.Fields("DisplayName").Value
			if IsNull(teams(i).name) then
				teams(i).name = rs.Fields("City").Value
			end if
			i = i + 1
			rs.MoveNext
		loop
	end if

	'Build the display. %>
	<h2>Scoring Summary By Team</h2>
	<table class="main" border="0" cellpadding="0" cellspacing="0">
		<thead id="teamsHead">
			<tr class="header bottomEdge singleLine sortable" valign="bottom">
				<th align="left"><a href="#" onclick="this.blur(); return tableSort.sort(teamsNameSort);" title="Sort by name.">Name</a></th>
				<th align="center" class="small" colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(teamsRecordSort);" title="Sort by record.">W-L-T<br /> Record</a></th>
				<th class="small" colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(teamsBestSort);" title="Sort by best scoring margin.">Best<br />Scoring Margin</a></th>
				<th class="small" colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(teamsWorstSort);" title="Sort by worst scoring margin.">Worst<br />Scoring Margin</a></th>
				<th class="small"><a href="#" onclick="this.blur(); return tableSort.sort(teamsAvgWinSort);" title="Sort by average margin in games won.">Avg. Win<br /> Margin</a></th>
				<th class="small"><a href="#" onclick="this.blur(); return tableSort.sort(teamsAvgLossSort);" title="Sort by average margin in games lost.">Avg. Loss<br /> Margin</a></th>
				<th><a href="#" onclick="this.blur(); return tableSort.sort(teamsPFSort);" title="Sort by total points scored.">PF</a></th>
				<th><a href="#" onclick="this.blur(); return tableSort.sort(teamsPASort);" title="Sort by total points allowed.">PA</a></th>
				<th><a href="#" onclick="this.blur(); return tableSort.sort(teamsNetSort);" title="Sort by total net points.">Net</a></th>
				<th class="small"><a href="#" onclick="this.blur(); return tableSort.sort(teamsNetPPGSort);" title="Sort by net points per game.">Net<br />PPG</a></th>
			</tr>
		</thead>
		<tbody id="teamsBody">
<%	alt = false
	for i = 0 to Ubound(teams)
		if alt then %>
			<tr align="right" class="alt singleLine">
<%		else %>
			<tr align="right" class="singleLine">
<%		end if
		alt = not alt %>
				<td align="left"><a href="teamSchedules.asp?id=<% = teams(i).id %>"><% call DisplayTeamLogo(teams(i).id) %><% = teams(i).name %></a></td>
				<td><% = FormatRecord(teams(i).wins, teams(i).losses, teams(i).ties) %></td>
				<td>(<% = FormatPercentage(teams(i).pct) %>)</td>
<%		if IsNumeric(teams(i).maxMargin) then
			str = ""
			if teams(i).maxNotes <> "" then
				footnotesCount = footnotesCount + 1
				str = "<span class=""small""><sup>(" & footnotesCount & ")</sup></span>"
			end if %>
				<td><% = FormatMarginScore(teams(i).maxMargin) %></td>
				<td align="left"><span class="small"><% = "Week " & teams(i).maxWeek & " vs. " & teams(i).maxOpp & str %></span></td>
<%		else %>
				<td>&nbsp;</td>
				<td align="left">n/a</td>
<%		end if
		if IsNumeric(teams(i).minMargin) then
			str = ""
			if teams(i).minNotes <> "" then
				footnotesCount = footnotesCount + 1
				str = "<span class=""small""><sup>(" & footnotesCount & ")</sup></span>"
			end if %>
				<td><% = FormatMarginScore(teams(i).minMargin) %></td>
				<td align="left"><span class="small"><% = "Week " & teams(i).minWeek & " vs. " & teams(i).minOpp & str %></span></td>
<%		else %>
				<td>&nbsp;</td>
				<td align="left">n/a</td>
<%		end if
		if IsNumeric(teams(i).maxMargin) then %>
				<td><% = teams(i).avgWinMargin %></td>
<%		else %>
				<td>n/a</td>
<%		end if
		if IsNumeric(teams(i).minMargin) then %>
				<td><% = teams(i).avgLossMargin %></td>
<%		else %>
				<td>n/a</td>
<%		end if %>
				<td><% = teams(i).ptsFor %></td>
				<td><% = teams(i).ptsAgainst %></td>
				<td><% = teams(i).netPts %></td>
				<td><% = teams(i).netPPG %></td>
			</tr>
<%	next %>
		</tbody>
	</table>
<%	'Display the footnotes, if any.
	if footnotesCount > 0 then %>
	<div class="adjustWidth small">
		Best/Worst margin notes:
		<ol class="small">
<%		for i = 0 to UBound(teams)
			if teams(i).maxNotes <> "" then %>
			<li><% = teams(i).maxNotes %></li>
<%			end if
			if teams(i).minNotes <> "" then %>
			<li><% = teams(i).minNotes %></li>
<%			end if
		next %>
		</ol>
	</div>
<% end if %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Returns a formatted a margin score.
	'--------------------------------------------------------------------------
	function FormatMarginScore(n)

		FormatMarginScore = n

		'Prepend a plus sign on non-negative values.
		if n >= 0 then
			FormatMarginScore = "+" & FormatMarginScore
		end if

	end function

	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' GameObj: Holds information for a single game.
	'--------------------------------------------------------------------------
	class GameObj

		public vid, hid, result, margin

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

	end class

	'--------------------------------------------------------------------------
	' TeamObj: Holds information for a single team.
	'--------------------------------------------------------------------------
	class TeamObj

		public id, name

		public wins, losses, ties, pct
		public avgWinMargin, avgLossMargin
		public ptsFor, ptsAgainst, netPts, netPPG
		public maxMargin, maxWeek, maxOpp
		public minMargin, minWeek, minOpp
		public maxNotes, minNotes

		private sub Class_Initialize()

			avgWinMargin = 0: avgLossMargin = 0
			ptsFor = 0 : ptsAgainst = 0 : netPts = 0 : netPPG = 0
			maxMargin = "" : maxWeek = "" : maxOpp = ""
			minMargin = "" : minWeek = "" : minOpp = ""
			maxNotes = "" : minNotes = ""

		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(teamID)

			dim sql, rs
			dim winMarginTotal, lossMarginTotal
			dim games
			dim week, opp, margin

			'Save the team ID.
			id = teamID

			'Get the team's scoring data.
			wins   = 0
			losses = 0
			ties   = 0
			winMarginTotal = 0
			lossMarginTotal = 0
			games = 0
			sql = "SELECT * FROM Schedule" _
			   & " WHERE Result IS NOT NULL" _
			   & " AND" _
			   & " (VisitorID = '" & teamID & "' OR HomeID = '" & teamID & "')"
			set rs = DbConn.Execute(sql)
			do while not rs.EOF

				'Add to the game count.
				games = games + 1

				'Get the opponent and add to the PF and PA totals.
				if rs.Fields("VisitorID").Value = teamID then
					opp = rs.Fields("HomeID").Value
					ptsFor = ptsFor + rs.Fields("VisitorScore").Value
					ptsAgainst = ptsAgainst + rs.Fields("HomeScore").Value
				else
					opp = rs.Fields("VisitorID").Value
					ptsFor = ptsFor + rs.Fields("HomeScore").Value
					ptsAgainst = ptsAgainst + rs.Fields("VisitorScore").Value
				end if

				'Find the winning/losing margin.
				margin = ABS(rs.Fields("VisitorScore").Value - rs.Fields("HomeScore").Value)
				if rs.Fields("Result").Value <> teamID then
					margin = -margin
				end if

				'Add to totals.
				if margin > 0 then
					wins = wins + 1
					winMarginTotal = winMarginTotal + margin
				elseif margin < 0 then
					losses = losses + 1
					lossMarginTotal = lossMarginTotal + margin
				else
					ties = ties + 1
				end if

				'Set the max/min margin, week and opponent.
				week = rs.Fields("Week").Value
				if not IsNumeric(maxMargin) then
					maxMargin = margin
					maxWeek = week
					maxOpp = opp
					maxNotes = ""
					minMargin = margin
					minWeek = week
					minOpp = opp
					minNotes = ""
				elseif margin > maxMargin then
					maxMargin = margin
					maxWeek = week
					maxOpp = opp
					maxNotes = ""
				elseif margin = maxMargin then
					if maxNotes <> "" then
						maxNotes = maxNotes & ", "
					end if
					maxNotes = maxNotes & "Week " & week & " vs. " & opp
				elseif margin < minMargin then
					minMargin = margin
					minWeek = week
					minOpp = opp
					minNotes = ""
				elseif margin = minMargin then
					if minNotes <> "" then
						minNotes = minNotes & ", "
					end if
					minNotes = minNotes & "Week " & week & " vs. " & opp
				end if
				rs.MoveNext
			loop

			'Calculate winning percentage.
			pct = 0
			if wins + losses + ties > 0 then
				pct = (wins + ties / 2) / (wins + losses + ties)
			end if

			'Get average win/loss margin.
			avgWinMargin  = FormatAverage(winMarginTotal,  wins,   2)
			avgLossMargin = FormatAverage(lossMarginTotal, losses, 2)

			'Calculate net points.
			netPts = ptsFor - ptsAgainst

			'Get net points per game.
			netPPG = FormatAverage(netPts, games, 2)

			'Format any footnotes.
			if Len(maxNotes) > 0 then
				maxNotes = "Tied best in " & maxNotes
			end if
			if Len(minNotes) > 0 then
				minNotes = "Tied worst in " & minNotes
			end if

		end sub

	end class %>

