<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" -->
<!-- #include file="includes/common.asp" -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/messages.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'If the message board is disabled, redirect to the home page.
	if not ENABLE_MESSAGE_BOARD then
		Response.Redirect("./")
	end if

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Message Board"
	call BuildPageHeader("", "tiny_mce/tiny_mce.js,messageBoard.js") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Purge any expired posts.
	call PurgeExpiredPosts()

	'If there is form data, process it.
	dim created, username, message, lastModified
	dim sql, rs
	if Request.ServerVariables("Content_Length") > 0 then
		if (Request.Form("submit") = "Post") and Session(SESSION_MESSAGE_KEY) = false then

			'If the user is disabled, prevent posting.
			if IsDisabled() then
				call DisplayErrorMessage("Error: Your account has been disabled, post not accepted. Please contact the Administrator.")
			else

				'Validate the message field.
				message = Request.Form("message")
                
				if Len(message) = 0 then
					FormFieldErrors.Add "message", "Messages may not be empty."
				elseif Len(message) > MAX_MESSAGE_LENGTH then
					FormFieldErrors.Add "message", "Message exceeds allowed length."
				else

					'Add the new post.
					created = GetCurrentDateTime()
					lastModified = created
					username = Session(SESSION_USERNAME_KEY)
					sql = "INSERT INTO Messages" _
					   & " (Created, Username, Message, LastModified)" _
					   & " VALUES(" & DATABASE_DATETIME_DELIMITER & created & DATABASE_DATETIME_DELIMITER & "," _
					   & " '" & SqlEscape(username) & "'," _
					   & " '" & SqlEscape(message) & "'," _
					   & DATABASE_DATETIME_DELIMITER _
                       & lastModified _
                       & DATABASE_DATETIME_DELIMITER & ")"
					call DbConn.Execute(sql)

					'Purge any excess posts.
					call PurgeExcessPosts()

					'Save the message in the session and redirect back to this
					'page.
					Session(SESSION_MESSAGE_KEY) = "Message added."
					Response.Redirect(Request.ServerVariables("SCRIPT_NAME"))
				end if

			end if
		end if

		'Display any errors.
		if FormFieldErrors.Count > 0 then
			call DisplayFormFieldErrorsMessage("Error: Invalid fields. Please correct and resubmit.")
		end if
	end if

	'If a message was saved in the session (during an edit or delete), show
	'that message and clear the session variable.
	if Session(SESSION_MESSAGE_KEY) <> "" then
		call DisplaySuccessMessage(Session(SESSION_MESSAGE_KEY))
		Session.Contents.Remove(SESSION_MESSAGE_KEY)
	end if

	'Build the display. %>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge" valign="bottom">
				<th align="left" colspan="3">Message Board</th>
			</tr>
<%	dim currentPage, pageCount, messageId, i

	'Retrive posts from the database.
	sql = "SELECT * FROM Messages ORDER BY Created DESC"
	set rs = Server.CreateObject("ADODB.Recordset")
	rs.CursorLocation = 3
	rs.PageSize = POST_PAGE_SIZE
	rs.Open sql, DbConn

	'Set the current page.
	currentPage = Request.QueryString("page")
	if IsNumeric(currentPage) then
		currentPage = CLng(currentPage)
	else
		currentPage = 0
	end if
	if currentPage < 1 then
		currentPage = 1
	end if
	if currentPage > rs.PageCount then
		currentPage = rs.PageCount
	end if

	'If a message ID is was specified in the query string, show the page
	'containing it.
	dim id
	id = Request.QueryString("id")
	if IsNumeric(id) then
		id = CLng(id)
		do while not rs.EOF
			if rs.Fields("MessageID").Value = id then
				currentPage = rs.AbsolutePage
				rs.MoveFirst
				exit do
			end if
			rs.MoveNext
		loop
	end if

	'Show posts.
	if rs.PageCount > 0 then

		'Set up page navigation.
		rs.AbsolutePage = currentPage
		if rs.PageCount > 1 then %>
			<tr class="subHeader bottomEdge">
				<th align="left" style="width: 20%;">
<%			if currentPage > 1 then %>
					<a href="<% = Request.ServerVariables("SCRIPT_NAME") & "?page=" & (currentPage - 1) %>"><span class="arrow">&#9664;</span> Newer</a>
<%			end if %>
				&nbsp;
				</th>
				<th align="center" style="width: 60%;">Page <% = currentPage & " of " & rs.PageCount %></th>
				<th align="right" style="width: 20%;">
				&nbsp;
<%			if currentPage < rs.PageCount then %>
					<a href="<% = Request.ServerVariables("SCRIPT_NAME") & "?page=" & (currentPage + 1) %>">Older <span class="arrow">&#9654;</span></a>
<%			end if %>
				</th>
			</tr>
<%		end if

		'Show posts.
		dim alt
		alt = false
		for i = 1 to rs.PageSize
			messageId    = rs.Fields("MessageID").Value
			created      = rs.Fields("Created").Value
			username     = rs.Fields("Username").Value
			message      = rs.Fields("Message").Value
			lastModified = rs.Fields("LastModified").Value
			if alt then %>
			<tr class="alt" valign="top">
<%			else %>
			<tr valign="top">
<%			end if
			alt = not alt %>
				<td white-space: nowrap;">
					<strong><% = username %></strong><br />
					<em class="small"><% = FormatPostDate(created) %><br />
					<% = FormatFullTime(created) %></em>
				</td>
				<td colspan="2">
<%			if created <> lastModified then %>
					<div title="Modified <% = FormatPostDate(lastModified) & " at " & FormatFullTime(lastModified) %>">
<%			else %>
					<div>
<%			end if
			if IsAdmin() or username = Session(SESSION_USERNAME_KEY) then %>
					<span style="float: right; margin: 0px 0px 1ex 1em;"><a href="updateMessage.asp?id=<% = messageId %>">Edit/Remove</a></span>
<%			end if %>
						<div class="message"><% = message %></div>
					</div>
				</td>
			</tr>
<%			rs.MoveNext
			if rs.EOF then
				exit for
			end if
		next
	else %>
			<tr>
				<td align="center" colspan="3"><em>No messages.</em></td>
			</tr>
<%	end if %>
		<tr class="header topEdge bottomEdge">
			<th align="left" colspan="3">Post a New Message</th>
		</tr>
		<tr valign="top">
			<td colspan="3" class="freeForm">
				<p>Enter your post below.
				Note that messages may not exceed <% = MAX_MESSAGE_LENGTH %> total characters (including formatting).</p>
				<table class="<% = StyleFormField("htmlEditorArea", "message") %>" border="0" cellpadding="0" cellspacing="0"><tr><td style="padding: 0px;">
					<div>
<%	message = ""
	if Request.ServerVariables("Content_Length") > 0 and not IsCancelRequest then
		message = Trim(Request.Form("message"))
	end if %>
						<textarea id="message" name="message" rows="8" cols="80" class="mceEditor"><% = message %></textarea>
					</div>
				</td></tr></table>
			</td>
		</tr>
		</table>
		<p><input type="submit" name="submit" value="Post" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></p>
	</form>
<% 'Set up page navigation.
	if rs.PageCount > 1 then
		call DisplayGoToNavigation("page", rs.PageCount, "")
	end if %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>

