<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/playoffs.asp" -->
<!-- #include file="includes/playoffsPick.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'If the playoffs pick'em pool is disabled, redirect to the home page.
	if not ENABLE_PLAYOFFS_PICK_POOL then
		Response.Redirect("./")
	end if

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = PlayoffsPickPoolTitle & " Pool Entry Form"
	if not USE_CONFIDENCE_POINTS then
		call BuildPageHeader("", "")
	else
		call BuildPageHeader("confPtsStatus.css", "confPtsStatus.js") %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Initialize the confidence points status display on page load.
	//=========================================================================
	domUtils.onready(function () {
		confPtsStatus.update(document.getElementById("entryForm"));
	});
	//]]></script>
<%	end if %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'If the user is the Administrator, check for a user name in the request.
	'Otherwise, show data for the current user.
	dim username
	username = Session(SESSION_USERNAME_KEY)
	if IsAdmin() then
		username = Trim(Request("username"))
	end if

	'For the Administrator, build a user selection list.
	if IsAdmin() then %>
		<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
			<table class="main" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge">
				<th align="left">Administrator Access</th>
			</tr>
			<tr>
				<td class="adminSection freeForm">
					<p>You may view or edit any player's entry form by selecting a username below.</p>
					<table border="0" cellpadding="0" cellspacing="0">
						<tr valign="middle">
							<td><strong>Select user:</strong></td>
							<td>
								<select name="username">
									<% call DisplayUserSelectList(GetUserList(true), username) %>
								</select>
							</td>
							<td><input type="submit" name="submit" value="Select" class="button" /></td>
						</tr>
					</table>
				</td>
			</tr>
			</table>
		</form>
<%		if username <> "" then %>
		<h2>Entry Form for <% = username %></h2>
<%		end if
	end if

	'Determine if the user has an entry for the playoffs pool (so we can display
	'the Delete button).
	dim hasEntry
	hasEntry = false
	if InPlayoffsPickPool(username) then
		hasEntry = true
	end if

	'Initialize lock flags.
	dim allLocked, anyLocked
	allLocked = true
	anyLocked = false

	'Create an array of game objects
	dim games, rs, n
	dim i
	n = GetPlayoffsGameCount()
	redim games(n - 1)
	sql = "SELECT * FROM PlayoffsSchedule ORDER BY Round, Date, Time"
	set rs = DbConn.Execute(sql)
	if not (rs.EOF and rs.BOF) then
		i = 0
		do while not rs.EOF
			set games(i) = new GameObj
			games(i).setData(rs)
			i = i + 1
			rs.MoveNext
		loop
	end if

	'Determine if there are any games set in the schedule.
	dim haveGames
	haveGames = false
	for i = 0 to UBound(games)
		if not IsNull(games(i).visitorID) and not IsNull(games(i).homeID) then
			haveGames = true
			exit for
		end if
	next

	'If there is form data, process it.
	dim needDeleteConfirmation, entryDeleted
	dim readyErrorShown
	dim pick, conf
	dim pickMissingMsg, confMissingMsg
	dim confUsed
	needDeleteConfirmation = false
	entryDeleted = false
	readyErrorShown = false

	'Process a delete request.
	if Request.Form("submit") = "Delete" then

		if not IsAdmin() and anyLocked then
			call DisplayErrorMessage("Error: One or more playoff games have been locked, entry cannot be deleted.")
		elseif LCase(Request.Form("confirmDelete")) <> "true" then
			needDeleteConfirmation = true
			call DisplayWarningMessage("To confirm deletion, check the box below and press <code>Delete</code> again. Pressing any other button will cancel the deletion.")
		elseif GetPlayoffsCompletedGameCount() = GetPlayoffsGameCount() then
			call DisplayErrorMessage("Error: The " & LCase(PlayoffsPickPoolTitle) & "  pool has been concluded, cannot delete entries.")
		else

			'Delete the player's entry.
			sql = "DELETE FROM PlayoffsPicks" _
			   & " WHERE Username = '" & SqlEscape(username) & "'"
			call DbConn.Execute(sql)
			entryDeleted = true
			hasEntry = false

			'Clear pick and confidence point assignments for each game.
			for i = 0 to UBound(games)
				games(i).storedPick = ""
				games(i).storedConf = ""
			next

			call DisplaySuccessMessage("Entry has been deleted.")
		end if

	'Process an update request.
	elseif Request.Form("submit") = "Update" then

		'Determine if at least one pick was made.
		dim anyPicks
		anyPicks = false
		for i = 0 to UBound(games)
			if Trim(Request.Form("pick-" & (i + 1))) <> "" or _
			   (USE_CONFIDENCE_POINTS and Trim(Request.Form("conf-" & (i + 1))) <> "") then
				anyPicks = true
				exit for
			end if
		next

		'Prevent entries by the Admin.
		if username = ADMIN_USERNAME then
			call DisplayErrorMessage("Error: User '" & ADMIN_USERNAME & "' may not make picks.")

		'If the playoffs teams have not been set, prevent the entry.
		elseif not haveGames then
			call DisplayErrorMessage("Error: Playoffs games have not been set, entries cannot be submitted.")
			readyErrorShown = true

		'If the user is disabled, prevent the entry.
		elseif IsDisabled() then
			call DisplayErrorMessage("Error: Your account has been disabled, changes not accepted. Please contact the Administrator.")

		'If all games have been locked, prevent any updates (except by the Admin).
		elseif not IsAdmin() and allLocked then
			call DisplayErrorMessage("Error: All playoff games have been locked, changes not accepted.")

		'If any games have been locked and the user does not already have an entry, prevent any updates (except by the Admin).
		elseif not IsAdmin() and not hasEntry and anyLocked then
			call DisplayErrorMessage("Error: The " & LCase(PlayoffsPickPoolTitle) & " pool has been locked, changes not accepted.")

		'If no picks were entered, prevent the entry.
		elseif not anyPicks then
			call DisplayErrorMessage("Error: No picks entered.")

		'Otherwise, process the request.
		else

			'Validate the pick and confidence point fields.
			pickMissingMsg = "You must make a pick to set your confidence points."
			confMissingMsg = "You must enter your confidence points when making a pick for a game."
			if USE_CONFIDENCE_POINTS then
				for i = 0 to UBound(games)
					pick = Trim(Request.Form("pick-" & (i + 1)))
					conf = Trim(Request.Form("conf-" & (i + 1)))

					'Make sure that if a pick was made, confidence points were
					'entered and vice-versa.
					if pick = "" and conf <> "" then
						FormFieldErrors.Add "pick-" & (i + 1), pickMissingMsg
						pickMissingMsg = ""
					end if
					if pick <> "" and conf = "" then
						FormFieldErrors.Add "conf-" & (i + 1), confMissingMsg
						confMissingMsg = ""
					end if

					'Validate the confidence points entered, if any.
					if conf <> "" then
						if not IsValidInteger(conf) then
							FormFieldErrors.Add "conf-" & (i + 1), "'" & conf & "'  is not a valid confidence point value."
						elseif CInt(conf) < 1 or CInt(conf) > UBound(games) + 1 then
							FormFieldErrors.Add "conf-" & (i + 1), "'" & conf & "' is not a valid confidence point value."
						end if
					end if

				next

				'Make sure the confidence points for each pick are unique.
				if FormFieldErrors.Count = 0 then
					redim confUsed(UBound(games) + 1)
					for i = 0 to UBound(games)
						confUsed(i) = false
					next
					for i = 0 to UBound(games)
						conf = GetFieldValue("conf-" & (i + 1), games(i).storedConf)
						if conf <> "" then
							if confUsed(conf) then
								FormFieldErrors.Add "conf-" & (i + 1), "'" & conf & "' is already assigned to a different game."
							else
								confUsed(conf) = true
							end if
						end if
					next
				end if
			end if

			'Make sure no picks were made for locked games.
			if not IsAdmin() then
				for i = 0 to UBound(games)
					if Request.Form("pick-" & (i + 1)) <> "" and games(i).isLocked then
						FormFieldErrors.Add "pick-" & (i + 1), "The " & games(i).visitorName & " at " & games(i).homeName & " game has been locked and cannot be changed."
					end if
				next
			end if

			'If there were any errors, display the error message. Otherwise, do
			'the updates.
			dim sql
			if FormFieldErrors.Count > 0 then
				call DisplayFormFieldErrorsMessage("Error: Invalid fields. Please correct and resubmit.")
			else
				for i = 0 to UBound(games)
					pick = GetFieldValue("pick-" & (i + 1), games(i).storedPick)
					conf = GetFieldValue("conf-" & (i + 1), games(i).storedConf)
					if not IsNumeric(conf) then
						conf = "NULL"
					end if
					sql = "DELETE FROM PlayoffsPicks" _
					   & " WHERE Username = '" & SqlEscape(username) & "'" _
					   & " AND GameID = " & games(i).id
					call DbConn.Execute(sql)
					sql = "INSERT INTO PlayoffsPicks" _
					   & " (Username, GameID, Pick, Confidence)" _
					   & " VALUES('" & SqlEscape(username) & "'," _
					   & " '" & games(i).id & "', " _
					   & " '" & pick & "'," _
					   & conf & ")"
					call DbConn.Execute(sql)
				next

				'Updates complete, redirect to the results page.
				Response.Redirect("playoffsPickResults.asp")
			end if
		end if
	end if

	'Show a warning if the pool is not ready for entries.
	if FormFieldErrors.Count = 0 and not readyErrorShown then
		if IsAdmin() and username = "" then
			Response.Write(vbTab & "<br />" & vbCrLf)
		end if
		if not haveGames then
			call DisplayWarningMessage("The " & LCase(PlayoffsPickPoolTitle) & " pool is not yet ready for entries.")
		end if
	end if

	'Build the entry form.
	if username <> "" then
		dim cols
		cols = 10
		if USE_CONFIDENCE_POINTS then
			cols = cols + 1
		end if
		if SHOW_POINT_SPREADS or USE_POINT_SPREADS then
			cols = cols + 1
		end if %>
	<form id="entryForm" action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<div>
<%		if IsAdmin() then %>
			<input type="hidden" name="username" value="<% = username %>" />
<%		end if

		'If used, add form fields for the confidence points status display.
		if USE_CONFIDENCE_POINTS then %>
			<input type="hidden" name="confPtsNumGames" value="<% = UBound(games) + 1 %>" />
			<input type="hidden" name="confPtsStatusID" value="confPtsStatus" />
<%		end if %>
		</div>
		<table border="0" cellpadding="0" cellspacing="0"><tr><td style="padding: 0px;">
		<table class="main" border="0" cellpadding="0" cellspacing="0">
<%		dim numRounds, conference
		dim lastRound
		dim visitor, home
		dim vpicked, hpicked
		dim correctPick
		dim lockedConf
		dim alt
		numRounds = GetPlayoffsRoundCount()
		lastRound = 0
		alt = false
		for i = 0 to UBound(games)
			if games(i).gameRound <> lastRound then
				lastRound = games(i).gameRound
				alt = false
				if games(i).gameRound = 1 then %>
			<tr class="header bottomEdge">
<%				else %>
			<tr class="header topEdge bottomEdge">
<%				end if %>
				<th align="left" colspan="<% = cols %>"><% = PlayoffRoundNames(games(i).gameRound - 1) %></th>
			</tr>
<%			end if
			if alt then %>
			<tr align="right" class="alt singleLine">
<%			else %>
			<tr align="right" class="singleLine">
<%			end if
			alt = not alt

			'Get the conference of the teams playing.
			if games(i).gameRound <> numRounds and not IsNull(games(i).homeID) then
				conference = "(" & ConferenceNames(games(i).conference - 1) & ")"
			else
				conference = "&nbsp;"
			end if

			'Show the lock icon, if appropriate.
			if anyLocked then
				if games(i).isLocked then %>
					<td align="center"><img src="graphics/locked.png" alt="Locked" /></td>
<%				else %>
					<td>&nbsp;</td>
<%				end if
			end if %>
				<td align="left"><% = WeekdayName(Weekday(games(i).dateTime), true) %></td>
				<td><% = FormatDate(games(i).dateTime) %></td>
				<td><% = FormatTime(games(i).dateTime) %></td>
				<td><% = conference %></td>
<%			'Get team names.
			visitor = games(i).visitorName
			home    = games(i).homeName

			'Get the player's pick data for this game.
			if (not IsAdmin() and games(i).isLocked) or entryDeleted then
				pick = games(i).storedPick
				conf = games(i).storedConf
			else
				pick = GetFieldValue("pick-" & (i + 1), games(i).storedPick)
				conf = GetFieldValue("conf-" & (i + 1), games(i).storedConf)
			end if

			'Highlight fields based on the game result.
			if games(i).result = games(i).visitorID then
				visitor = FormatWinner(visitor)
			elseif games(i).result = games(i).homeID then
				home = FormatWinner(home)
			end if
			if USE_POINT_SPREADS then
				if games(i).atsResult = games(i).visitorID then
					visitor = FormatATSWinner(visitor)
				elseif games(i).atsResult = games(i).homeID then
					home = FormatATSWinner(home)
				end if
			end if

			'Handle the display for a locked game or a game that has not been set.
			if (not IsAdmin() and games(i).isLocked) or IsNull(games(i).visitorID) or IsNull(games(i).homeID) then

				'Save the raw confidence points value (used by the client-side script).
				lockedConf = conf

				'Determine the correct pick.
				if USE_POINT_SPREADS then
					correctPick = games(i).atsResult
				else
					correctPick = games(i).result
				end if

				'Set the pick displays.
				vpicked = "&nbsp;"
				hpicked = "&nbsp;"
				if pick = games(i).visitorID then
					vpicked = "X"
				elseif pick = games(i).homeID then
					hpicked = "X"
				end if

				'Format a correct/incorrect pick.
				if correctPick <> "" then
					if pick = correctPick then
						if pick = games(i).visitorID then
							vpicked = FormatCorrectPick(vpicked)
						elseif pick = games(i).homeID then
							hpicked = FormatCorrectPick(hpicked)
						end if
					else
						if pick = games(i).visitorID then
							vpicked = FormatIncorrectPick(vpicked)
						elseif pick = games(i).homeID then
							hpicked = FormatIncorrectPick(hpicked)
						end if
					end if
				end if

				'Set the confidence points display.
				if USE_CONFIDENCE_POINTS then
					if conf <> "" then
						conf = conf & "&nbsp;pts."
						if pick = correctPick then
							conf = FormatCorrectPick(conf)
						end if
					end if
				end if

				'Pad the pick and confidence point displays.
				vpicked = "&nbsp;&nbsp;" & vpicked & "&nbsp;&nbsp;"
				hpicked = "&nbsp;&nbsp;" & hpicked & "&nbsp;&nbsp;"
				conf    = "&nbsp;" & conf %>
				<td align="center"><% = vpicked %></td>
				<td align="left"><% call DisplayTeamLogo(games(i).visitorID) %><% = visitor %></td>
<%				if SHOW_POINT_SPREADS or USE_POINT_SPREADS then %>
				<td><% = FormatPointSpread(games(i).pointSpread) %></td>
<%				end if %>
				<td><% = GetConjunction(games(i).gameRound) %></td>
				<td align="center"><% = hpicked %></td>
				<td align="left"><% call DisplayTeamLogo(games(i).homeID) %><% = home %></td>
<%				'Add the confidence points assigned to the locked game as a
				'form field (used by the client-side script).
				if USE_CONFIDENCE_POINTS then %>
				<td><input type="hidden" name="lockedConf-<% = (i + 1) %>" value="<% = lockedConf %>" /><% = conf %></td>
<%				end if

			'Handle the display for an unlocked game.
			else %>
				<td align="center"><span class="<% = StyleFormField("fieldWrapper", "pick-" & (i + 1)) %>"><input type="radio" id="pick-<% = (i + 1) %>-V" name="pick-<% = (i + 1) %>" value="<% = games(i).visitorID %>"<% if pick = games(i).visitorID then Response.Write(CHECKED_ATTRIBUTE) end if %> /></span></td>
				<td align="left"><label for="pick-<% = (i + 1) %>-V"><% call DisplayTeamLogo(games(i).visitorID) %><% = visitor %></label></td>
<%				if SHOW_POINT_SPREADS or USE_POINT_SPREADS then %>
				<td><label for="pick-<% = (i + 1) %>-V"><% = FormatPointSpread(games(i).pointSpread) %></label></td>
<%				end if %>
				<td><% = GetConjunction(games(i).gameRound) %></td>
				<td align="center"><span class="<% = StyleFormField("fieldWrapper", "pick-" & (i + 1)) %>"><input type="radio" id="pick-<% = (i + 1) %>-H" name="pick-<% = (i + 1) %>" value="<% = games(i).homeID %>"<% if pick = games(i).homeID then Response.Write(CHECKED_ATTRIBUTE) end if %> /></span></td>
				<td align="left"><label for="pick-<% = (i + 1) %>-H"><% call DisplayTeamLogo(games(i).homeID) %><% = home %></label></td>
<%				if USE_CONFIDENCE_POINTS then %>
				<td align="right">
					<select name="conf-<% = (i + 1) %>" class="<% = StyleFormField("numeric", "conf-" & (i + 1)) %>" onchange="confPtsStatus.update(this.form);">
<%					call DisplayConfidencePointsList(UBound(games) + 1, conf) %>
					</select>&nbsp;pts.
				</td>
<%				end if
			end if %>
			</tr>
<%		next

		'Add a row for dynamically displaying the available confidence points.
		if USE_CONFIDENCE_POINTS and (IsAdmin() or not allLocked) then %>
			<tr class="subHeader topEdge" style="display: none;">
				<th id="confPtsStatus" colspan="<% = cols %>"></th>
			</tr>
<%		end if

		'Build the player's score display, when available.
		dim score, numGames, pctStr, scoreStr
		numGames = GetPlayoffsCompletedGameCount()
		scoreStr = ""
		pctStr = ""
		if numGames > 0 then
			score = GetPlayoffsPickScore(username)
			if IsNumeric(score) and IsNumeric(numGames) then
				scoreStr = score & "/" & numGames
				pctStr = "&nbsp;(" & FormatPercentage(score / numGames) & ")"
				if USE_CONFIDENCE_POINTS then
					score = GetPlayoffsConfidenceScore(username)
					if IsNumeric(score) then
						scoreStr = scoreStr & pctStr & "&nbsp;&nbsp;<strong>" & FormatScore(score, false) & " pts.</strong>"
					end if
				else
					scoreStr = "<strong>" & scoreStr & "</strong>" & pctStr
				end if
			end if 
		end if
		if scoreStr <> "" then %>
			<tr class="header topEdge bottomEdge">
				<th align="left" colspan="<% = cols %>">Score</th>
			</tr>
			<tr>
				<td align="right" colspan="<% = cols %>"><% = scoreStr %></td>
			</tr>
<%		end if %>
		</table>
<%		'Show form buttons, if changes are allowed.
		if IsAdmin() or not allLocked then %>
		<p></p>
		<table border="0" cellpadding="0" cellspacing="0" style="width: 100%;">
			<tr valign="middle">
				<td style="padding: 0px;"><input type="submit" name="submit" value="Update" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></td>
<%			'If the user has an entry and no games are locked (or the user is the
			'Admin), add a delete button.
			if hasEntry and (IsAdmin() or not anyLocked) then

				'If delete was requested, add a confirmation checkbox.
				if needDeleteConfirmation then %>
				<td align="right" style="padding: 0px;"><input type="checkbox" id="confirmDelete" name="confirmDelete" value="true" /> <label for="confirmDelete">Confirm Deletion</label>&nbsp;</td>
<%				end if %>
				<td align="right" style="padding: 0px;"><input type="submit" name="submit" value="Delete" class="button" /></td>
<%			end if %>
			</tr>
		</table>
<%		end if %>
		</td></tr></table>
	</form>
<%	end if %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' GameObj: Holds information for a single game.
	'--------------------------------------------------------------------------
	class GameObj

		public id, gameRound, dateTime, visitorID, homeID, pointSpread
		public result, atsResult
		public visitorName, homeName, conference, isLocked
		public storedPick, storedConf

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(rs)

			'Set the game properties using the supplied database record.
			id          = rs.Fields("GameID").Value
			gameRound   = rs.Fields("Round").Value
			dateTime    = CDate(rs.Fields("DateTime").Value)
			visitorID   = rs.Fields("VisitorID").Value
			pointSpread = rs.Fields("PointSpread").Value
			homeID      = rs.Fields("HomeID").Value
			result      = rs.Fields("Result").Value
			atsResult   = rs.Fields("ATSResult").Value
			isLocked    = false
			storedPick  = ""
			storedConf  = ""

			'Get the conference of the teams playing.
			conference = GetConference(homeID)

			'Set the team names for display.
			visitorName = GetTeamName(visitorID)
			homeName    = GetTeamName(homeID)

			'Set the game's lock status.
			if IsPlayoffsRoundLocked(gameRound) then
				anyLocked = true
				isLocked = true
			else
				allLocked = false
			end if

			'Get the user's pick data for this game.
			dim sql, rs2
			sql = "SELECT Pick, Confidence FROM PlayoffsPicks" _
			   & " WHERE Username = '" & SqlEscape(username) & "'" _
			   & " AND GameID = " & id
			set rs2 = DbConn.Execute(sql)
			if not (rs2.EOF and rs2.BOF) then
				storedPick = rs2.Fields("Pick").Value
				storedConf = rs2.Fields("Confidence").Value
			end if

		end sub

	end class %>