<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/playoffs.asp" -->
<!-- #include file="includes/playoffsPick.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'If the playoffs pick'em pool is disabled, redirect to the home page.
	if not ENABLE_PLAYOFFS_PICK_POOL then
		Response.Redirect("./")
	end if

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = PlayoffsPickPoolTitle & " Pool Results"
	call BuildPageHeader("tableSort.css", "tableSort.js") %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Define the results table sort commands.
	//=========================================================================
	var resultsNameSort = {
		initialSort : true,
		tbodyID     : "resultsBody",
		theadID     : "resultsHead",
		sortColumns : [
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [],
			headColumns : []
		}
	}
<%	if USE_CONFIDENCE_POINTS then %>
	var resultsCorrectSort = {
		tbodyID     : "resultsBody",
		theadID     : "resultsHead",
		sortColumns : [
			{ column : -3,  descending : true  },
			{ column :  0,  descending : false }
		],
		highlightColumns : {
			bodyColumns : [-4, -3],
			headColumns : [-2]
		}
	}
	var resultsScoreSort = {
		tbodyID     : "resultsBody",
		theadID     : "resultsHead",
		sortColumns : [
			{ column : -2, descending : true  },
			{ column :  0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [-2, -1],
			headColumns : [-1]
		}
	}
<%	else %>
	var resultsScoreSort = {
		tbodyID     : "resultsBody",
		theadID     : "resultsHead",
		sortColumns : [
			{ column : -1, descending : true  },
			{ column :  0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [-2, -1],
			headColumns : [-1]
		}
	}
<%	end if %>
	//]]></script>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Find the number of playoff games.
	dim numGames, completedGames
	numGames = GetPlayoffsGameCount()
	completedGames = GetPlayoffsCompletedGameCount()

	'Get the current username.
	dim currentUser
	currentUser = Session(SESSION_USERNAME_KEY)

	'Determine if all playoff games have been locked.
	dim allLocked
	allLocked = IsPlayoffsRoundLocked(GetPlayoffsRoundCount())

	'Build the display.
	dim gameCols, otherCols
	gameCols  = numGames
	otherCols = 3
	if USE_CONFIDENCE_POINTS then
		otherCols = otherCols + 2
	end if %>
	<table class="main" border="0" cellpadding="0" cellspacing="0">
		<thead id="resultsHead">
			<tr class="header bottomEdge sortable" valign="bottom">
				<th align="left"><a href="#" onclick="this.blur(); return tableSort.sort(resultsNameSort);" title="Sort by name.">Name</a></th>
				<th class="small" colspan="4">Wild Card<br />Games</th>
				<th class="small" colspan="4">Divisional<br />Playoffs</th>
				<th class="small" colspan="2">Conf.<br /> Champ.</th>
				<th class="small">Super<br />Bowl</th>
<%	if USE_CONFIDENCE_POINTS then %>
				<th colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(resultsCorrectSort);" title="Sort by number of correct picks.">Correct</a></th>
<%	end if %>
				<th colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(resultsScoreSort);" title="Sort by score.">Score</a></th>
			</tr>
		</thead>
<%	'Show the pot/payout.
	dim numEntries
	dim pot, list, str
	numEntries = GetPlayoffsPickEntryCount()
	if numEntries > 0 then %>
		<tfoot>
<%		pot = numEntries * PLAYOFFS_PICK_ENTRY_FEE
		list = GetPlayoffsPickWinnersList()
		if IsArray(list) then
			if UBound(list) > 0 then
				str = "Winners: " & Join(list, ", ") & " (" & FormatAmount(pot / (UBound(list) + 1)) & " each)"
			else
				str = "Winner: " & Join(list, ", ") & " (" & FormatAmount(pot) & ")"
			end if %>
			<tr class="header topEdge"><th align="left" colspan="<% = gameCols + otherCols %>"><% = str %></th></tr>
<%		else %>
			<tr class="subHeader topEdge"><th align="left" colspan="<% = gameCols + otherCols %>">Pot: <% = FormatAmount(pot) %></th></tr>
<%		end if %>
		</tfoot>
<%	end if %>
		<tbody id="resultsBody">
<%	dim users
	dim anyHalfPts, leadConfScore
	dim i, j
	dim sql, rs
	dim gameRound
	dim pick, conf, result, correctPick, giveTie
	dim pickScore, pickPct, confScore, confScoreDiff, tbDiff
	dim hidePick
	dim alt

	'Get user data.
	list = GetPlayoffsPickPlayersList()
	if IsArray(list) then

		'Create an array of user objects.
		redim users(UBound(list))
		for i = 0 to UBound(list)
			set users(i) = new UserObj
			users(i).setData(list(i))
		next

		'If confidence points are used, get the current leading score.
		anyHalfPts = false
		if USE_CONFIDENCE_POINTS and completedGames > 0 then
			leadConfScore = 0
			for i = 0 to UBound(users)
				if IsNumeric(users(i).confScore) then
					if users(i).confScore > leadConfScore then
						leadConfScore = users(i).confScore
					end if

					'Note if there are any scores with a half of a point.
					if Round(users(i).confScore) <> users(i).confScore then
						anyHalfPts = true
					end if
				end if
			next
		end if

		'Display user picks and score.
		alt = false
		for i = 0 to UBound(users)
			if alt then %>
			<tr align="center" class="alt singleLine">
<%			else %>
			<tr align="center" class="singleLine">
<%			end if
			alt = not alt %>
				<td align="left"><% = users(i).name %></td>
<%			'Display picks for this user, highlighting the correct ones.
			sql = "SELECT * FROM PlayoffsPicks, PlayoffsSchedule" _
			   & " WHERE Username = '" & SqlEscape(users(i).name) & "'" _
			   & " AND PlayoffsPicks.GameID = PlayoffsSchedule.GameID" _
			   & " ORDER BY PlayoffsSchedule.Round, PlayoffsSchedule.DateTime"
			set rs = DbConn.Execute(sql)
			do while not rs.EOF
				pick = rs.Fields("Pick").Value
				conf = rs.Fields("Confidence").Value

				'Determine if the pick should be hidden.
				hidePick = false
				gameRound = rs.Fields("Round").Value
				if not allLocked and not IsAdmin() and currentUser <> users(i).name then
					if not IsPlayoffsRoundLocked(gameRound) then
						hidePick = true
					end if
				end if

				'Determine the correct pick.
				if USE_POINT_SPREADS then
					correctPick = rs.Fields("ATSResult").Value
				else
					correctPick = rs.Fields("Result").Value
				end if

				'Format the pick display.
				if pick = "" then
					pick = "---"
					conf = "--"
				elseif hidePick then
					pick = "XXX"
					conf = "xx"
				else
					if correctPick <> "" then
						if pick = correctPick then
							pick = FormatCorrectPick(pick)
						elseif correctPick = TIE_STR then
							pick = FormatTie(pick)
						else
							pick = FormatIncorrectPick(pick)
						end if
					end if
				end if

				'When using point spreads, highlight the straight-up result
				'if it matches the pick.
				if USE_POINT_SPREADS then
					if rs.Fields("Pick").Value = rs.Fields("Result").Value then
						pick = FormatWinner(pick)
					end if
				end if
				if USE_CONFIDENCE_POINTS then %>
				<td class="small"><% = pick %><br /><% = conf %></td>
<%				else %>
				<td><% = pick %></td>
<%				end if
					rs.MoveNext
			loop

			'Build the correct pick and score displays.
			pickScore  = "n/a"
			pickPct    = "&nbsp;"
			if completedGames > 0 then
				pickScore = users(i).pickScore
				pickPct = "(" & FormatPercentage(pickScore / completedGames) & ")"
				pickScore = pickScore & "/" & completedGames
			end if

			'For confidence points, show how far behind the leader this user's
			'score is.
			if USE_CONFIDENCE_POINTS then
				confScore = "n/a&nbsp;&nbsp;&nbsp;"
				confScoreDiff = "&nbsp;"
				if completedGames > 0 then
					confScore = users(i).confScore
					if confScore < leadConfScore then
						confScoreDiff = "(" & FormatScore(confScore -leadConfScore, false) & ")"
					elseif confScore = leadConfScore then
						confScoreDiff = "&nbsp;"
					end if
					confScore = FormatScore(confScore, anyHalfPts)
				end if
			end if %>
				<td align="right"><% = pickScore %></td>
				<td align="right"><% = pickPct %></td>
<%			if USE_CONFIDENCE_POINTS then %>
				<td align="right"><% = confScore %></td>
				<td align="right"><span class="small"><% = confScoreDiff %></span></td>
<%			end if %>
			</tr>
<%		next
	else %>
			<tr class="noSort">
				<td>&nbsp;</td>
				<td align="center" colspan="<% = gameCols %>" style="width: 28em;"><em>No entries found.</em></td>
				<td colspan="<% = otherCols - 1 %>">&nbsp;</td>
			</tr>
<%	end if %>
		</tbody>
	</table>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' UserObj: Holds information for a single user.
	'--------------------------------------------------------------------------
	class UserObj

		public name
		public pickScore, confScore

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(username)

			'Set the user properties.
			name      = username
			pickScore = GetPlayoffsPickScore(username)
			confScore = GetPlayoffsConfidenceScore(username)

		end sub

	end class %>

