<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/playoffs.asp" -->
<!-- #include file="includes/playoffsRank.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'If the playoffs pick'em pool is disabled, redirect to the home page.
	if not ENABLE_PLAYOFFS_RANK_POOL then
		Response.Redirect("./")
	end if

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = PlayoffsRankPoolTitle & " Pool Entry Form"
	call BuildPageHeader("confPtsStatus.css", "confPtsStatus.js") %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Initialize the confidence points status display on page load.
	//=========================================================================
	domUtils.onready(function () {
		confPtsStatus.update(document.getElementById("entryForm"));
	});
	//]]></script>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'If the user is the Administrator, check for a user name in the request.
	'Otherwise, show data for the current user.
	dim username
	username = Session(SESSION_USERNAME_KEY)
	if IsAdmin() then
		username = Trim(Request("username"))
	end if

	'For the Administrator, build a user selection list.
	if IsAdmin() then %>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<table class="main" border="0" cellpadding="0" cellspacing="0">
		<tr class="header bottomEdge">
			<th align="left">Administrator Access</th>
		</tr>
		<tr>
			<td class="adminSection freeForm">
				<p>You may view or edit any player's entry form by selecting a username below.</p>
				<table border="0" cellpadding="0" cellspacing="0">
					<tr valign="middle">
						<td><strong>Select user:</strong></td>
						<td>
							<select name="username">
								<% call DisplayUserSelectList(GetUserList(true), username) %>
							</select>
						</td>
						<td><input type="submit" name="submit" value="Select" class="button" /></td>
					</tr>
				</table>
			</td>
		</tr>
		</table>
	</form>
<%		if username <> "" then %>
	<h2>Entry Form for <% = username %></h2>
<%		end if
	end if

	'Determine if the playoffs teams have been set.
	dim haveTeams
	haveTeams = HavePlayoffsTeams()

	'Determine if the user has an entry for the playoffs pool (so we can
	'display the Delete button).
	dim hasEntry
	hasEntry = false
	if InPlayoffsRankPool(username) then
		hasEntry = true
	end if

	'Set locked flag.
	dim isLocked
	isLocked = IsPlayoffsRoundLocked(1)

	'Build the list of playoffs teams.
	dim n
	dim teams
	dim i, j, k
	n = NumberConferences * NumberPlayoffsSeeds
	redim teams(n - 1)
	k = 0
	for i = 1 to NumberConferences
		for j = 1 to NumberPlayoffsSeeds
			set teams(k) = new TeamObj
			call teams(k).setData(i, j)
			k = k + 1
		next
	next

	'Determine if there are any results.
	dim anyResults
	anyResults = false
	for i = 0 to UBound(teams)
		if teams(i).wins + teams(i).losses > 0 then
			anyResults = true
			exit for
		end if
	next

	'If there is form data, process it.
	dim sql
	dim needDeleteConfirmation, entryDeleted
	dim readyErrorShown
	dim conf
	needDeleteConfirmation = false
	entryDeleted = false
	readyErrorShown = false

	'Process a delete request.
	if Request.Form("submit") = "Delete" then

		if not IsAdmin() and isLocked then
			call DisplayErrorMessage("Error: The " & LCase(PlayoffsRankPoolTitle) & " pool has been locked, entry cannot be deleted.")
		elseif LCase(Request.Form("confirmDelete")) <> "true" then
			needDeleteConfirmation = true
			call DisplayWarningMessage("To confirm deletion, check the box below and press <code>Delete</code> again. Pressing any other button will cancel the deletion.")
		elseif GetPlayoffsCompletedGameCount() = GetPlayoffsGameCount() then
			call DisplayErrorMessage("Error: The " & LCase(PlayoffsRankPoolTitle) & "  pool has been concluded, cannot delete entries.")
		else

			'Delete the player's entry.
			sql = "DELETE FROM PlayoffsRanks" _
			   & " WHERE Username = '" & SqlEscape(username) & "'"
			call DbConn.Execute(sql)
			entryDeleted = true
			hasEntry = false

			'Clear confidence point assignments for each team.
			for i = 0 to UBound(teams)
				teams(i).storedConf = ""
			next

			call DisplaySuccessMessage("Entry has been deleted.")
		end if

	'Process an update request.
	elseif Request.Form("submit") = "Update" then

		'Check for missing confidence point assignments.
		dim missingConf
		missingConf = false
		for i = 0 to UBound(teams)
			if Trim(Request.Form("conf-" & (i + 1)) = "") then
				missingConf = true
				FormFieldErrors.Add "conf-" & (i + 1), ""
			end if
		next

		'Prevent entries by the Admin.
		if username = ADMIN_USERNAME then
			call DisplayErrorMessage("Error: User '" & ADMIN_USERNAME & "' may not make picks.")

		'If the playoffs teams have not been set, prevent the entry.
		elseif not haveTeams then
			call DisplayErrorMessage("Error: Playoffs teams have not been set, entries cannot be submitted.")
			readyErrorShown = true

		'If the user is disabled, prevent the entry.
		elseif IsDisabled() then
			call DisplayErrorMessage("Error: Your account has been disabled, changes not accepted. Please contact the Administrator.")

		'If any playoffs games have been locked, prevent any updates (except by the Admin).
		elseif not IsAdmin() and isLocked then
			call DisplayErrorMessage("Error: The " & LCase(PlayoffsRankPoolTitle) & " pool has been locked, changes not accepted.")

		'If not all teams were assigned confidence points, prevent the entry.
		elseif missingConf then
			call DisplayErrorMessage("Error: You must assign a point value to each team.")

		'Otherwise, process the request.
		else

			'Validate the confidence points.
			for i = 0 to UBound(teams)
				conf = Trim(Request.Form("conf-" & (i + 1)))
				if conf <> "" then
					if not IsValidInteger(conf) then
						FormFieldErrors.Add "conf-" & (i + 1), "'" & conf & "'  is not a valid point value."
					elseif CInt(conf) < 1 or CInt(conf) > UBound(teams) + 1 then
						FormFieldErrors.Add "conf-" & (i + 1), "'" & conf & "' is not a valid point value."
					end if
				end if
			next

			'Make sure the confidence points for each team are unique.
			if FormFieldErrors.Count = 0 then
				redim confUsed(UBound(teams) + 1)
				for i = 0 to UBound(teams)
					confUsed(i) = false
				next
				for i = 0 to UBound(teams)
					conf = GetFieldValue("conf-" & (i + 1), teams(i).storedConf)
					if conf <> "" then
						if confUsed(conf) then
							FormFieldErrors.Add "conf-" & (i + 1), "'" & conf & "' is already assigned to a different team."
						else
							confUsed(conf) = true
						end if
					end if
				next
			end if

			'If there were any errors, display the error messages. Otherwise, do the updates.
			if FormFieldErrors.Count > 0 then
				call DisplayFormFieldErrorsMessage("Error: Invalid fields. Please correct and resubmit.")
			else

				'Delete any current picks for this users.
				sql = "DELETE FROM PlayoffsRanks" _
				   & " WHERE Username = '" & SqlEscape(username) & "'"
				call DbConn.Execute(sql)

				'Insert picks for this user.
				for i = 0 to UBound(teams)
					conf = GetFieldValue("conf-" & (i + 1), teams(i).storedConf)
					sql = "INSERT INTO PlayoffsRanks" _
					   & " (Username, TeamID, Confidence)" _
					   & " VALUES('" & SqlEscape(username) & "'," _
					   & " '" & teams(i).id & "', " _
					   & conf & ")"
					call DbConn.Execute(sql)
				next

				'Updates complete, redirect to the results page.
				Response.Redirect("playoffsRankResults.asp")
			end if
		end if
	end if

	'Show a warning if the pool is not ready for entries.
	if FormFieldErrors.Count = 0 and not readyErrorShown then
		if IsAdmin() and username = "" then
			Response.Write(vbTab & "<br />" & vbCrLf)
		end if
		if not haveTeams then
			call DisplayWarningMessage("The " & LCase(PlayoffsRankPoolTitle) & " pool is not yet ready for entries.")
		end if
	end if

	'Build the entry form.
	dim cols
	dim alt
	dim confName, className
	dim confStr, score, total
	if username <> "" then
		 cols = 3
		 if isLocked then
		 	cols = cols + 1
		 end if
		 if anyResults then
		 	cols = cols + 1
		 end if %>
	<form id="entryForm" action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<div>
<%		if IsAdmin() then %>
			<input type="hidden" name="username" value="<% = username %>" />
<%		end if %>
			<input type="hidden" name="confPtsNumGames" value="<% = UBound(teams) + 1 %>" />
			<input type="hidden" name="confPtsStatusID" value="confPtsStatus" />
		</div>
		<table border="0" cellpadding="0" cellspacing="0"><tr><td style="padding: 0px;">
		<table class="main" border="0" cellpadding="0" cellspacing="0">
<%		dim numWeeks
		numWeeks = GetWeekCount()
		k = 0
		total = 0
		for i = 1 to NumberConferences
			confName = ConferenceNames(i - 1)
			className = LCase(confName)
			if i > 1 then
				className = "topEdge " & className
			end if
			alt = false %>
			<tr class="header bottomEdge <% = className %>" valign="bottom">
				<th align="left" colspan="<% = cols %>"><% = confName %> Playoff Teams</th>
			</tr>
<%			if anyResults then %>
			<tr class="subHeader bottomEdge" valign="bottom">
				<th colspan="<% = cols - 3 %>">&nbsp;</th>
				<th>Assigned</th>
				<th>Gained</th>
			</tr>
<%			end if
			for j = 1 to NumberPlayoffsSeeds
				if alt then %>
			<tr class="alt singleLine">
<%				else %>
			<tr class="singleLine">
<%				end if
				alt = not alt

				'Get the player's assigned points for this team.
				if (not IsAdmin() and isLocked) or entryDeleted then
					conf = teams(k).storedConf
				else
					conf = GetFieldValue("conf-" & (k + 1), teams(k).storedConf)
				end if

				'Get score for the pick, if available.
				if conf = "" then
					confStr  = "&nbsp;"
					score = "&nbsp;"
				elseif IsNumeric(conf) then
					confStr = conf & "&nbsp;pts."
					if teams(k).wins + teams(k).losses = 0 then
						score = "&nbsp;"
					else
						score = conf * teams(k).wins
						total = total + score
						score = "<strong>" & score & "&nbsp;pts.</strong>"
					end if
				end if

				'Show the lock icon, if appropriate.
				if isLocked then %>
				<td align="center"><img src="graphics/locked.png" alt="Locked" /></td>
<%				end if %>
				<td style="width: 24em;">
					<input type="hidden" name="id-<% = (k + 1) %>" value="<% = teams(k).id %>" /><% = j %>. <% call DisplayTeamLogo(teams(k).id) %><% = teams(k).name %>
<%				if teams(k).id <> "" then

 					'If entries are locked, show the playoffs record. Otherwise
					'show the regular season record.
					if isLocked then %>
					<span class="small">(<% = FormatRecord(teams(k).wins, teams(k).losses, 0) %>)</span>
<%					else
						call DisplayTeamRecord(teams(k).id, numWeeks, false)
					end if
				end if %>
				</td>
<%				'Handle the display for a locked entry.
				if not IsAdmin() and isLocked then %>
				<td align="right"><% = confStr %></td>
<%				'Handle the display for an unlocked entry.
				else %>
				<td align="right">
<%					if haveTeams then %>
					<select name="conf-<% = (k + 1) %>" class="<% = StyleFormField("numeric", "conf-" & (k + 1)) %>" onchange="confPtsStatus.update(this.form);">
<%						call DisplayConfidencePointsList(UBound(teams) + 1, conf) %>
					</select>&nbsp;pts.
<%					else %>
					&nbsp;
<%					end if %>
				</td>
<%				end if

				'If there are any game results, show the score.
				if anyResults then %>
				<td align="right"><% = score %></td>
<%				end if %>
			</tr>
<%				k = k + 1
			next
		next

		'Add a row for dynamically displaying the available confidence points.
		if IsAdmin() or not isLocked then %>
			<tr class="subHeader topEdge" style="display: none;">
				<th id="confPtsStatus" colspan="<% = cols %>"></th>
			</tr>
<%		end if

		'Show the player's score, if available
		if hasEntry and anyResults then %>
			<tr class="header topEdge bottomEdge">
				<th align="left" colspan="<% = cols %>">Score</th>
			</tr>
			<tr>
				<td align="right" colspan="<% = cols %>"><strong><% = total %> pts.</strong></td>
			</tr>
<%		end if %>
		</table>
<%		'Show form buttons, if changes are allowed.
		if IsAdmin() or not isLocked then %>
		<p></p>
		<table border="0" cellpadding="0" cellspacing="0" style="width: 100%;">
			<tr valign="middle">
				<td style="padding: 0px;"><input type="submit" name="submit" value="Update" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></td>
<%			'If the user has an entry and the pool is not locked (or the user
			'is the Admin), add a delete button.
			if hasEntry and (IsAdmin() or not isLocked) then

				'If delete was requested, add a confirmation checkbox.
				if needDeleteConfirmation then %>
				<td align="right" style="padding: 0px;"><input type="checkbox" id="confirmDelete" name="confirmDelete" value="true" /> <label for="confirmDelete">Confirm Deletion</label>&nbsp;</td>
<%				end if %>
				<td align="right" style="padding: 0px;"><input type="submit" name="submit" value="Delete" class="button" /></td>
<%			end if %>
			</tr>
		</table>
<%		end if %>
		</td></tr></table>
	</form>
<%	end if %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************
	'--------------------------------------------------------------------------
	' TeamObj: Holds information for a single team.
	'--------------------------------------------------------------------------
	class TeamObj

		public id, name
		public storedConf
		public wins, losses

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(conf, seed)

			'Initialize properties.
			id     = ""
			name   = TO_BE_DETERMINED_STR
			wins   = 0
			losses = 0

			'If the playoffs teams have not been set, exit.
			if not haveTeams then
				exit sub
			end if

			'Get the team info.
			dim sql, rs
			sql = "SELECT * FROM Teams" _
			   & " WHERE Conference = " & conf _
			   & " AND PlayoffsSeed = " & seed
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				id   = rs.Fields("TeamID").Value
				name = rs.Fields("City").Value & " " & rs.Fields("Name").Value
			end if

			'Get the user's points data for this team.
			sql = "SELECT Confidence FROM PlayoffsRanks" _
			   & " WHERE Username = '" & SqlEscape(username) & "'" _
			   & " AND TeamID = '" & id & "'"
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				storedConf = rs.Fields("Confidence").Value
			end if

			'Get the number of wins the team has.
			sql = "SELECT COUNT(Result) AS Total FROM PlayoffsSchedule" _
			   & " WHERE Result  = '" & id & "'"
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				wins = rs.Fields("Total").Value
			end if

			'Get the number of losses the team has.
			sql = "SELECT COUNT(Result) AS Total FROM PlayoffsSchedule" _
			   & " WHERE (VisitorID = '" & id & "' OR HomeID = '" & id & "')" _
			   & " AND Result IS NOT NULL AND Result <> '" & id & "'"
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				losses = rs.Fields("Total").Value
			end if

		end sub

	end class %>

