<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/playoffs.asp" -->
<!-- #include file="includes/playoffsRank.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'If the playoffs rank'em pool is disabled, redirect to the home page.
	if not ENABLE_PLAYOFFS_RANK_POOL then
		Response.Redirect("./")
	end if

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = PlayoffsRankPoolTitle & " Pool Results"
	call BuildPageHeader("tableSort.css", "tableSort.js") %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Define the results table sort commands.
	//=========================================================================
	var resultsNameSort = {
		initialSort : true,
		tbodyID     : "resultsBody",
		theadID     : "resultsHead",
		sortColumns : [
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [],
			headColumns : []
		}
	}
	var resultsScoreSort = {
		tbodyID     : "resultsBody",
		theadID     : "resultsHead",
		sortColumns : [
			{ column : -2, descending : true  },
			{ column :  0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [-2, -1],
			headColumns : [-1]
		}
	}
	//]]></script>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Find the number of completed playoff games.
	dim completedGames
	completedGames = GetPlayoffsCompletedGameCount()

	'Get the current username.
	dim currentUser
	currentUser = Session(SESSION_USERNAME_KEY)

	'Set locked flag.
	dim isLocked
	isLocked = IsPlayoffsRoundLocked(1)

	'Build the list of playoffs teams.
	dim n
	dim teams
	dim i, j, k
	n = NumberConferences * NumberPlayoffsSeeds
	redim teams(n - 1)
	k = 0
	for i = 1 to NumberConferences
		for j = 1 to NumberPlayoffsSeeds
			set teams(k) = new TeamObj
			call teams(k).setData(i, j)
			k = k + 1
		next
	next

	'Sort the teams by date and time of last game (in reverse order). This
	'is so the footer display will show teams in the order they drop out of
	'contention.
	dim swap, tmp
	for i = 0 to UBound(teams) - 1
		for j = i + 1 to UBound(teams)
			swap = false
			if teams(j).dateTime < teams(i).dateTime then
				swap = true
			elseif teams(j).dateTime = teams(i).dateTime then
				if teams(j).id < teams(i).id then
					swap = true
				end if
			end if
			if swap then
				set tmp = teams(i)
				set teams(i) = teams(j)
				set teams(j) = tmp
			end if
		next
	next

	'Build the display.
	dim teamCols, otherCols
	teamCols = UBound(teams) + 1
	otherCols = 3 %>
	<table class="main" border="0" cellpadding="0" cellspacing="0">
		<thead id="resultsHead">
			<tr class="header bottomEdge sortable" valign="bottom">
				<th align="left"><a href="#" onclick="this.blur(); return tableSort.sort(resultsNameSort);" title="Sort by name.">Name</a></th>
<%	for i = 0 to UBound(teams) %>
				<th><% = i + 1 %></th>
<%	next %>
				<th align="left" colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(resultsScoreSort);" title="Sort by score.">Score</a></th>
			</tr>
		</thead>
		<tfoot>
			<tr class="subHeader topEdge bottomEdge" valign="top">
				<th align="left" colspan="<% = teamCols + otherCols %>">Playoffs Standings</th>
			</tr>
			<tr align="center">
				<td>&nbsp;</td>
<%	for i = 0 to UBound(teams) %>
				<td class="small"><% = teams(i).id %><br /><% = FormatRecord(teams(i).wins, teams(i).losses, 0) %></td>
<%	next %>
				<td colspan="2">&nbsp;</td>
			</tr>
<%	'Show the pot/payout.
	dim numEntries
	dim pot, list, str
	numEntries = GetPlayoffsRankEntryCount()
	if numEntries > 0 then
		pot = numEntries * PLAYOFFS_RANK_ENTRY_FEE
		list = GetPlayoffsRankWinnersList()
		str = ""
		if IsArray(list) then
			if UBound(list) > 0 then
				str = "Winners: " & Join(list, ", ") & " (" & FormatAmount(pot / (UBound(list) + 1)) & " each)"
			else
				str = "Winner: " & Join(list, ", ") & " (" & FormatAmount(pot) & ")"
			end if %>
			<tr class="header topEdge"><th align="left" colspan="<% = teamCols + otherCols %>"><% = str %></th></tr>
<%		else %>
			<tr class="subHeader topEdge"><th align="left" colspan="<% = teamCols + otherCols %>">Pot: <% = FormatAmount(pot) %></th></tr>
<%		end if
	end if %>
		</tfoot>
		<tbody id="resultsBody">
<%	'Get user data.
	dim users
	dim leadRankScore
	dim teamID
	dim sql, rs
	dim conf, score
	dim rankScore, rankScoreDiff
	dim hidePick
	dim alt
	list = GetPlayoffsRankPlayersList()
	if IsArray(list) then

		'Create an array of user objects.
		redim users(UBound(list))
		for i = 0 to UBound(list)
			set users(i) = new UserObj
			users(i).setData(list(i))
		next

		'Get the current leading score.
		if true then
			leadRankScore = 0
			for i = 0 to UBound(users)
				if IsNumeric(users(i).rankScore) then
					if users(i).rankScore > leadRankScore then
						leadRankScore = users(i).rankScore
					end if
				end if
			next
		end if

		'Display user picks and score.
		alt = false
		for i = 0 to UBound(users)
			if alt then %>
			<tr align="center" class="alt singleLine">
<%			else %>
			<tr align="center" class="singleLine">
<%			end if
			alt = not alt %>
				<td align="left"><% = users(i).name %></td>
<%			'Determine if rankings should be hidden.
			hidePick = false
			if not isLocked and not IsAdmin() and currentUser <> users(i).name then
				hidePick = true
			end if

			'Display rankings for this user.
			sql = "SELECT TeamID, Confidence FROM PlayoffsRanks" _
			   & " WHERE Username = '" & SqlEscape(users(i).name) & "'" _
			   & " ORDER BY Confidence"
			set rs = DbConn.Execute(sql)
			do while not rs.EOF
				teamID = rs.Fields("TeamID").Value
				conf   = rs.Fields("Confidence").Value

				'Format team and score.
				if hidePick then
					teamID = "xxx"
					score = "--"
				else

					'Find the matching team and calculate score.
					n = GetTeamIndex(teamID)
					score = conf * teams(n).wins

					if teams(n).wins > 0 then
						teamID = FormatCorrectPick(teamID)
					end if
					if teams(n).losses > 0 then
						teamID = FormatIncorrectPick(teamID)
					end if
					if teams(n).wins + teams(n).losses = 0 then
						score = "--"
					end if
				end if %>
				<td class="small"><% = teamID %><br /><% = score %></td>
<%				rs.MoveNext
			loop

			'Show how far behind the leader this user's score is.
			rankScore = "n/a&nbsp;&nbsp;&nbsp;"
			rankScoreDiff = "&nbsp;"
			if completedGames > 0 then
				rankScore = users(i).rankScore
				if rankScore < leadRankScore then
					rankScoreDiff = "(" & FormatScore(rankScore -leadRankScore, false) & ")"
				elseif score = leadRankScore then
					rankScoreDiff = "&nbsp;"
				end if
				rankScore = FormatScore(rankScore, false)
			end if %>
				<td align="right"><% = rankScore %></td>
				<td align="right"><span class="small"><% = rankScoreDiff %></span></td>
			</tr>
<%		next
	else %>
			<tr class="noSort">
				<td>&nbsp;</td>
				<td align="center" colspan="<% = teamCols %>" style="width: <% = teamCols * 2.25 %>em;"><em>No entries found.</em></td>
				<td colspan="<% = otherCols - 1 %>">&nbsp;</td>
			</tr>
<%	end if %>
		</tbody>
	</table>

	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Returns the index of the given team in the playoff teams list.
	'--------------------------------------------------------------------------
	function GetTeamIndex(id)

		for GetTeamIndex = 0 to UBound(teams)
			if teams(GetTeamIndex).id = id then
				exit function
			end if
		next
		GetTeamIndex = UBound(teams)

	end function

	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' TeamObj: Holds information for a single playoff team.
	'--------------------------------------------------------------------------
	class TeamObj

		public id
		public dateTime
		public wins, losses

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(conf, seed)

			dim sql, rs

			'Set the team properties.
			id       = TO_BE_DETERMINED_STR
			dateTime = Null
			wins     = 0
			losses   = 0

			'Get the team info.
			sql = "SELECT * FROM Teams" _
			   & " WHERE Conference = " & conf _
			   & " AND PlayoffsSeed = " & seed
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				id = rs.Fields("TeamID").Value
			end if

			'Find the date and time of the teams latest playoff game.
			sql = "SELECT [DateTime] FROM PlayoffsSchedule" _
			   & " WHERE VisitorID  = '" & id & "' OR HomeID = '" & id & "'" _
			   & " ORDER BY [DateTime] DESC"
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				dateTime = CDate(rs.Fields("DateTime").Value)
			end if

			'Get the number of wins the team has.
			sql = "SELECT COUNT(Result) AS Total FROM PlayoffsSchedule" _
			   & " WHERE Result  = '" & id & "'"
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				wins = rs.Fields("Total").Value
			end if

			'Get the number of losses the team has.
			sql = "SELECT COUNT(Result) AS Total FROM PlayoffsSchedule" _
			   & " WHERE (VisitorID = '" & id & "' OR HomeID = '" & id & "')" _
			   & " AND Result IS NOT NULL AND Result <> '" & id & "'"
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				losses = rs.Fields("Total").Value
			end if

		end sub

	end class

	'--------------------------------------------------------------------------
	' UserObj: Holds information for a single user.
	'--------------------------------------------------------------------------
	class UserObj

		public name
		public rankScore

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(username)

			'Set the user properties.
			name = username
			rankScore = GetPlayoffsRankScore(username)

		end sub

	end class %>

