<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/playoffs.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Playoffs Schedule"
	call BuildPageHeader("", "") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Build the display.
	dim cols
	cols = 10
	if USE_POINT_SPREADS then
		cols = cols + 1
	end if %>
	<table class="main" border="0" cellpadding="0" cellspacing="0">
<%	dim i
	dim numRounds
	dim lastRound, gameRound, conference
	dim gameID, gameDate, gameTime
	dim vid, hid, visitor, home
	dim vscore, hscore, spread
	dim ot, result, atsResult
	dim sql, rs
	dim alt
	numRounds = GetPlayoffsRoundCount()
	sql = "SELECT * FROM PlayoffsSchedule ORDER BY Round, [DateTime]"
	set rs = DbConn.Execute(sql)
	if not (rs.EOF and rs.BOF) then
		i = 0
		lastRound = 0
		alt = false
		do while not rs.EOF
			gameID    = rs.Fields("GameID").Value
			gameRound = rs.Fields("Round").Value
			gameDate  = rs.Fields("DateTime").Value
			gameTime  = rs.Fields("DateTime").Value
			vid       = rs.Fields("VisitorID").Value
			vscore    = rs.Fields("VisitorScore").Value
			spread    = rs.Fields("PointSpread").Value
			hid       = rs.Fields("HomeID").Value
			hscore    = rs.Fields("HomeScore").Value
			ot        = rs.Fields("OT").Value
			result    = rs.Fields("Result").Value
			atsResult = rs.Fields("ATSResult").Value

			'Get the conference of the teams playing.
			if gameRound <> numRounds and not IsNull(hid) then
				conference = "(" & ConferenceNames(GetConference(hid) - 1) & ")"
			else
				conference = "&nbsp;"
			end if

			if gameRound <> lastRound then
				lastRound = gameRound
				i = 1
				if gameRound = 1 then %>
		<tr class="header bottomEdge">
<%				else %>
		<tr class="header topEdge bottomEdge">
<%				end if %>
			<th align="left" colspan="<% = cols %>"><% = PlayoffRoundNames(gameRound - 1) %></th>
		</tr>
<%			end if

			'Set the team names for display.
			visitor = GetTeamName(rs.Fields("VisitorID").Value)
			home    = GetTeamName(rs.Fields("HomeID").Value)

			'Highlight the results.
			if result = vid then
				visitor = FormatWinner(visitor)
				vscore  = FormatWinner(vscore)
			elseif result = hid then
				home   = FormatWinner(home)
				hscore = FormatWinner(hscore)
			end if
			if atsResult = rs.Fields("VisitorID").Value then
				visitor = FormatATSWinner(visitor)
				vscore  = FormatATSWinner(vscore)
			elseif atsResult = rs.Fields("HomeID").Value then
				home   = FormatATSWinner(home)
				hscore = FormatATSWinner(hscore)
			end if


			if alt then %>
		<tr align="right" class="alt">
<%			else %>
		<tr align="right">
<%			end if
			alt = not alt %>
			<td><% = WeekdayName(Weekday(gameDate), true) %></td>
			<td><% = FormatDate(gameDate) %></td>
			<td><% = FormatTime(gameTime) %></td>
			<td><% = conference %></td>
			<td align="left"><% call DisplayTeamLogo(vid) %><% = visitor %></td>
			<td><% = vscore %></td>
<%			if USE_POINT_SPREADS then %>
			<td><% = FormatPointSpread(spread) %></td>
<%			end if %>
			<td><% = GetConjunction(gameRound) %>
			<td align="left"><% call DisplayTeamLogo(hid) %><% = home %></td>
			<td><% = hscore %></td>
			<td align="left">
<%			if ot = 0 then %>
				&nbsp;
<%			elseif ot = 1 then %>
				<span class="small">OT</span>
<%			else %>
				<span class="small">OT(<% = ot %>)</span>
<%			end if %>
			</td>
		</tr>
<%			rs.MoveNext
		loop %>
	</table>
<%	end if %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
