<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/playoffsRank.asp" -->
<%	'Limit access to the Administrator.
	call CheckAccess(true)

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Set Playoffs Teams"
	call BuildPageHeader("loadDialogs.css", "") %>
	<script type="text/javascript">//<![CDATA[
<%	if SHOW_TEAM_LOGOS then %>
	//=========================================================================
	// Module: teamLogo
	//
	// Used to update the team logo shown next to a drop down list when a team
	// selection is changed.
	//=========================================================================
	var teamLogo = function () {

		//---------------------------------------------------------------------
		// Initializes the team logos.
		//---------------------------------------------------------------------
		function init() {

			// Add IDs to each team logo span.
			var elList = document.getElementsByTagName("SPAN");
			var n = 1;
			for (var i = 0; i < elList.length; i++)
				if (domUtils.hasClass(elList[i], "teamLogo")) {
					elList[i].id = "logo-" + n;
					n++;
				}

			// Scan the form and set the logo for any selected teams.
			var formEl = document.getElementById("teamsForm");
			var el;
			i = 1;
			while ((el = formEl.elements["id-" + i]) != null) {
				var teamId = formEl.elements["id-" + i].value;
				setLogo("logo-" + i, teamId);
				i++;
			}
		}

		//---------------------------------------------------------------------
		// Sets the specified team logo.
		//---------------------------------------------------------------------
		function setLogo(elId, teamId) {

			var el = document.getElementById(elId);
			if (el == null)
				return;
			el.className = "teamLogo";
			if (teamId != "")
				el.className += " " + teamId;
		}

		//=====================================================================
		// Initialization code.
		//=====================================================================

		// Initialize on page load.
		domUtils.onready(init);

		//=====================================================================
		// Public properties and methods.
		//=====================================================================
		return {

			//-----------------------------------------------------------------
			// Change the logo to match the selected team.
			//-----------------------------------------------------------------
			update : function (elId, teamId) {

				setLogo(elId, teamId);
				return true;
			}
		}
	}();
<%	end if %>
	//=========================================================================
	// Module: teamsLoader
	//
	// Used to set the playoffs teams using data retrieved from the server.
	//=========================================================================
	var teamsLoader = function () {

		// Define an array to hold form field information for each team listed
		// on the form.
		var teamFields = [];

		// Create an XMLHttpRequest object for loading the teams data.
		var xhr = new XHR();
		xhr.url = "standings.asp";
		xhr.queryString = "type=seeds";
		xhr.successCallback = getTeamsSuccess;
		xhr.failureCallback = getTeamsFailure;

		// Set interval timer.
		var loadChecker   =  null;
		var loadMaxWait   = 15000;
		var loadStartTime =     0;

		// Holds the data retrieved from the load.
		var teamData = null;

		// Used for the dialog message.
		var resultMsg  = "";
		var errorMsg   = "";
		var foundNewResults = false;

		//---------------------------------------------------------------------
		// Initializes the teams loader.
		//---------------------------------------------------------------------
		function init() {

			// Scan the form and build the team fields array.
			var formEl = document.getElementById("teamsForm");
			var i = 1;
			var el;
			while ((el = formEl.elements["id-" + i]) != null)
			{
				var conf = formEl.elements["conference-" + i].value;
				var seed = formEl.elements["seed-" + i].value;
				var id   = formEl.elements["id-" + i].value;
				teamFields.push({
					conf : conf,
					seed : seed,
					id   : id,
					idEl : el
				});
				i++;
			}
		}

		//---------------------------------------------------------------------
		// Initiates the retrieval of playoffs teams data.
		//---------------------------------------------------------------------
		function getTeams() {

			// Clear any existing team data.
			teamData = [];

			// Clear any highlighting on the form fields.
			for (var i = 0; i < teamFields.length; i++)
				domUtils.removeClass(teamFields[i].idEl, "fieldLoaded");

			// Initialize the display.
			foundNewResults = false;
			resultMsg = "";
			errorMsg = "";
			showLoadingDisplay("loadingActive");

			// Initiate the request and set an interval timer to monitor it.
			try {
				getTeamsCleanUp();
				xhr.get();
				loadStartTime = new Date();
				loadChecker = setInterval(teamsLoadedCheck, 500);
			}
			catch(ex) {
				getTeamsCleanUp();
				errorMsg = "Could not retrieve teams data.";
				showLoadingDisplay("loadingError");
			}

			return false;
		}

		//---------------------------------------------------------------------
		// Called by an interval timer to determine if the teams data page has 
		// been loaded.
		//---------------------------------------------------------------------
		function teamsLoadedCheck() {

			// Has the max wait time been exceeded?
			var currentTime = new Date();
			if (currentTime.valueOf() - loadStartTime.valueOf() > loadMaxWait) {
				// Yes, abort.
				getTeamsCleanUp();
				errorMsg = "The operation timed out, try again later.";
				showLoadingDisplay("loadingError");
				return;
			}
		}

		//---------------------------------------------------------------------
		// Cleans up after an attempt to load teams data.
		//---------------------------------------------------------------------
		function getTeamsCleanUp() {

			// Clear the interval timer.
			if (loadChecker != null)
			{
				clearInterval(loadChecker);
				loadChecker = null;
			}

			// Abort the request.
			xhr.abort();
		}

		//---------------------------------------------------------------------
		// Callback for a successful get teams request.
		//---------------------------------------------------------------------
		function getTeamsSuccess(reqObj) {

			try {

				// Parse the returned data and process it.
				var teamsObj;
				eval("teamsObj = " + reqObj.responseText);
				teamData = teamsObj.playoffsTeams;
				setTeamFields();
				getTeamsCleanUp();
				if (foundNewResults)
					hideLoadingDisplay();
				else
					showLoadingDisplay("loadingComplete");
			}
			catch(ex) {
				getTeamsCleanUp();
				errorMsg = "Could not retrieve teams data.";
				showLoadingDisplay("loadingError");
			}
		}

		//---------------------------------------------------------------------
		// Callback for a failed get teams request.
		//---------------------------------------------------------------------
		function getTeamsFailure(reqObj) {

			getTeamsCleanUp();
			errorMsg = "Could not retrieve teams data.";
			showLoadingDisplay("loadingError");
		}

		//---------------------------------------------------------------------
		// Takes the parsed teams data and updates the appropriate form fields.
		//---------------------------------------------------------------------
		function setTeamFields() {

			// For each team found, find a matching set of form fields.
			if (teamData.length > 0)
			{
				resultMsg = "No changes to currently selected playoffs teams found.";
				for (var i = 0; i < teamFields.length; i++)
					for (var j = 0; j < teamData.length; j++)

						// Look for a matching conference and seed.
						if (teamFields[i].conf == teamData[j].conf && teamFields[i].seed == teamData[j].seed) {

							// Compare the team IDs.
							if (teamFields[i].idEl.value != teamData[j].id) {
								foundNewResults = true;

								// Set the form field.
								teamFields[i].idEl.value = teamData[j].id;
								domUtils.addClass(teamFields[i].idEl, "fieldLoaded");
<%	if SHOW_TEAM_LOGOS then %>
								// Update the logo.
								teamLogo.update("logo-" + (i + 1), teamFields[i].idEl.value);
<%	end if %>
							}
							break;
						}
			}
			else
				resultMsg = "Could not determine playoffs teams, try again later.";
		}

		//---------------------------------------------------------------------
		// Shows the loading display with the specified message box.
		//---------------------------------------------------------------------
		function showLoadingDisplay(id) {

			// Hide all the message boxes.
			document.getElementById("loadingActive").style.display   = "none";
			document.getElementById("loadingComplete").style.display = "none";
			document.getElementById("loadingError").style.display    = "none";

			// Set the result and error messages.
			var el = document.getElementById("loadingResultMsg");
			while (el.firstChild != null)
				el.removeChild(el.firstChild);
			document.getElementById("loadingResultMsg").appendChild(document.createTextNode(resultMsg));
			var el = document.getElementById("loadingErrorMsg");
			while (el.firstChild != null)
				el.removeChild(el.firstChild);
			document.getElementById("loadingErrorMsg").appendChild(document.createTextNode(errorMsg));

			// Show the specified message box.
			el = document.getElementById(id);
			if (el != null)
				el.style.display  = "";

			// Make it visible.
			document.getElementById("loadingDisplay").style.visibility = "visible";
		}

		//---------------------------------------------------------------------
		// Hides the loading display.
		//---------------------------------------------------------------------
		function hideLoadingDisplay() {

			document.getElementById("loadingDisplay").style.visibility = "hidden";
		}

		//=====================================================================
		// Initialization code.
		//=====================================================================

		// Initialize on page load.
		domUtils.onready(init);

		//=====================================================================
		// Public properties and methods.
		//=====================================================================
		return {

			//-----------------------------------------------------------------
			// Loads the playoffs teams.
			//-----------------------------------------------------------------
			load : function (week) {

				getTeams();
				return false;
			},

			//-----------------------------------------------------------------
			// Cancels a load.
			//-----------------------------------------------------------------
			cancel : function () {

				getTeamsCleanUp();
				hideLoadingDisplay();
				return false;
			},

			//-----------------------------------------------------------------
			// Closes the load display.
			//-----------------------------------------------------------------
			close : function () {

				hideLoadingDisplay();
				return false;
			}
		}
	}();
	//]]></script>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/email.asp" -->
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'If there are any entries, show a warning message.
	if Request.ServerVariables("Content_Length") = 0  then
		if GetPlayoffsRankEntryCount() > 0 then
			call DisplayWarningMessage("Warning: There are existing entries for this pool. Updating playoffs teams may invalidate them.")
		end if
	end if

	'If there is form data, process it.
	dim n
	dim i, j
	dim id1, id2
	dim id, seed
	dim sql
	dim notify, infoMsg
	if Request.ServerVariables("Content_Length") > 0 and not IsCancelRequest() then

		'Process an update request.
		if Request.Form("submit") = "Update" then

			'Validate the form fields.
			n = NumberConferences * NumberPlayoffsSeeds

			'Make sure each team is specified only once.
			for i = 1 to n - 1
				id1 = Trim(Request.Form("id-" & i))
				if id1 <> "" then
					for j = i + 1 to n
						id2 = Trim(Request.Form("id-" & j))
						if id1 = id2 then
							FormFieldErrors.Add "id-" & j, GetTeamName(id2) & " is already assigned to a playoffs slot."
						end if
					next
				end if
			next

			'If there were any errors, display the error summary message.
			'Otherwise, do the updates.
			if FormFieldErrors.Count > 0 then
				call DisplayFormFieldErrorsMessage("Error: Invalid fields. Please correct and resubmit.")
			else

				'Clear any existing playoff seedings.
				sql = "UPDATE Teams SET PlayoffsSeed = NULL"
				DbConn.Execute(sql)

				'Set playoff seedings.
				for i = 1 to n
					id   = Trim(Request.Form("id-"   & i))
					seed = Trim(Request.Form("seed-" & i))
					if IsNumeric(seed) then
						sql = "UPDATE Teams SET" _
						   & " PlayoffsSeed = " & seed _
						   & " WHERE TeamID = '" & id & "'"
						call DbConn.Execute(sql)
					end if
				next

				'Send out email notifications, if checked.
				infoMsg = "Update successful."
				notify = Trim(Request.Form("notify"))
				if LCase(notify) = "true" then
					infoMsg = "Update successful, notifications sent."
					call SendNotifications()
				end if

				'Updates done, show an informational message.
				call DisplaySuccessMessage(infoMsg)
			end if
		end if
	end if

	'Get all teams.
	dim rsTeams
	set rsTeams = GetTeamsRecordset()

	'Build the display.
	dim alt
	dim conference
	dim confName, className
	dim isSelected, isCalculated %>
	<form id="teamsForm" action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<table border="0" cellpadding="0" cellspacing="0"><tr><td style="padding: 0px;">
		<table class="main" border="0" cellpadding="0" cellspacing="0">
<%	n = 1
	for conference = 1 to NumberConferences
		confName = ConferenceNames(conference - 1)
		className = LCase(confName)
		 if conference > 1 then
		 	className = "topEdge " & className
		end if %>
			<tr class="header bottomEdge <% = className %>" valign="bottom">
				<th align="left" colspan="2"><% = confName %> Playoff Teams</th>
			</tr>
<%		alt = false
		for seed = 1 to NumberPlayoffsSeeds
			if alt then %>
			<tr class="alt singleLine">
<%			else %>
			<tr class="singleLine">
<%			end if
			alt = not alt %>
				<td align="right" style="width: 1em;"><input type="hidden" name="conference-<% = n %>" value="<% = conference %>" /><input type="hidden" name="seed-<% = n %>" value="<% = seed %>" /><% = seed %>.</td>
				<td style="width: 38em;">
					<% call DisplayTeamLogo("") %>
					<select name="id-<% = n %>" class="<% = StyleFormField("", "id-" & n) %>" style="width: 14em;"<% if SHOW_TEAM_LOGOS then Response.Write(" onchange=""return teamLogo.update('logo-" & n & "', this.value);""") end if %>>
						<option value=""></option>
<%			rsTeams.MoveFirst
			do while not rsTeams.EOF
				if rsTeams.Fields("Conference").Value = conference then

					'Determine if this team should be selected.
					isSelected = false
					if not IsCancelRequest() and FormFieldExists("id-" & n) then
						if rsTeams.Fields("TeamID").Value = Request.Form("id-" & n) then
							isSelected = true
						end if
					elseif rsTeams.Fields("PlayoffsSeed").Value = seed then
						isSelected = true
					end if %>
						<option value="<% = rsTeams.Fields("TeamID").Value %>"<% if isSelected then Response.Write(" selected=""selected""") end if %>><% = rsTeams.Fields("City").Value & " " & rsTeams.Fields("Name").Value %></option>
<%				end if
				rsTeams.MoveNext
			loop %>
					</select>
				</td>
<%			n = n + 1 %>
			</tr>
<%		next
	next
	if SERVER_EMAIL_ENABLED then %>
			<tr class="subHeader topEdge">
				<th align="left" colspan="2"><input type="checkbox" id="notify" name="notify" value="true" /> <label for="notify">Send update notification to users.</label></th>
			</tr>
<%	end if %>
		</table>
		<p></p>
		<table border="0" cellpadding="0" cellspacing="0" style="width: 100%;">
			<tr valign="middle">
				<td style="padding: 0px;"><input type="submit" name="submit" value="Update" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></td>
				<td align="right" style="padding: 0px;"><input type="submit" name="submit" value="Load" class="button" onclick="return teamsLoader.load();" /></td>
			</tr>
		</table>
		</td></tr></table>
	</form>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
	<div id="loadingDisplay" style="visibility: hidden;">
 		<div id="loadingDialog">
			<div id="loadingActive">
				<h2><em>Loading...</em></h2>
				<form action="#" method="post" onsubmit="return false;">
					<p><img src="graphics/loading.gif" alt="" /></p>
					<p><input type="submit" name="submit" value="Cancel" class="button" onclick="return teamsLoader.cancel();" /></p>
				</form>
			</div>
			<div id="loadingComplete">
				<h2>Load Complete</h2>
				<form action="#" method="post" onsubmit="return false;">
					<div class="successMsg"><div><span id="loadingResultMsg"></span></div></div>
					<p><input type="submit" name="submit" value="Close" class="button" onclick="return teamsLoader.close();" /></p>
				</form>
			</div>
			<div id="loadingError">
				<h2>Load Failed</h2>
				<form action="#" method="post" onsubmit="return false;">
					<div class="errorMsg"><div><span id="loadingErrorMsg"></span></div></div>
					<p><input type="submit" name="submit" value="Close" class="button" onclick="return teamsLoader.close();" /></p>
				</form>
			</div>
		</div>
	</div>
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Sends an email notification to any users who have elected to receive
	' them.
	'--------------------------------------------------------------------------
	sub SendNotifications()

		dim subj, body
		dim sql, rs
		dim conf, lastConf
		dim list, email

		subj = PlayoffsRankPoolTitle & " Pool Update Notification"
		body = "Playoffs teams have been updated." & vbCrLf & vbCrLf

		'Show the teams.
		sql = "SELECT * FROM TEAMS" _
		   & " WHERE PlayoffsSeed IS NOT NULL" _
		   & " ORDER BY Conference, PlayoffsSeed"
		set rs = DbConn.Execute(sql)
		lastConf = 0
		do while not rs.EOF
			conf = rs.Fields("Conference").Value
			if conf <> lastConf then
				body = body & ConferenceNames(conf - 1) & vbCrLf
				lastConf = conf
			end if
			body = body & rs.Fields("PlayoffsSeed").Value & ". " & rs.Fields("City").Value & " " & rs.Fields("Name").Value & vbCrLf
			rs.MoveNext
		loop
		body = body & vbCrLf

		list = GetNotificationList("NotifyOfNewsUpdates")
		for each email in list
			call SendMail(email, subj, body)
		next

	end sub %>

