<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/side.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'If the side pool is disabled, redirect to the home page.
	if not ENABLE_SURVIVOR_POOL and not ENABLE_MARGIN_POOL then
		Response.Redirect("./")
	end if

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = SidePoolTitle & " Pool Entry Form"
	call BuildPageHeader("", "") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Get the week to display.
	dim week
	week = GetRequestedWeek()

	'If the user is the Administrator, check for a user name in the request.
	'Otherwise, show data for the current user.
	dim username
	username = Session(SESSION_USERNAME_KEY)
	if IsAdmin() then
		username = Trim(Request("username"))
	end if

	'Initialize lock flags.
	dim allLocked, anyLocked
	allLocked = IsWeekLocked(week)
	anyLocked = allLocked

	'Create an array of game objects
	dim games, rs, n
	dim i
	n = GetGameCount(week)
	redim games(n - 1)
	set rs = GetGamesRecordset(week)
 
	if not (rs.EOF and rs.BOF) then
		i = 0
		do while not rs.EOF
			set games(i) = new GameObj
			games(i).setData(rs)
			i = i + 1
			rs.MoveNext
		loop
	end if
 
	'If the survivor pool is enabled, determine if it has already been
	'concluded.
	dim finalWeek, isSurvivorOver
	if ENABLE_SURVIVOR_POOL then
		call GetCurrentSurvivorPoolStatus()
	end if

	'Determine if the user is eligible to make an entry.
	'Note: All users are eligible the first week of the pool. After that, only
	'users who entered that first week are eligible.
	dim isEntryAllowed
	isEntryAllowed = false
	if username <> "" then
		if InSidePool(username) or (week = SIDE_START_WEEK and (IsAdmin() or not allLocked)) then
			isEntryAllowed = true
		end if
	end if

	'If the survivor pool is enabled, determine if the user can buyback into the
	'pool
	dim allowBuyback, hasBuyback
	allowBuyback = false
	hasBuyback   = false
	if isEntryAllowed and ENABLE_SURVIVOR_POOL then
		allowBuyback = IsSurvivorBuybackAllowed(username, week)
		hasBuyback = HasSurvivorBuyback(username, week)
	end if

	'For the Administrator, build a user selection list.
	if IsAdmin() then %>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<table class="main" border="0" cellpadding="0" cellspacing="0">
		<tr class="header bottomEdge">
			<th align="left">Administrator Access</th>
		</tr>
		<tr>
			<td class="adminSection freeForm">
				<p>You may view or edit any player's entry form by selecting a username below.<br />
				Use the links at the bottom of the page to switch to a specific week.</p>
				<table border="0" cellpadding="0" cellspacing="0">
					<tr valign="middle">
						<td><strong>Select user:</strong></td>
						<td>
							<input type="hidden" name="week" value="<% = week %>" />
							<select name="username">
								<% call DisplayUserSelectList(GetUserList(true), username) %>
							</select>
						</td>
						<td><input type="submit" name="submit" value="Select" class="button" /></td>
					</tr>
				</table>
			</td>
		</tr>
		</table>
	</form>
<%		if username <> "" then %>
	<h2>Entry Form for <% = username %></h2>
<%		end if
	end if

	dim hasEntry
	dim sidePick, sidePickLocked
	dim usedTeams
	hasEntry = false

	if username <> "" then
       
		'Determine if the user has an entry for the given week (so we can
		'display the Delete button) and get its lock status.
		sidePick = GetSidePick(username, week)
		if sidePick <> "" then
			hasEntry = true
			sidePickLocked = IsSidePickLocked(sidePick, week)
		else
			sidePick = GetFieldValue("sidePick", sidePick)
			sidePickLocked = allLocked
		end if

		'Get a list of teams already used by the player.
		usedTeams = GetUsedSidePicksList(username)
	end if
   
	'If there is form data, process it.
	dim sql
	dim needDeleteConfirmation, entryDeleted
	needDeleteConfirmation = false
	entryDeleted = false

	'Check for a buyback.
	dim buyback
	if Request.ServerVariables("Content_Length") > 0 and not IsCancelRequest() then
		buyback = FormFieldExists("buyback")
	else
		buyback = hasBuyback
	end if

	'Process a delete request.
	if Request.Form("submit") = "Delete" then
		if not IsAdmin() and sidePickLocked then
			call DisplayErrorMessage("Error: The game for your current pick has been locked, entry cannot be deleted.")
		elseif LCase(Request.Form("confirmDelete")) <> "true" then
			needDeleteConfirmation = true
			call DisplayWarningMessage("To confirm deletion, check the box below and press <code>Delete</code> again. Pressing any other button will cancel the deletion.")
		elseif (ENABLE_SURVIVOR_POOL and isSurvivorOver and not ENABLE_MARGIN_POOL) or (ENABLE_MARGIN_POOL and IsArray(GetMarginWinnersList())) then
			call DisplayErrorMessage("Error: The " & LCase(SidePoolTitle) & "  pool has been concluded, cannot delete entries.")
		else

			'Delete the player's entry.
			sql = "DELETE FROM SidePicks" _
			   & " WHERE Username = '" & SqlEscape(username) & "'" _
			   & " AND Week = " & week
			call DbConn.Execute(sql)
			entryDeleted = true
			hasEntry = false

			'Clear the player's pick.
			sidePick = ""
			usedTeams = GetUsedSidePicksList(username)

			'If the survivor pool is enabled, update the current status.
			if ENABLE_SURVIVOR_POOL then
				call ClearSurvivorStatus(week)
				call GetCurrentSurvivorPoolStatus()
			end if

			'If the margin pool is enabled, clear any saved results.
			if ENABLE_MARGIN_POOL then
				call ClearMarginResultsCache(week)
			end if

			call DisplaySuccessMessage("Entry has been deleted.")
		end if

	'Process an update request.
	elseif Request.Form("submit") = "Update" then

		'Get the new pick
		dim newSidePick, newSidePickLocked
		newSidePick = Request.Form("sidePick")
		newSidePickLocked = IsSidePickLocked(newSidePick, week)
     
		'Prevent entries by the Admin.
		if username = ADMIN_USERNAME then
			call DisplayErrorMessage("Error: User '" & ADMIN_USERNAME & "' may not make picks.")

		'If the user is disabled, prevent the entry.
		elseif IsDisabled() then
			call DisplayErrorMessage("Error: Your account has been disabled, change not accepted. Please contact the Administrator.")

		'If only the survivor pool is enabled and it is over, prevent the
		'entry.
		elseif not ENABLE_MARGIN_POOL and isSurvivorOver then
			call DisplayErrorMessage("Error: The survivor pool has been concluded, entries no longer accepted.")

		'If the player is not eligible to make an entry, prevent it.
		elseif not isEntryAllowed then
			call DisplayErrorMessage("Error: You are not eligible to make entries in this pool.")

		'If all games have been locked, prevent any updates (except by the
		'Admin).
		elseif not IsAdmin() and allLocked then
			call DisplayErrorMessage("Error: All games for this week have been locked, change not accepted.")

		'If the current pick has been locked, prevent any updates (except by
		'the Admin).
		elseif not IsAdmin() and sidePickLocked then
			call DisplayErrorMessage("Error: The " & GetTeamName(sidePick) & " game has been locked, change not accepted.")
		elseif not IsAdmin() and newSidePickLocked then
			call DisplayErrorMessage("Error: The " & GetTeamName(newSidePick) & " game has been locked, change not accepted.")

		'If a buyback is requested but not allowed, prevent the update.
		elseif buyback and not allowBuyback then
			call DisplayErrorMessage("Error: You are not eligible to buyback into the pool.")

		'Otherwise, process the request.
		else

			'Make sure a pick was made.
			if newSidePick = "" then
				FormFieldErrors.Add "sidePick", "You must select a team."
			else

				'Validate the team has not been used.
				if newSidePick <> sidePick then
					if IsArray(usedTeams) then
						if InList(newSidePick, usedTeams) then
							FormFieldErrors.Add "sidePick", GetTeamName(newSidePick) & " has already been used."
						end if
					end if
				end if
			end if

			'If only the survivor pool is active, check if a buyback is required.
			if not ENABLE_MARGIN_POOL then
				if allowBuyback and not buyback then
					FormFieldErrors.Add "buyback", "You must use a buyback to continue in the pool."
				end if
			end if
   
			'If there were any errors, display the error message. Otherwise, do
			'the updates.
			if FormFieldErrors.Count > 0 then
				call DisplayFormFieldErrorsMessage("Error: Invalid fields. Please correct and resubmit.")
			else
				sql = "DELETE FROM SidePicks" _
				   & " WHERE Week = " & week _
				   & " AND Username = '" & SqlEscape(username) & "'"
				call DbConn.Execute(sql)
				sql = "INSERT INTO SidePicks" _
				   & " (Week, Username, Pick, SurvivorBuyback, MarginScore)" _
				   & " VALUES(" & week & ", " _
				   & "'" & SqlEscape(username) & "', " _
				   & "'" & newSidePick & "', " _
				   & "'" & buyback & "', " _
				   & "NULL)"
            
				call DbConn.Execute(sql)
   
				'If the survivor pool is enabled, update the current status.
				if ENABLE_SURVIVOR_POOL then
					call ClearSurvivorStatus(week)
					call GetCurrentSurvivorPoolStatus()
				end if
                
				'Updates complete, redirect to the side pool standings page.
				Response.Redirect("sideStandings.asp")
			end if
		end if
	end if


	'Build the entry form for that week.
	if username <> "" then
		dim cols
		cols = 8
		if anyLocked then
			cols = cols + 1
		end if

		dim completed, wasAlive, isAlive, isPending, survivorStatus
		dim currentScore, lastTotal, currentTotal, score, scoreStr
		dim footnote

		'If the survivor pool is enabled, determine the player's status for
		'that week.
		if ENABLE_SURVIVOR_POOL then
			completed = 0
			wasAlive  = false
			isAlive   = false
			isPending = false
			set rs = GetSurvivorStatus(username, week)
			if not (rs.EOF and rs.BOF) then
				completed = rs.Fields("Completed").Value
				wasAlive  = rs.Fields("WasAlive").Value
				isAlive   = rs.Fields("IsAlive").Value
				isPending = rs.Fields("IsPending").Value
			elseif week = SIDE_START_WEEK and (IsAdmin() or not allLocked) then
				wasAlive = true
				isAlive  = true
			end if

		end if %>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<div>
<%		if IsAdmin() then %>
			<input type="hidden" name="username" value="<% = username %>" />
<%		end if %>
			<input type="hidden" name="week" value="<% = week %>" />
		</div>
		<table border="0" cellpadding="0" cellspacing="0"><tr><td style="padding: 0px;">
		<table class="main" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge">
			  <th align="left" colspan="<% = cols %>">Week <% = week %></th>
			</tr>
<%		'Show all games for that week.
		dim visitor, home
		dim vpicked, hpicked
		dim vused, hused
		dim alt
		alt = false
		n = 1
		for i = 0 to UBound(games)
			if alt then %>
			<tr align="right" class="alt singleLine">
<%			else %>
			<tr align="right" class="singleLine">
<%			end if
			alt = not alt

			'Get team names.
			visitor = games(i).visitorName
			home    = games(i).homeName

			'Highlight fields based on the game result.
			if games(i).result = games(i).visitorID then
				visitor = FormatCorrectPick(visitor)
			elseif games(i).result = games(i).homeID then
				home = FormatCorrectPick(home)
			end if

			'Show the lock icon, if appropriate.
			if anyLocked then
				if games(i).isLocked then %>
				<td align="center"><img src="graphics/locked.png" alt="Locked" /></td>
<%				else %>
				<td>&nbsp;</td>
<%				end if
			end if %>
				<td align="left"><% = WeekdayName(Weekday(games(i).dateTime), true) %></td>
				<td><% = FormatDate(games(i).dateTime) %></td>
				<td><% = FormatTime(games(i).dateTime) %></td>
<%			'Handle the display if any of the following is true:
			' - The player is not participating in the side pool.
			' - The side pool has not started yet.
			' - Only the survivor pool is active and it is over.
			' - Only the survivor pool is active, the player has been
			'   eliminated and a buyback isn't allowed.
			' - The game is locked and the player did not pick one of the two
			'   teams.
			' In other words, any case where neither team is a valid pick.
			if not IsEntryAllowed or _
			   week < SIDE_START_WEEK or (not ENABLE_MARGIN_POOL and isSurvivorOver) or _
			   (not IsAlive and not wasAlive and not isPending and not ENABLE_MARGIN_POOL and not (hasBuyback or allowBuyback)) or _
			   (games(i).isLocked and not IsAdmin() and sidePick <> games(i).visitorID and sidePick <> games(i).homeID) then %>
				<td>&nbsp;</td>
				<td align="left"><% call DisplayTeamLogo(games(i).visitorID) %><% = visitor %><% call DisplayTeamRecord(games(i).visitorID, week, false) %></td>
				<td>at</td>
				<td>&nbsp;</td>
				<td align="left"><% call DisplayTeamLogo(games(i).homeID) %><% = home %><% call DisplayTeamRecord(games(i).homeID, week, false) %></td>
<%			'Handle the display if the player's current pick is locked.
			elseif not IsAdmin() and sidePickLocked then
				vPicked = "&nbsp;"
				hPicked = "&nbsp;"
				if sidePick = games(i).visitorID then
					vpicked = "X"
				elseif sidePick = games(i).homeID then
					hpicked = "X"
				end if

				'Format a correct/incorrect pick.
				if games(i).result <> "" then
					if sidePick = games(i).result then
						if sidePick = games(i).visitorID then
							vpicked = FormatCorrectPick(vpicked)
						elseif sidePick = games(i).homeID then
							hpicked = FormatCorrectPick(hpicked)
						end if
					else
						if sidePick = games(i).visitorID then
							vpicked = FormatIncorrectPick(vpicked)
						elseif sidePick = games(i).homeID then
							hpicked = FormatIncorrectPick(hpicked)
						end if
					end if
				end if

				'Pad the pick displays.
				vpicked = "&nbsp;&nbsp;" & vpicked & "&nbsp;&nbsp;"
				hpicked = "&nbsp;&nbsp;" & hpicked & "&nbsp;&nbsp;" %>
				<td><% = vpicked %></td>
				<td align="left"><% call DisplayTeamLogo(games(i).visitorID) %><% = visitor %><% call DisplayTeamRecord(games(i).visitorID, week, false) %></td>
				<td>at</td>
				<td><% = hpicked %></td>
				<td align="left"><% call DisplayTeamLogo(games(i).homeID) %><% = home %><% call DisplayTeamRecord(games(i).homeID, week, false) %></td>
<%			'Handle the display for an unlocked game. Note that each team can
			'only be picked if it has not been used in another week.
			else
				if sidePick = games(i).visitorID or not InList(games(i).visitorID, usedTeams) then
					n = n + 1 %>
				<td align="center"><span class="<% = StyleFormField("fieldWrapper", "sidePick") %>"><input type="radio" id="sidePick-<% = n %>" name="sidePick" value="<% = games(i).visitorID %>"<% if sidePick = games(i).visitorID then Response.Write(CHECKED_ATTRIBUTE) end if %> /></span></td>
				<td align="left"><label for="sidePick-<% = n %>"><% call DisplayTeamLogo(games(i).visitorID) %><% = visitor %><% call DisplayTeamRecord(games(i).visitorID, week, false) %></label></td>
<%				else %>
				<td>&nbsp;</td>
				<td align="left"><% call DisplayTeamLogo(games(i).visitorID) %><% = visitor %><% call DisplayTeamRecord(games(i).visitorID, week, false) %></td>
<%				end if %>
				<td>at</td>
<%				if sidePick = games(i).homeID or not InList(games(i).homeID, usedTeams) then
					n = n + 1 %>
				<td align="center"><span class="<% = StyleFormField("fieldWrapper", "sidePick") %>"><input type="radio" id="sidePick-<% = n %>" name="sidePick" value="<% = games(i).homeID %>"<% if sidePick = games(i).homeID then Response.Write(CHECKED_ATTRIBUTE) end if %> /></span></td>
				<td align="left"><label for="sidePick-<% = n %>"><% call DisplayTeamLogo(games(i).homeID) %><% = home %><% call DisplayTeamRecord(games(i).homeID, week, false) %></label></td>
<%				else %>
				<td>&nbsp;</td>
				<td align="left"><% call DisplayTeamLogo(games(i).homeID) %><% = home %><% call DisplayTeamRecord(games(i).homeID, week, false) %></td>
<%				end if %>
<%			end if %>
			</tr>
<%		next

		'If the side pool has not started yet, display a message.
		if week < SIDE_START_WEEK then %>
			<tr class="subHeader topEdge">
				<th align="left" colspan="<% = cols %>">This pool begins in Week <% = SIDE_START_WEEK %>.</th>
			</tr>
<%		'If the player cannot participate in the pool, display a messasge.
		elseif not isEntryAllowed then %>
			<tr class="subHeader topEdge">
				<th align="left" colspan="<% = cols %>">You are not participating in this pool.</th>
			</tr>
<%		'Otherwise, show the player's status.
		elseif InSidePool(username) then

			footnote = ""
			if ENABLE_SURVIVOR_POOL then
				'Show the player's survivor pool status.
				if isSurvivorOver then
					survivorStatus = "n/a"
					if ENABLE_MARGIN_POOL then
						footnote = "Although the survivor pool has been concluded, your picks still count toward the margin pool."
					end if
				elseif isAlive then
					survivorStatus = "Alive"
					if WasRevived() then
						footnote = "You would have been eliminated, but no other player survived this week."
					end if
				elseif isPending then
					survivorStatus = "Pending"
					footnote = "You will be eliminated unless no other player survives the current week."
				else
					survivorStatus = "Eliminated"
					if ENABLE_MARGIN_POOL then
						footnote = "Although you have been eliminated from the survivor pool, your picks still count toward the margin pool."
						if allowBuyback and not UsedSurvivorBuyback(username, week) then
							footnote = footnote & " You may also buyback into the survivor pool, but must do so this week."
						end if
					elseif allowBuyback then
						footnote = "If you wish to buyback into the pool, you must do so this week."
					end if
					'If the user is eligible to buyback into the pool next
					'week, add a note to that effect.
					if IsSurvivorBuybackAllowed(username, week + 1) then
						if footnote <> "" then
							footnote = footnote & " "
						end if
						footnote = footnote & "Note that you may buyback into the survivor pool next week."
					end if
				end if

				'Highlight the survivor status, if it is has been determined
				'for this week's entry.
				if survivorStatus <> "n/a"  and not (survivorStatus = "Alive" and completed < week - SIDE_START_WEEK + 1) then
					survivorStatus = "<strong>" & survivorStatus & "</strong>"
				end if
				if footnote <> "" then
					survivorStatus = survivorStatus & "*"
				end if %>
			<tr class="header topEdge bottomEdge">
				<th align="left" colspan="<% = cols %>">Survivor Pool Status</th>
			</tr>
			<tr>
<%			'If a buyback is allowed, show the option.
			dim checkedStr, disabledStr
			checkedStr  = ""
			disabledStr = ""
			if allowBuyback then
				if buyback then
					checkedStr = " checked=""checked"""
				end if
				if not IsAdmin() and sidePickLocked then
					disabledStr = " disabled=""disabled"""
				end if %>
				<td align="right"><div class="<% = StyleFormField("", "buyback") %>"><input type="checkbox" id="buyback" name="buyback" value="true"<% = checkedStr %><% = disabledStr %> /></div></td>
				<td colspan="<% = cols - 3 %>"><label for="buyback">Buyback into the pool (<% = FormatAmount(SURVIVOR_BUYBACK_FEE) %>)</label></td>
				<td align="right" colspan="<% = 2 %>"><% = survivorStatus %></td>
<%			else %>
				<td align="right" colspan="<% = cols %>"><% = survivorStatus %></td>
<%			end if
		end if %>
			</tr>
<%		if ENABLE_MARGIN_POOL then %>
			<tr class="header topEdge bottomEdge">
				<th align="left" colspan="<% = cols %>">Margin Pool Score</th>
			</tr>
<%				'Find the player's total margin score as of the previous week.
				lastTotal = ""
				for i = SIDE_START_WEEK to week - 1
					score = GetMarginScore(username, i)
					if IsNumeric(score) then
						if not IsNumeric(lastTotal) then
							lastTotal = score
						else
							lastTotal = lastTotal + score
						end if
					end if
				next

				'Find the player's margin score for this week
				currentScore = GetMarginScore(username, week)

				'Calculate the player's margin score as of this week.
				currentTotal = ""
				if IsNumeric(lastTotal) and IsNumeric(currentScore) then
					currentTotal = lastTotal + currentScore
				elseif IsNumeric(lastTotal) then
					currentTotal = lastTotal
				elseif IsNumeric(currentScore) then
					currentTotal = currentScore
				end if

				'Show the player's margin score info.%>
			<tr>
				<td colspan="4">Previous Total:</td>
				<td align="right" colspan="<% = cols - 4 %>"><% call DisplayMarginScore(lastTotal) %></td>
			</tr>
			<tr class="alt">
				<td colspan="4">This Week:</td>
				<td align="right" colspan="<% = cols - 4 %>"><% call DisplayMarginScore(currentScore) %></td>
			</tr>
			<tr class="subHeader topEdge">
				<th align="left" colspan="4">Total:</th>
				<th align="right" colspan="<% = cols - 4 %>"><% call DisplayMarginScore(currentTotal) %></th>
			</tr>
<%			end if
		end if %>
		</table>
<%		'Show the footnote, if any.
		if footnote <> "" then %>
		<div class="adjustWidth"><em>*<% = footnote %></em></div>
<%		end if

		'List open dates.
		call DisplayOpenDates(week)

		'Show form buttons, if changes are allowed.
		if IsAdmin() or not sidePickLocked then %>
		<p></p>
		<table border="0" cellpadding="0" cellspacing="0" style="width: 100%;">
			<tr valign="middle">
				<td style="padding: 0px;"><input type="submit" name="submit" value="Update" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></td>
<%			'If the user has an entry and no games are locked (or the user is
			'the Admin), add a delete button.
			if hasEntry and (IsAdmin() or not sidePickLocked) then

				'If delete was requested, add a confirmation checkbox.
				if needDeleteConfirmation then %>
				<td align="right" style="padding: 0px;"><input type="checkbox" id="confirmDelete" name="confirmDelete" value="true" /> <label for="confirmDelete">Confirm Deletion</label>&nbsp;</td>
<%				end if %>
				<td align="right" style="padding: 0px;"><input type="submit" name="submit" value="Delete" class="button" /></td>
<%			end if %>
			</tr>
		</table>
<%		end if %>
		</td></tr></table>
	</form>
<%	end if

	'List links to view other weeks.
	dim otherParams
	otherParams = ""
	if IsAdmin() then
		otherParams = "username=" & Server.HtmlEncode(username)
	end if
	call DisplayGoToNavigation("week", GetWeekCount(), otherParams) %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Used to reset the current status of the survivor pool anytime a change is
	' made to an entry.
	'--------------------------------------------------------------------------
	sub GetCurrentSurvivorPoolStatus()

		isSurvivorOver= false
		finalWeek = GetSurvivorFinalWeek()
		if IsNumeric(finalWeek) and week > finalWeek then
			isSurvivorOver = true
		end if

	end sub

	'--------------------------------------------------------------------------
	' Returns true if the user was revived in the survivor pool.
	'--------------------------------------------------------------------------
	function WasRevived()

		dim rs
		dim curRevived, preRevived

		WasRevived = false

		'Get the number of revives up to this week.
		set rs = GetSurvivorStatus(username, week)
		curRevived = 0
		if not (rs.EOF and rs.BOF) then
			curRevived = rs.Fields("Revived").Value
		end if

		'If the pool started this week, check if the user was revived.
		if week = SIDE_START_WEEK then
			if curRevived = 1 then
				WasRevived = true
			end if
			exit function
		end if

		'Otherwise, compare to the number of revives up to the previous week.
		set rs = GetSurvivorStatus(username, week - 1)
		if not (rs.EOF and rs.BOF) then
			preRevived = rs.Fields("Revived").Value
			if curRevived > preRevived then
				WasRevived = true
			end if
		end if

	end function

	'--------------------------------------------------------------------------
	' Displays a margin score
	'--------------------------------------------------------------------------
	sub DisplayMarginScore(score)

		dim str

		str = "n/a"
		if IsNumeric(score) then
			str = "<strong>" & score & "&nbsp;pts.</strong>"
		end if
		Response.Write(str)

	end sub

	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' GameObj: Holds information for a single game.
	'--------------------------------------------------------------------------
	class GameObj

		public id, dateTime, visitorID, visitorName, homeID, homeName
		public result
		public isLocked

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(rs)

			'Set the game properties using the supplied database record.
			id          = rs.Fields("GameID").Value
			dateTime    = CDate(rs.Fields("DateTime").Value)
			visitorID   = rs.Fields("VisitorID").Value
			visitorName = rs.Fields("VCity").Value
			homeID      = rs.Fields("HomeID").Value
			homeName    = rs.Fields("HCity").Value
			result      = rs.Fields("Result").Value
			isLocked    = false

			'Set the team names for display.
			if rs.Fields("VDisplayName").Value <> "" then
				visitorName = rs.Fields("VDisplayName").Value
			end if
			if rs.Fields("HDisplayName").Value <> "" then
				homeName = rs.Fields("HDisplayName").Value
			end if

			'Set the game's lock status.
			if allLocked or IsDateTimePast(dateTime) then
				anyLocked = true
				isLocked = true
			end if

		end sub

	end class %>
