<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/side.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'If the side pool is disabled, redirect to the home page.
	if not ENABLE_SURVIVOR_POOL and not ENABLE_MARGIN_POOL then
		Response.Redirect("./")
	end if

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = SidePoolTitle & " Pool Standings"
	call BuildPageHeader("tableSort.css", "tableSort.js") %>
	<script type="text/javascript">//<![CDATA[
<%	if ENABLE_SURVIVOR_POOL then %>
	//=========================================================================
	// Define the survivor table sort commands.
	//=========================================================================
	var survivorNameSort = {
		initialSort : true,
		tbodyID     : "survivorBody",
		theadID     : "survivorHead",
		sortColumns : [
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [],
			headColumns : []
		}
	}
<%		if SURVIVOR_BUYBACK_LIMIT > 0 then %>
	var survivorBuybackSort = {
		tbodyID     : "survivorBody",
		theadID     : "survivorHead",
		sortColumns : [
			{ column : -3, descending : true  },
			{ column :  0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [-3],
			headColumns : [-3]
		}
	}
<%		end if %>
	var survivorCorrectSort = {
		tbodyID     : "survivorBody",
		theadID     : "survivorHead",
		sortColumns : [
			{ column : -2, descending : true  },
			{ column :  0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [-2],
			headColumns : [-2]
		}
	}
	var survivorStatusSort = {
		tbodyID     : "survivorBody",
		theadID     : "survivorHead",
		sortColumns : [
			{ column : -1, descending : false },
			{ column : -2, descending : true  },
<%		if SURVIVOR_BUYBACK_LIMIT > 0 then %>
			{ column : -3, descending : false  },
<%		end if %>
			{ column :  0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [-1],
			headColumns : [-1]
		}
	}
<%	end if
	if ENABLE_MARGIN_POOL then %>
	//=========================================================================
	// Define the margin table sort commands.
	//=========================================================================
	var marginNameSort = {
		initialSort : true,
		tbodyID     : "marginBody",
		theadID     : "marginHead",
		sortColumns : [
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [],
			headColumns : []
		}
	}
	var marginCorrectSort = {
		tbodyID     : "marginBody",
		theadID     : "marginHead",
		sortColumns : [
			{ column : -3, descending : true  },
			{ column :  0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [-3],
			headColumns : [-2]
		}
	}
	var marginScoreSort = {
		tbodyID     : "marginBody",
		theadID     : "marginHead",
		sortColumns : [
			{ column : -2, descending : true  },
			{ column : -3, descending : true  },
			{ column :  0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [-2, -1],
			headColumns : [-1]
		}
	}
<%	end if %>
	//]]></script>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Find the current week and the total number of weeks.
	dim curWeek, numWeeks

	curWeek = GetCurrentWeek()
	numWeeks = GetWeekCount()
   
	'If the survivor pool is enabled, find the final week.
	dim finalSurvivorWeek
	if ENABLE_SURVIVOR_POOL then
		finalSurvivorWeek = GetSurvivorFinalWeek()
		if not IsNumeric(finalSurvivorWeek) then
			finalSurvivorWeek = numWeeks
		end if
	end if

	'Determine if any games have been completed.
	dim completedGames
	completedGames = GetCompletedGameCount(SIDE_START_WEEK)

	'Get user data.
	dim i
	dim list, users
	dim leadMarginScore
	list = GetSidePlayersList()
   
	if IsArray(list) then
   
		'Create an array of user objects.
		redim users(UBound(list))
		for i = 0 to UBound(list)
			set users(i) = new UserObj
			users(i).setData(list(i))
		next
 
		'If the margin pool is enabled, get the current leading score.
		if IsArray(list) and ENABLE_MARGIN_POOL and completedGames > 0 then
			leadMarginScore = ""
			for i = 0 to UBound(users)
				if IsNumeric(users(i).marginScore) then
					if not IsNumeric(leadMarginScore) then
						leadMarginScore = users(i).marginScore
					elseif users(i).marginScore > leadMarginScore then
						leadMarginScore = users(i).marginScore
					end if
				end if
			next
		end if
	end if
    
	'Set up the display.
	dim cols
	dim alt, week
	dim sql, rs
	dim pick, result, margin
	dim pickLocked, hidePick
	dim scoreDiff
	dim currentUser
	dim numEntries
	dim pot, str
 
	'Get the current user.
	currentUser = Session(SESSION_USERNAME_KEY)

	'Find the number of entries.
	numEntries = GetSideEntryCount()
 
	'Show survivor pool standings, if appropriate.
	if ENABLE_SURVIVOR_POOL then
		cols = numWeeks + 3 - SIDE_START_WEEK + 1
		if SURVIVOR_BUYBACK_LIMIT > 0 then
			cols = cols + 1
		end if
		'Check for winners.
		list = GetSurvivorWinnersList()
    
		if ENABLE_MARGIN_POOL then %>
	<h2>Survivor Pool Standings</h2>
<%		end if %>
	<table class="main" border="0" cellpadding="0" cellspacing="0">
		<thead id="survivorHead">
			<tr class="header bottomEdge singleLine sortable" valign="bottom">
				<th align="left"><a href="#" onclick="this.blur(); return tableSort.sort(survivorNameSort);" title="Sort by name.">Name</a></th>
<%		'Display the weeks, and check for any weeks were players were revived because all were eliminated.
		dim revives, lastRevives, anyRevives
		lastRevives = 0
		anyRevives = false
			for week = SIDE_START_WEEK to numWeeks
			str = ""
			sql = "SELECT MAX(Revived) AS Total FROM SurvivorStatus WHERE Week = " & week
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				revives = rs.Fields("Total").Value
				if revives <> lastRevives then
					str = "*"
					lastRevives = revives
					anyRevives = true
				end if
			end if %>
				<th style="width: 2.2em;"><% = week & str %></th>
<%		next
		if SURVIVOR_BUYBACK_LIMIT > 0 then %>
				<th align="right"><a href="#" onclick="this.blur(); return tableSort.sort(survivorBuybackSort);" title="Sort by number of buybacks.">Bks</a></th>
<%		end if %>
				<th align="right"><a href="#" onclick="this.blur(); return tableSort.sort(survivorCorrectSort);" title="Sort by number of correct picks.">Correct</a></th>
				<th><a href="#" onclick="this.blur(); return tableSort.sort(survivorStatusSort);" title="Sort by current status.">Status</a></th>
			</tr>
		</thead>
<%		'Show the pot/payout.
		if numEntries > 0 then %>
		<tfoot>
<%			pot = GetSurvivorPotAmount()
			if IsArray(list) then
				if UBound(list) > 0 then
					str = "Winners: " & Join(list, ", ") & " (" & FormatAmount(pot / (UBound(list) + 1)) & " each)"
				else
					str = "Winner: " & Join(list, ", ") & " (" & FormatAmount(pot) & ")"
			end if %>
			<tr class="header topEdge"><th align="left" colspan="<% = cols %>"><% = str %></th></tr>
<%			else %>
			<tr class="subHeader topEdge"><th align="left" colspan="<% = cols %>">Pot: <% = FormatAmount(pot) %></th></tr>
<%			end if %>
		</tfoot>
<%		end if %>
		<tbody id="survivorBody">
<%		if IsArray(users) then

			'Show each player's picks and scoring info.
			alt = false
			for i = 0 to UBound(users)
				if alt then  %>
			<tr align="center" class="alt singleLine">
<%				else %>
			<tr align="center" class="singleLine">
<%				end if
				alt = not alt %>
				<td align="left"><% = users(i).name %></td>
<%				'Show the player's pick for each week.
				for week = SIDE_START_WEEK to numWeeks

					'If the player is no longer active in the pool, show blanks.
					if week > users(i).survivorMaxWeek then
						pick = "&nbsp;"
					else

						'Get the user's pick and result for this week.
						pick  = users(i).picks(week)
						result = users(i).results(week)

						'Handle a missing a pick.
						if pick = "" and week <= users(i).survivorMaxWeek then
							pick = "---"
						else

							'Determine if the pick is locked (note that we are making
							'some assumptions here based on the week).
							pickLocked = false
							if week < curWeek then
								pickLocked = true
							elseif  week = curWeek then
								pickLocked = IsSidePickLocked(pick, week)
							end if

							'Determine if the pick should be hidden.
							hidePick = false
							if HIDE_OTHERS_PICKS and not pickLocked and not IsAdmin() and currentUser <> users(i).name then
								hidePick = true
							end if

							'Format the pick display.
							if pick = "" then
								pick = "&nbsp;"
							elseif hidePick then
								pick = "XXX"
								margin = "XX"
							end if
							if result <> "" then
								if pick = result or (result = TIE_STR and not SURVIVOR_STRIKE_ON_TIE) then
									pick = FormatCorrectPick(pick)
								else
									pick = FormatIncorrectPick(pick)
								end if
							end if

							'If this is a buyback, mark it.
							if HasSurvivorBuyback(users(i).name, week) then
								pick = FormatBuyback(pick)
							end if
						end if
					end if %>
				<td><% = pick %></td>
<%				next
				if SURVIVOR_BUYBACK_LIMIT > 0 then %>
				<td align="right"><% = users(i).survivorBuybacks %></td>
<%				end if
				if users(i).anyCompletedGames then %>
				<td align="right"><% = users(i).survivorCorrect %>&nbsp;</td>
<%				else %>
				<td align="right">n/a&nbsp;</td>
<%				end if
				if users(i).survivorIsAlive then %>
				<td align="left">Alive</td>
<%				elseif users(i).survivorIsPending then %>
				<td align="left">Pending</td>
<%				else %>
				<td align="left">Eliminated</td>
<%				end if %>
			</tr>
<%			next 
		else %>
			<tr class="noSort">
				<td align="center" colspan="<% = cols %>"><em>No entries found.</em></td>
			</tr>
<%		end if %>
		</tbody>
	</table>
<%		'If there were any revives, show the footnote.
		if anyRevives then %>
		<div class="adjustWidth small">*Week's results ignored as all players would have been eliminated.</div>
<%		end if
	end if

	'Show margin pool standings, if appropriate.
	if ENABLE_MARGIN_POOL then
		cols = numWeeks + 4 - SIDE_START_WEEK + 1
		if ENABLE_SURVIVOR_POOL then %>
	<h2>Margin Pool Standings</h2>
<%		end if %>
	<table class="main" border="0" cellpadding="0" cellspacing="0"<% if ENABLE_SURVIVOR_POOL then Response.Write(" style=""width: 100%;""") end if %>>
		<thead id="marginHead">
			<tr class="header bottomEdge singleLine sortable" valign="bottom">
				<th align="left"><a href="#" onclick="this.blur(); return tableSort.sort(marginNameSort);" title="Sort by name.">Name</a></th>
<%		for week = SIDE_START_WEEK to numWeeks %>
				<th style="width: 2.2em;"><% = week %></th>
<%		next %>
				<th><a href="#" onclick="this.blur(); return tableSort.sort(marginCorrectSort);;" title="Sort by number of correct picks.">Correct</a></th>
				<th colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(marginScoreSort);;" title="Sort by score.">Score</a></th>
			</tr>
		</thead>
<%		'Show the pot/payout.
		if numEntries > 0 then %>
		<tfoot>
<%			pot = GetMarginPotAmount()
			list = GetMarginWinnersList()
			if IsArray(list) then
				if UBound(list) > 0 then
					str = "Winners: " & Join(list, ", ") & " (" & FormatAmount(pot / (UBound(list) + 1)) & " each)"
				else
					str = "Winner: " & Join(list, ", ") & " (" & FormatAmount(pot) & ")"
				end if %>
			<tr class="header topEdge"><th align="left" colspan="<% = cols %>"><% = str %></th></tr>
<%			else %>
			<tr class="subHeader topEdge"><th align="left" colspan="<% = cols %>">Pot: <% = FormatAmount(pot) %></th></tr>
<%			end if %>
		</tfoot>
<%		end if %>
		<tbody id="marginBody">
<%		if IsArray(users) then

			'Show each player's picks and scoring info.
			alt = false
			for i = 0 to UBound(users)
				if alt then  %>
			<tr align="center" class="alt singleLine">
<%				else %>
			<tr align="center" class="singleLine">
<%				end if
				alt = not alt %>
				<td align="left"><% = users(i).name %></td>
<%				'Show the player's pick and margin score for each week.
				for week = SIDE_START_WEEK to numWeeks
					pick   = users(i).picks(week)
					result = users(i).results(week)
					margin = users(i).margins(week)

					'Determine if the pick is locked (note that we are making
					'some assumptions here based on the week).
					pickLocked = false
					if week < curWeek then
						pickLocked = true
					elseif  week = curWeek then
						pickLocked = IsSidePickLocked(pick, week)
					end if

					'Determine if the pick should be hidden.
					hidePick = false
					if HIDE_OTHERS_PICKS and not pickLocked and not IsAdmin() and currentUser <> users(i).name then
						hidePick = true
					end if

					'Format the pick display.
					if pick = "" then
						pick = "---"
						if margin = "" then
							margin= "--"
						end if
					elseif hidePick then
						pick = "XXX"
						margin = "XX"
					else
						if not IsNumeric(margin) then
							margin = "--"
						end if
						if result <> "" then
							if result = TIE_STR then
								pick = FormatTie(pick)
							elseif pick = result then
								pick = FormatCorrectPick(pick)
								if margin > 0 then
									margin = "+" & margin
								end if
							else
								pick = FormatIncorrectPick(pick)
							end if
						end if
					end if %>
				<td class="small"><% = pick %><br /><% = margin %></td>
<%				next

				'Show the number of correct picks and total margin score for
				'this player.
				scoreDiff = "&nbsp;"
				if users(i).anyCompletedGames then %>
				<td align="right"><% = users(i).marginCorrect %>&nbsp;</td>
				<td align="right"><% = users(i).marginScore %>&nbsp;&nbsp;</td>
<%					'Show how far behind the leader this player's score is.
					if IsNumeric(leadMarginScore) and IsNumeric(users(i).marginScore) then
						if users(i).marginScore < leadMarginScore then
							scoreDiff = "(" & users(i).marginScore - leadMarginScore & ")"
						end if
					end if %>
<%				else %>
				<td align="right">n/a&nbsp;</td>
				<td align="right">n/a&nbsp;</td>
<%				end if %>
				<td align="right"><span class="small"><% = scoreDiff%></span></td>
			</tr>
<%			next
		else %>
			<tr><td align="center" colspan="<% = cols %>"><em>No entries found.</em></td></tr>
<%		end if %>
		</tbody>
	</table>
<%	end if %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' UserObj: Holds information for a single user.
	'--------------------------------------------------------------------------
	class UserObj

		public name
		public picks, results, margins
		public anyCompletedGames
		public marginCorrect, marginScore
		public survivorMaxWeek, survivorBuybacks, survivorCorrect
		public survivorIsAlive, survivorIsPending

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(username)
        
			dim sql, rs
			dim week
			dim games, missed

			'Set the username.
			name = username

			'Initialize arrays.
			redim picks(numWeeks + 1)
			redim results(numWeeks + 1)
			redim margins(numWeeks + 1)

			'Initialize completed games flag.
			anyCompletedGames = false

			'Get the user's pick and the game result for all weeks.
			sql = "SELECT SidePicks.*, Schedule.Result FROM Schedule, SidePicks" _
			   & " WHERE Username = '" & SqlEscape(username) & "'" _
			   & " AND SidePicks.Week >= " & SIDE_START_WEEK _
			   & " AND Schedule.Week = SidePicks.Week" _
			   & " AND (Pick = VisitorID or Pick = HomeID)" _
			   & " ORDER BY SidePicks.Week"
			
            set rs = DbConn.Execute(sql)
          
			'Get data for each week.
			marginCorrect = 0
			marginScore   = 0
			for week = SIDE_START_WEEK to numWeeks
				picks(week)   = ""
				results(week) = ""
				margins(week) = ""
				if not rs.EOF then
					if rs.Fields("Week").Value = week then
						if not IsNull(rs.Fields("Pick").Value) then
							picks(week) = rs.Fields("Pick").Value
						end if
						if not IsNull(rs.Fields("Result").Value) then
							results(week) = rs.Fields("Result").Value
							anyCompletedGames = true
						end if
						if ENABLE_MARGIN_POOL and not IsNull(rs.Fields("MarginScore").Value) then
							margins(week) = rs.Fields("MarginScore").Value
						end if
						rs.MoveNext
					end if
				end if

				'If the margin score has not been cached, get it now.
				if ENABLE_MARGIN_POOL then
					if not IsNumeric(margins(week)) then
						margins(week) = GetMarginScore(username, week)
					end if

					'Now add to the margin totals, if appropriate.
					if IsNumeric(margins(week)) then
						marginScore = marginScore + margins(week)
						if margins(week) > 0 then
							marginCorrect = marginCorrect + 1
						end if
					else
						margins(week) = ""
					end if
				end if
			next
         
			'Get the current status of this user in the survivor pool.
			survivorMaxWeek   = 0
			survivorBuybacks  = 0
			survivorCorrect   = 0
			survivorIsAlive   = false
			survivorIsPending = false
			if ENABLE_SURVIVOR_POOL then
             
				'If the user has already done a buyback for the following week,
				'use that instead.
				if HasSurvivorBuyback(username, week + 1) then
					week = week + 1
				end if
                
				'Get the user's status for that week.
				set rs = GetSurvivorStatus(username, week)
			  
                if not (rs.EOF and rs.BOF) then
					survivorCorrect   = rs.Fields("Completed").Value - rs.Fields("Missed").Value
					survivorBuybacks  = rs.Fields("Buybacks").Value
					survivorIsAlive   = rs.Fields("IsAlive").Value
					survivorIsPending = rs.Fields("IsPending").Value
				end if
             
				'Determine the last week survivor picks for this user should
				'be shown.
				survivorMaxWeek = finalSurvivorWeek
               
				'If the user has been eliminated, determine the last week the
				'user started alive in the pool (i.e. the week the user was
				'eliminated).
				if not survivorIsAlive and not survivorIsPending then
					sql = "SELECT MAX(Week) AS FinalWeek FROM SurvivorStatus" _
					   & " WHERE Username = '" & SqlEscape(username) & "'" _
					   & " AND WasAlive ='True'"
					
                    set rs = DbConn.Execute(sql)
					if not (rs.EOF and rs.BOF) then
						survivorMaxWeek = rs.Fields("FinalWeek").Value
					end if

				'Otherwise, use the last week the user has made a pick for.
				else
					sql = "SELECT MAX(Week) AS FinalWeek FROM SidePicks" _
					   & " WHERE Username = '" & SqlEscape(username) & "'" _
					   & " AND Week <= " & finalSurvivorWeek
				
                    set rs = DbConn.Execute(sql)
					if not (rs.EOF and rs.BOF) then
						survivorMaxWeek = rs.Fields("FinalWeek").Value
					end if
				end if
			end if
   
		end sub

	end class %>
