<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/superbowl.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'If the Super Bowl pool is disabled, redirect to the home page.
	if not ENABLE_SUPER_BOWL_POOL then
		Response.Redirect("./")
	end if

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Super Bowl Pool Entry Form"
	call BuildPageHeader("", "") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'If the user is the Administrator, check for a user name in the request.
	'Otherwise, show data for the current user.
	dim username
	username = Session(SESSION_USERNAME_KEY)
	if IsAdmin() then
		username = Trim(Request("username"))
	end if

	'For the Administrator, build a user selection list.
	if IsAdmin() then %>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<table class="main" border="0" cellpadding="0" cellspacing="0">
		<tr class="header bottomEdge">
			<th align="left">Administrator Access</th>
		</tr>
		<tr>
			<td class="adminSection freeForm">
				<p>You may view or edit any player's entry form by selecting a username below.</p>
				<table border="0" cellpadding="0" cellspacing="0">
					<tr>
						<td valign="middle"><strong>Select user:</strong></td>
						<td>
							<select name="username">
								<% call DisplayUserSelectList(GetUserList(true), username) %>
							</select>
						</td>
						<td><input type="submit" name="submit" value="Select" class="button" /></td>
					</tr>
				</table>
			</td>
		</tr>
		</table>
	</form>
<%		if username <> "" then %>
	<h2>Entry Form for <% = username %></h2>
<%		end if
	end if

	'Determine if the user has an entry for the Super Bowl pool (so we can
	'display the Delete button).
	dim hasEntry
	hasEntry = false
	if InSuperBowlPool(username) then
		hasEntry = true
	end if

	'Set locked flag.
	dim isLocked
	isLocked = IsSuperBowlLocked()

	'Create an array of proposition objects.
	dim numProps
	dim props, rs, n
	dim i
	numProps = GetSuperBowlPropCount()
	redim props(numProps - 1)
	set rs = GetSuperBowlPropsRecordset()
	if not (rs.EOF and rs.BOF) then
		i = 0
		do while not rs.EOF
			set props(i) = new PropObj
			props(i).setData(rs)
			i = i + 1
			rs.MoveNext
		loop
	end if

	'Get the Super Bowl teams.
	dim vid, hid
	set rs = SuperBowlScheduleRecordset()
	if not (rs.EOF and rs.BOF) then
		vid = rs.Fields("VisitorID").Value
		hid = rs.Fields("HomeID").Value
	end if

	'If there is form data, process it.
	dim sql
	dim needDeleteConfirmation, entryDeleted
	dim pick, pickMissingError
	dim readyErrorShown
	needDeleteConfirmation = false
	entryDeleted = false
	readyErrorShown = false

	'Process a delete request.
	if Request.Form("submit") = "Delete" then

		if not IsAdmin() and isLocked then
			call DisplayErrorMessage("Error: The Super Bowl pool has been locked, entry cannot be deleted.")
		elseif LCase(Request.Form("confirmDelete")) <> "true" then
			needDeleteConfirmation = true
			call DisplayWarningMessage("To confirm deletion, check the box below and press <code>Delete</code> again. Pressing any other button will cancel the deletion.")
		elseif IsArray(GetSuperBowlWinnersList()) then
			call DisplayErrorMessage("Error: Super Bowl pool has been concluded, cannot delete entries.")
		else

			'Delete the player's entry.
			sql = "DELETE FROM SuperBowlPicks" _
			   & " WHERE Username = '" & SqlEscape(username) & "'"
			call DbConn.Execute(sql)
			entryDeleted = true
			hasEntry = false

			'Clear stored pick data.
			for i = 0 to UBound(props)
				props(i).storedPick = ""
			next

			call DisplaySuccessMessage("Entry has been deleted.")
		end if

	'Process an update request.
	elseif Request.Form("submit") = "Update" then

		'Check for missing picks.
		dim missingPicks
		missingPicks = false
		for i = 0 to UBound(props)
			if Trim(Request.Form("pick-" & (i + 1)) = "") then
				missingPicks = true
				FormFieldErrors.Add "pick-" & (i + 1), ""
			end if
		next

		'Prevent entries by the Admin.
		if username = ADMIN_USERNAME then
			call DisplayErrorMessage("Error: User '" & ADMIN_USERNAME & "' may not make picks.")

		'If there are no propositions, prevent the entry.
		elseif numProps = 0 then
			call DisplayErrorMessage("Error: Super Bowl propositions have not been set, entries cannot be submitted.")
			readyErrorShown = true

		'If both teams have not been set, prevent the entry.
		elseif IsNull(vid) or IsNull(hid) then
			call DisplayErrorMessage("Error: Super Bowl teams have not been set, entries cannot be submitted.")
			readyErrorShown = true

		'If the user is disabled, prevent the entry.
		elseif IsDisabled() then
			call DisplayErrorMessage("Error: Your account has been disabled, changes not accepted. Please contact the Administrator.")

		'If the Super Bowl has been locked, prevent any updates (except by the Admin).
		elseif not IsAdmin() and isLocked then
			call DisplayErrorMessage("Error: The Super Bowl has been locked, changes not accepted.")

		'If not all picks were entered, prevent the entry.
		elseif missingPicks then
			call DisplayErrorMessage("Error: You must make a pick for each proposition.")

		'Otherwise, process the request.
		else

			'If there were any errors, display the error messages. Otherwise, do the updates.
			if FormFieldErrors.Count > 0 then
				call DisplayFormFieldErrorsMessage("Error: Invalid fields. Please correct and resubmit.")
			else

				'Delete any current picks for this users.
				sql = "DELETE FROM SuperBowlPicks" _
					   & " WHERE Username = '" & SqlEscape(username) & "'"
				call DbConn.Execute(sql)

				'Insert picks for this user.
				for i = 0 to UBound(props)
					pick = GetFieldValue("pick-" & (i + 1), props(i).storedPick)
					sql = "INSERT INTO SuperBowlPicks" _
					   & " (Username, PropID, Pick)" _
					   & " VALUES('" & SqlEscape(username) & "'," _
					   & " " & props(i).id & ", " _
					   & " '" & pick & "')"
					call DbConn.Execute(sql)
				next

				'Updates complete, redirect to the results page.
				Response.Redirect("superBowlResults.asp")
			end if
		end if
	end if

	'Show a warning if the pool is not ready for entries.
	if FormFieldErrors.Count = 0 and not readyErrorShown then
		if numProps = 0 or IsNull(vid) or IsNull(hid) then
			if IsAdmin() and username = "" then
				Response.Write(vbTab & "<br />" & vbCrLf)
			end if
			call DisplayWarningMessage("The Super Bowl pool is not yet ready for entries.")
		end if
	end if

	'Build the entry form.
	dim cols
	cols = 4
	if isLocked then
		cols = cols + 1
	end if

	if username <> "" then %>
	<form id="entryForm" action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<div>
<%		if IsAdmin() then %>
			<input type="hidden" name="username" value="<% = username %>" />
<%		end if %>
		</div>
		<table border="0" cellpadding="0" cellspacing="0"><tr><td style="padding: 0px;">
		<table class="main" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge">
				<th align="left" colspan="<% = cols - 2 %>">Super Bowl Propositions</th>
<%		if not IsNull(vid) then %>
				<th><% = GetTeamName(vid) %></th>
<%		else %>
				<th><% = TO_BE_DETERMINED_STR %></th>
<%		end if
		if not IsNull(hid) then %>
				<th><% = GetTeamName(hid) %></th>
<%		else %>
				<th><% = TO_BE_DETERMINED_STR %></th>
<%		end if %>
			</tr>
<%		dim vpicked, hpicked
		dim correctPick
		dim alt
		if numProps > 0 then
			alt = false
			for i = 0 to UBound(props)
				if alt then %>
			<tr class="alt singleLine">
<%				else %>
			<tr class="singleLine">
<%				end if
				alt = not alt

				'Show the lock icon, if appropriate.
				if isLocked then %>
					<td align="center"><img src="graphics/locked.png" alt="Locked" /></td>
<%				end if %>
				<td align="right"><% = (i + 1) %>.</td>
				<td style="width: 28em;"><input type="hidden" name="id-<% = (i + 1) %>" value="<% = props(i).id %>" /><% = props(i).desc %></td>
<%				'Get the player's pick data for this game.
				if isLocked or entryDeleted then
					pick = props(i).storedPick
				else
					pick = GetFieldValue("pick-" & (i + 1), props(i).storedPick)
				end if

				'Handle the display for a locked entry.
				if not IsAdmin() and isLocked then

					'Set the pick displays.
					correctPick = props(i).result
					vpicked = "&nbsp;"
					hpicked = "&nbsp;"
					if pick = vid then
						vpicked = "X"
					elseif pick = hid then
						hpicked = "X"
					end if

					'Format a correct/incorrect pick.
					if correctPick <> "" then
						if correctPick = TIE_STR then
							if pick = vid then
								vpicked = FormatTie(vpicked)
							elseif pick = hid then
								hpicked = FormatTie(hpicked)
							end if
						else
							if pick = correctPick then
								if pick = vid then
									vpicked = FormatCorrectPick(vpicked)
								elseif pick = hid then
									hpicked = FormatCorrectPick(hpicked)
								end if
							else
								if pick = vid then
									vpicked = FormatIncorrectPick(vpicked)
								elseif pick = hid then
									hpicked = FormatIncorrectPick(hpicked)
								end if
							end if
							vpicked = vpicked & "&nbsp;&nbsp;"
							hpicked = hpicked & "&nbsp;&nbsp;"
						end if
					end if
					vpicked = "&nbsp;&nbsp;" & vpicked
					hpicked = "&nbsp;&nbsp;" & hpicked %>
				<td align="center"><span class="fieldWrapper"><% = vpicked %></span><% call DisplayTeamLogo(vid) %></td>
				<td align="center"><span class="fieldWrapper"><% = hpicked %></span><% call DisplayTeamLogo(hid) %></td>
<%				'Handle the display for an unlocked entry.
				else
					if IsNull(vid) or IsNull(hid) then %>
				<td>&nbsp;</td>
				<td>&nbsp;</td>
<%					else %>
				<td align="center"><span class="<% = StyleFormField("fieldWrapper", "pick-" & (i + 1)) %>"><input type="radio" id="pick-<% = (i + 1) %>-V" name="pick-<% = (i + 1) %>" value="<% = vid %>"<% if pick = vid then Response.Write(CHECKED_ATTRIBUTE) end if %> /></span><label for="pick-<% = (i + 1) %>-V"><% call DisplayTeamLogo(vid) %></label></td>
				<td align="center"><span class="<% = StyleFormField("fieldWrapper", "pick-" & (i + 1)) %>"><input type="radio" id="pick-<% = (i + 1) %>-H" name="pick-<% = (i + 1) %>" value="<% = hid %>"<% if pick = hid then Response.Write(CHECKED_ATTRIBUTE) end if %> /></span><label for="pick-<% = (i + 1) %>-H"><% call DisplayTeamLogo(hid) %></label></td>
<%					end if
				end if %>
			</tr>
<%			next
		else %>
			<tr>
				<td align="center" colspan="<% = cols %>"><em>No propositions found.</em></td>
			</tr>
<%		end if

		'Build the player's score display, when available.
		dim score, pctStr, scoreStr
		scoreStr = ""
		pctStr = ""
		if GetSuperBowlCompletedPropCount() > 0 > 0 then
			score = GetSuperBowlScore(username)
			if IsNumeric(score) then
				scoreStr = score & "/" & numProps
				pctStr = "&nbsp;(" & FormatPercentage(score / numProps) & ")"
				scoreStr = "<strong>" & scoreStr & "</strong>" & pctStr
			end if 
		end if
		if scoreStr <> "" then %>
			<tr class="header topEdge bottomEdge">
				<th align="left" colspan="<% = cols %>">Score</th>
			</tr>
			<tr>
				<td align="right" colspan="<% = cols %>"><% = scoreStr %></td>
			</tr>
<%		end if %>
		</table>
<%		'Show form buttons, if changes are allowed.
		if IsAdmin() or not isLocked then %>
		<p></p>
		<table border="0" cellpadding="0" cellspacing="0" style="width: 100%;">
			<tr valign="middle">
				<td style="padding: 0px;"><input type="submit" name="submit" value="Update" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></td>
<%			'If the user has an entry and the pool is not locked (or the user
			'is the Admin), add a delete button.
			if hasEntry and (IsAdmin() or not isLocked) then

				'If delete was requested, add a confirmation checkbox.
				if needDeleteConfirmation then %>
				<td align="right" style="padding: 0px;"><input type="checkbox" id="confirmDelete" name="confirmDelete" value="true" /> <label for="confirmDelete">Confirm Deletion</label>&nbsp;</td>
<%				end if %>
				<td align="right" style="padding: 0px;"><input type="submit" name="submit" value="Delete" class="button" /></td>
<%			end if %>
			</tr>
		</table>
<%		end if %>
		</td></tr></table>
	</form>
<%	end if %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' PropObj: Holds information for a single proposition.
	'--------------------------------------------------------------------------
	class PropObj

		public id, desc, result
		public storedPick

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(rs)

			'Set the object properties using the supplied database record.
			id         = rs.Fields("PropID").Value
			desc       = rs.Fields("Description").Value
			result     = rs.Fields("Result").Value
			storedPick = ""

			'Get the user's pick data for this game.
			dim sql, rs2
			sql = "SELECT Pick FROM SuperBowlPicks" _
			   & " WHERE Username = '" & SqlEscape(username) & "'" _
			   & " AND PropID = " & id
			set rs2 = DbConn.Execute(sql)
			if not (rs2.EOF and rs2.BOF) then
				storedPick = rs2.Fields("Pick").Value
			end if

		end sub

	end class %>

