<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/weekly.asp" -->
<!-- #include file="includes/superbowl.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'If the Super Bowl pool is disabled, redirect to the home page.
	if not ENABLE_SUPER_BOWL_POOL then
		Response.Redirect("./")
	end if

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Super Bowl Pool Results"
	call BuildPageHeader("tableSort.css", "tableSort.js") %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Define the results table sort commands.
	//=========================================================================
	var resultsNameSort = {
		initialSort : true,
		tbodyID     : "resultsBody",
		theadID     : "resultsHead",
		sortColumns : [
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [],
			headColumns : []
		}
	}
	var resultsScoreSort = {
		tbodyID     : "resultsBody",
		theadID     : "resultsHead",
		sortColumns : [
			{ column : -1, descending : true },
			{ column :  0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [-2, -1],
			headColumns : [-1]
		}
	}
	//]]></script>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Get the number of propositions.
	dim numProps, completedProps
	numProps       = GetSuperBowlPropCount()
	completedProps = GetSuperBowlCompletedPropCount()

	'Set locked flag.
	dim isLocked
	isLocked = IsSuperBowlLocked()

	'Build the display.
	dim propCols, otherCols
	propCols  = numProps
	otherCols = 3
 %>
	<table class="main" border="0" cellpadding="0" cellspacing="0">
		<thead id="resultsHead">
			<tr class="header bottomEdge sortable" valign="bottom">
				<th align="left"><a href="#" onclick="this.blur(); return tableSort.sort(resultsNameSort);" title="Sort by name.">Name</a></th>
<%	dim sql, rs
	set rs = GetSuperBowlPropsRecordset()
	if rs.EOF and rs.BOF then %>
				<th>&nbsp;</th>
<%	end if
	do while not rs.EOF %>
				<th class="small"><% = rs.Fields("Header").Value %></th>
<%		rs.MoveNext
	loop %>
				<th colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(resultsScoreSort);" title="Sort by score.">Score</a></th>
			</tr>
		</thead>
<%	'Show the pot/payout.
	dim numEntries
	dim pot, list, str
	numEntries = GetSuperBowlEntryCount()
	if numEntries > 0 then %>
		<tfoot>
<%		pot = numEntries * SUPER_BOWL_ENTRY_FEE
		list = GetSuperBowlWinnersList()
		if IsArray(list) then
			if UBound(list) > 0 then
				str = "Winners: " & Join(list, ", ") & " (" & FormatAmount(pot / (UBound(list) + 1)) & " each)"
			else
				str = "Winner: " & Join(list, ", ") & " (" & FormatAmount(pot) & ")"
			end if %>
			<tr class="header topEdge"><th align="left" colspan="<% = propCols + otherCols %>"><% = str %></th></tr>
<%		else %>
			<tr class="subHeader topEdge"><th align="left" colspan="<% = propCols + otherCols %>">Pot: <% = FormatAmount(pot) %></th></tr>
<%		end if %>
		</tfoot>
<%	end if %>
		<tbody id="resultsBody">
<%	dim users, currentUser
	dim i
	dim pick, result
	dim hidePick
	dim correct
	dim pickScore, pickPct
	currentUser = Session(SESSION_USERNAME_KEY)

	'Get user data.
	dim alt
	list = GetSuperBowlPlayersList()
	if IsArray(list) then
		alt = false
		for i = 0 to UBound(list)
			correct = 0
			if alt then %>
			<tr align="center" class="alt singleLine">
<%			else %>
			<tr align="center" class="singleLine">
<%			end if
			alt = not alt %>
				<td align="left"><% = list(i) %></td>
<%			'Display picks for this user, highlighting the correct ones.
			sql = "SELECT Pick, Result FROM SuperBowlProps, SuperBowlPicks" _
			   & " WHERE SuperBowlProps.PropID = SuperBowlPicks.PropID" _
			   & " AND Username = '" & SqlEscape(list(i)) & "'" _
			   & " ORDER BY SuperBowlProps.PropID"
			set rs = DbConn.Execute(sql)
			do while not rs.EOF
				pick = rs.Fields("Pick").Value
				result = rs.Fields("Result").Value

				'Determine if the pick should be hidden.
				hidePick = false
				if not isLocked and not IsAdmin() and currentUser <> list(i) then
					hidePick = true
				end if

				'Format the pick display.
				if pick = "" then
					pick = "---"
				elseif hidePick then
					pick = "XXX"
				else
					if result <> "" then
						if pick = result then
							correct = correct + 1
							pick = FormatCorrectPick(pick)
						elseif result = TIE_STR then
							correct = correct + .5
							pick = FormatTie(pick)
						else
							pick = FormatIncorrectPick(pick)
						end if
					end if
				end if %>
				<td><% = pick %></td>
<%				rs.MoveNext
			loop

			'Build the correct pick and score displays.
			pickScore  = "n/a"
			pickPct    = "&nbsp;"
			if completedProps > 0 then
				pickPct = "(" & FormatPercentage(correct / completedProps) & ")"
				pickScore = correct & "/" & completedProps
			end if %>
				<td align="right"><% = pickScore %></td>
				<td align="right"><% = pickPct %></td>
			</tr>
<%		next
	else %>
			<tr class="noSort">
				<td>&nbsp;</td>
				<td align="center" colspan="<% = propCols %>"><em>No entries found.</em></td>
				<td colspan="2">&nbsp;</td>
			</tr>
<%	end if %>

		</tbody>
	</table>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
