<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/weekly.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Top Weekly Scores"
	call BuildPageHeader("", "") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Define the number of top scores to show.
	const TOP_SCORE_COUNT = 25

	'Define score types
	const PICK_SCORE = 1
	const CONF_SCORE = 2

	'Define the top score arrays.
	dim topPickScores(), topConfScores()
	redim topPickScores(TOP_SCORE_COUNT - 1)
	redim topConfScores(TOP_SCORE_COUNT - 1)

	'Get the last completed week.
	dim maxWeek
	maxWeek = GetCurrentWeek()
	if GetWeeklyTiebreakerActual(maxWeek) = "" then
		maxWeek = maxWeek - 1
	end if

	'Get all weekly pool scores.
	dim sql, rs
	dim userScore
	dim week, username, pickScore, confScore, tbGuess
	dim lastWeek, numGames, maxPts, tbTarget
	lastWeek = 0
	sql = "SELECT * FROM WeeklyScoring" _
	   & " WHERE Week <= " & maxWeek _
	   & " ORDER BY Week"
	set rs = DbConn.Execute(sql)
	do while not rs.EOF

		'For each new week, get the number of games, max confidence score
		'possible and tiebreaker value.
		week = rs.Fields("Week").Value
		if week <> lastWeek then
			numGames = GetGameCount(week)
			maxPts   = (numGames * (numGames + 1) / 2)
			tbTarget = GetWeeklyTiebreakerActual(week)
			lastWeek = week
		end if

		'Get score info.
		username  = rs.Fields("Username").Value
		pickScore = rs.Fields("PickScore").Value
		confScore = rs.Fields("ConfidenceScore").Value
		tbGuess   = rs.Fields("Tiebreaker").Value

		'Ensure we have the player's pick and confidence scores.
		if IsNull(pickScore) then
			pickScore = GetWeeklyPickScore(username, week)
			confScore = GetWeeklyConfidenceScore(username, week)
		end if

		'Add the score to the list, if appropriate.
		if IsNumeric(tbTarget) then
			set userScore = new UserScoreObj
			call userScore.setData(username, week, pickScore, confScore, numGames, maxPts, Abs(tbTarget - tbGuess))
			call AddToTopScores(userScore, topPickScores, PICK_SCORE)
			call AddToTopScores(userScore, topConfScores, CONF_SCORE)
		end if

		rs.MoveNext
	loop

	'Build the top weekly score display. %>
	<table border="0" cellpadding="0" cellspacing="0"><tr valign="top"><td>
		<table class="main" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge singleLine">
				<th colspan="6">Correct Picks</th>
			</tr>
			<tr class="subHeader bottomEdge singleLine">
				<th>#</th>
				<th align="left">Name</th>
				<th>Week</th>
				<th colspan="2">Correct</th>
				<th>TB Diff.</th>
			</tr>
<%	dim i, n
	dim alt
	n = GetLastIndex(topPickScores)
	alt = false
	if n < 0 then %>
			<tr class="singleLine">
				<td align="center" colspan="6"><em>No results available.</em></td>
			</tr>
<%	else
		for i = 0 to n
			if alt then %>
			<tr align="right" class="alt singleLine">
<%			else %>
			<tr align="right" class="singleLine">
<%			end if
			alt = not alt %>
				<td><a href="weeklyResults.asp?week=<% = topPickScores(i).week %>"><% = i + 1 %></a></td>
				<td align="left"><% = topPickScores(i).username %></td>
				<td><% = topPickScores(i).week %></td>
				<td><% = topPickScores(i).pickScore & "/" & topPickScores(i).numGames %></td>
				<td><% = "(" & FormatPercentage(topPickScores(i).pickPct) & ")" %></td>
				<td><% = topPickScores(i).tbDiff %></td>
			</tr>
<%		next
	end if %>
		</table>
	</td>
<% if USE_CONFIDENCE_POINTS then %>
	<td>&nbsp;</td>
	<td>
		<table class="main" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge singleLine">
				<th colspan="6">Confidence Points</th>
			</tr>
			<tr class="subHeader bottomEdge singleLine">
				<th>#</th>
				<th align="left">Name</th>
				<th>Week</th>
				<th colspan="2">Score</th>
				<th>TB Diff.</th>
			</tr>
<%		n = GetLastIndex(topConfScores)
		alt = false
		if n < 0 then %>
			<tr class="singleLine">
				<td align="center" colspan="6"><em>No results available.</em></td>
			</tr>
<%		else
				for i = 0 to n
				if alt then %>
			<tr align="right" class="alt singleLine">
<%				else %>
			<tr align="right" class="singleLine">
<%				end if
				alt = not alt %>
				<td><a href="weeklyResults.asp?week=<% = topConfScores(i).week %>"><% = i + 1 %></a></td>
				<td align="left"><% = topConfScores(i).username %></td>
				<td><% = topConfScores(i).week %></td>
				<td><% = topConfScores(i).confScore & "/" & topConfScores(i).maxPts %></td>
				<td><% = "(" & FormatPercentage(topConfScores(i).confPct) & ")" %></td>
				<td><% = topConfScores(i).tbDiff %></td>
			</tr>
<%			next
		end if
	end if %>
		</table>
	</td></tr></table>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'---------------------------------------------------------------------------
	' Adds a given score to the given top scores list, if it qualifies.
	'---------------------------------------------------------------------------
	sub AddToTopScores(userScore, scoresList, listType)

		dim i, j
		dim newPct,   listPct
		dim newScore, listScore
		dim cmp

		'Get the score values to compare.
		if listType = PICK_SCORE then
			newPct   = userScore.pickPct
			newScore = userScore.pickScore
		else
			newPct   = userScore.confPct
			newScore = userScore.confScore
		end if

		'Exit if the new score is invalid.
		if not IsNumeric(newPct) then
			exit sub
		end if

		'Exit if the new score is lower than last score currently in the list.
		i = UBound(scoresList)
		if not IsEmpty(scoresList(i)) then
			if listType = PICK_SCORE then
				listPct = scoresList(i).pickPct
			else
				listPct = scoresList(i).confPct
			end if
			if newPct < listPct then
				exit sub
			end if
		end if

		'Compare the new score to the scores currently in the list.
		i = 0
		do while i <= UBound(scoresList)

			'If an empty spot is found, take it.
			if IsEmpty(scoresList(i)) then
				exit do
			end if

			'Get the score values of this list item.
			if listType = PICK_SCORE then
				listPct   = scoresList(i).pickPct
				listScore = scoresList(i).pickScore
			else
				listPct   = scoresList(i).confPct
				listScore = scoresList(i).confScore
			end if

			'Compare the scores, percentage is the primary sort value.
			cmp = Sgn(newPct - listPct)

			'If those scores are equal, compare the actual score (this will
			'give precedence to scores for weeks with more games).
			if cmp = 0 then
				cmp = newScore - listScore
			end if

			'If the scores are still equal, compare the tiebreaker.
			if cmp = 0 then
				cmp = Sgn(scoresList(i).tbDiff - userScore.tbDiff)
			end if

			'If the scores are still equal, compare the week and give it to
			'whomever earned it first.
			if cmp = 0 then
				if userScore.week < scoresList(i).week then
					cmp = 1
				elseif userScore.week > scoresList(i).week then
					cmp = -1
				end if
			end if

			'If the scores are still equal, sort by player name.
			if cmp = 0 then
				if userScore.username < scoresList(i).username then
					cmp = 1
				else
					cmp = -1
				end if
			end if

			'If the new score is better, we need to insert it at this slot.
			if cmp > 0 then

				'Shift all other scores down the list and exit the loop.
				for j = UBound(scoresList) - 1 to i step -1
					if not IsEmpty(scoresList(j)) then
						set scoresList(j + 1) = scoresList(j)
					end if
				next
				exit do

			end if
			i = i + 1
		loop

		'Add the score to the top scores list, if qualified.
		if i <= UBound(scoresList) then
			set scoresList(i) = userScore
		end if

	end sub

	'---------------------------------------------------------------------------
	' Returns the index of the last, non-empty element in the given array.
	'---------------------------------------------------------------------------
	function GetLastIndex(list)

		dim i

		GetLastIndex = UBound(list)

		for i = 0 to UBound(list)
			if IsEmpty(list(i)) then
				GetLastIndex = i - 1
				exit function
			end if
		next

	end function

	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' UserObj: Holds information for a user's score for a given week.
	'--------------------------------------------------------------------------
	class UserScoreObj

		public username, week
		public pickScore, confScore
		public numGames, maxPts
		public pickPct, confPct
		public tbDiff

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(user, wk, ps, cs, ng, mp, tb)

			'Initialize properties.
			username  = user
			week      = wk
			pickScore = ps
			confScore = cs
			numGames  = ng
			maxPts    = mp
			tbDiff    = tb

			'Get percentages (used for comparison).
			pickPct = ""
			confPct = ""
			if IsNumeric(pickScore) then
				pickPct = pickScore / numGames
			end if
			if IsNumeric(confScore) then
				confPct = confScore / maxPts
			end if

		end sub

	end class %>
