<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" -->
<!-- #include file="includes/common.asp" -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/email.asp" -->
<!-- #include file="includes/encryption.asp" -->
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/side.asp" -->
<!-- #include file="includes/weekly.asp" -->
<%	'Limit access to the Administrator.
	call CheckAccess(true)

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Update Game Schedule"
	call BuildPageHeader("dateTimePicker.css", "dateTimePicker.js") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
<!-- #include file="includes/dateTimePicker.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Get the week to display.
	dim week
	week = GetRequestedWeek()

	'If there is form data, process it.
	dim n, i
	dim gameID, gameWeek, gameDate, gameTime
	dim notify, infoMsg
	dim sql, rs
	dim affectedWeeks
	affectedWeeks = Array()
	n = GetGameCount(week)
	if Request.ServerVariables("Content_Length") > 0 and not IsCancelRequest() then
		for i = 1 to n
			gameID   = Trim(Request.Form("id-"   & i))
			gameWeek = Trim(Request.Form("week-" & i))
			gameDate = Trim(Request.Form("date-" & i))
			gameTime = Trim(Request.Form("time-" & i))

			'Validate the form fields.
			if not IsValidInteger(gameWeek) then
				FormFieldErrors.Add "week-" & i, "'" & gameWeek & "' is not a valid week number."
			else
				if CInt(gameWeek) < 1 or CInt(gameWeek) > GetWeekCount() then
					FormFieldErrors.Add "week-" & i, "'" & gameWeek & "' is not a valid week number."
				end if
			end if
			if not IsDate(gameDate) then
				FormFieldErrors.Add "date-" & i, "'" & gameDate & "' is not a valid date."
			end if
			if not IsDate(gameTime) then
				FormFieldErrors.Add "time-" & i, "'" & gameTime & "' is not a valid time."
			end if
		next

		'If there were any errors, display the error summary message.
		'Otherwise, do the updates.
		if FormFieldErrors.Count > 0 then
			call DisplayFormFieldErrorsMessage("Error: Invalid fields. Please correct and resubmit.")
		else
			for i = 1 to n
				gameID   = Trim(Request.Form("id-"   & i))
				gameWeek = Trim(Request.Form("week-" & i))
				gameDate = Trim(Request.Form("date-" & i))
				gameTime = Trim(Request.Form("time-" & i))
				call AddAffectedWeek(gameWeek)
				sql = "UPDATE Schedule SET" _
				   & " Week   = "  & gameWeek & ","  _
				   & " [DateTime] = " & DATABASE_DATETIME_DELIMITER & gameDate & " " & gameTime & DATABASE_DATETIME_DELIMITER  _
				   & " WHERE GameID = " & gameID
                call DbConn.Execute(sql)
			next

			'Clear any cached pool results for the affected weeks.
			call SortAffectedWeeks()
			for i = LBound(affectedWeeks) to UBound(affectedWeeks)
				call ClearWeeklyResultsCache(affectedWeeks(i))
				if ENABLE_MARGIN_POOL then
					call ClearMarginResultsCache(affectedWeeks(i))
				end if
			next
			if ENABLE_SURVIVOR_POOL then
				call ClearSurvivorStatus(affectedWeeks(0))
			end if

			'Send out email notifications, if checked.
			infoMsg = "Update successful."
			notify = Trim(Request.Form("notify"))
			if LCase(notify) = "true" then
				infoMsg = "Update successful, notifications sent."
				call SendNotifications()
			end if

			'Updates done, show an informational message.
			call DisplaySuccessMessage(infoMsg)
		end if
	end if

	'Display the schedule for the specified week. %>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<div><input type="hidden" name="week" value="<% = week %>" /></div>
		<table class="main" border="0" cellpadding="0" cellspacing="0">
			<tr align="left" class="header bottomEdge">
				<th>Week</th>
				<th>&nbsp;</th>
				<th colspan="2">Date</th>
				<th colspan="2">Time</th>
				<th colspan="3">Teams</th>
			</tr>
<%	dim vid, hid
	dim visitor, home
	dim alt
	set rs = GetGamesRecordset(week)
	if not (rs.EOF and rs.BOF) then
		n = 1
		alt = false
		do while not rs.EOF
			gameID   = rs.Fields("GameID").Value
			gameWeek = rs.Fields("Week").Value
			gameDate =  FormatDate(rs.Fields("DateTime").Value)
			gameTime =  FormatTime(rs.Fields("DateTime").Value)
			vid      = rs.Fields("VisitorID").Value
			hid      = rs.Fields("HomeID").Value
			visitor  = rs.Fields("VCity").Value
			home     = rs.Fields("HCity").Value

			'Set the team names for display
			if rs.Fields("VDisplayName").Value <> "" then
				visitor = rs.Fields("VDisplayName").Value
			end if
			if rs.Fields("HDisplayName").Value <> "" then
				home = rs.Fields("HDisplayName").Value
			end if
			if alt then %>
			<tr class="alt">
<%			else %>
			<tr>
<%			end if
			alt = not alt

			'If there were errors on the form post processing, restore those fields.
			if FormFieldErrors.Count > 0 then
				gameWeek = GetFieldValue("week-" & n, gameWeek)
				gameDate = GetFieldValue("date-" & n, gameDate)
				gameTime = GetFieldValue("time-" & n, gameTime)
			end if %>
				<td><input type="hidden" name="id-<% = n %>" value="<% = gameID %>" /><input type="text" name="week-<% = n %>" value="<% = gameWeek %>" size="2" class="<% = StyleFormField("numeric", "week-" & n) %>" /></td>
				<td align="right"><input type="text" name="day-<% = n %>" value="<% = WeekdayName(Weekday(gameDate), true) %>" size="3" class="readonly" readonly="readonly" /></td>
				<td><input type="text" name="date-<% = n %>" value="<% = FormatFullDate(gameDate) %>" size="10" class="<% = StyleFormField("numeric readonly", "date-" & n) %>" readonly="readonly" /></td>
				<td><input type="image" src="graphics/calendar.png" onclick="return datePicker.open(this.form, 'day-<% = n %>', 'date-<% = n %>');" title="Select a new date." /></td>
				<td><input type="text" name="time-<% = n %>" value="<% = FormatFullTime(gameTime) %>" size="10" class="<% = StyleFormField("numeric readonly", "time-" & n) %>" readonly="readonly" /></td>
				<td><input type="image" src="graphics/clock.png" onclick="timePicker.open(this.form, 'time-<% = n %>'); return false;" title="Select a new time." /></td>
				<td><% call DisplayTeamLogo(vid) %><% = visitor %></td>
				<td>at</td>
				<td><% call DisplayTeamLogo(hid) %><% = home %></td>
			</tr>
<%			rs.MoveNext
			n = n + 1
		loop
		if SERVER_EMAIL_ENABLED then %>
			<tr class="subHeader topEdge">
				<th align="left" colspan="9"><input type="checkbox" id="notify" name="notify" value="true" /> <label for="notify">Send update notification to users.</label></th>
			</tr>
<%		end if %>
		</table>
<%		'List open dates.
		call DisplayOpenDates(week)
	end if %>
		<p><input type="submit" name="submit" value="Update" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></p>
	</form>
<%	'List links to view other weeks.
	call DisplayGoToNavigation("week", GetWeekCount(), "") %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Adds the specified week to the list of affected weeks, if it is not
	' already present.
	'--------------------------------------------------------------------------
	sub AddAffectedWeek(week)

		dim i

		for i = LBound(affectedWeeks) to UBound(affectedWeeks)
			if affectedWeeks(i) = week then
				exit sub
			end if
		next
		redim preserve affectedWeeks(Ubound(affectedWeeks) + 1)
		affectedWeeks(UBound(affectedWeeks)) = week

	end sub

	'--------------------------------------------------------------------------
	' Sorts the list of affected weeks.
	'--------------------------------------------------------------------------
	sub SortAffectedWeeks()

		dim i, j, tmp

		for i = LBound(affectedWeeks) to UBound(affectedWeeks) - 1
			for j = i + 1 to UBound(affectedWeeks)
				if affectedWeeks(j) < affectedWeeks(i) then
					tmp = affectedWeeks(i)
					affectedWeeks(i) = affectedWeeks(j)
					affectedWeeks(j) = tmp
				end if
			next
		next

	end sub

	'--------------------------------------------------------------------------
	' Sends an email notification to any users who have elected to receive
	' them.
	'--------------------------------------------------------------------------
	sub SendNotifications()

		dim subj, body
		dim i, rs
		dim list, email

		subj = "Football Pool Game Schedule Update Notification"
		body = ""

		'Show the schedule for each affected week.
		for i = LBound(affectedWeeks) to UBound(affectedWeeks)
			if i > 0 then
				body = body & vbCrLf
			end if
			body = body & "The game schedule for Week " & affectedWeeks(i) & " has been updated." & vbCrLf & vbCrLf
			set rs = GetGamesRecordset(affectedWeeks(i))
			do while not rs.EOF
				body = body  _
				     & WeekdayName(Weekday(rs.Fields("DateTime").Value), true) _
			    	 & " " & FormatDate(rs.Fields("DateTime").Value) _
					 & " " & FormatTime(rs.Fields("DateTime").Value) _
				     & " " & rs.Fields("VisitorID").Value & " at " & rs.Fields("HomeID").Value & vbCrLf
				rs.moveNext
			loop
		next
		body = body & vbCrLf & "(All times Eastern)" & vbCrLf

		list = GetNotificationList("NotifyOfScheduleUpdates")
		for each email in list
			call SendMail(email, subj, body)
		next

	end sub %>

