<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/email.asp" -->
<!-- #include file="includes/encryption.asp" -->
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/passwords.asp" -->
<%	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "User Sign Up"
	call BuildPageHeader("", "") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'If there is form data, process it.
	dim code, username, email, password1, password2, badChar
	dim salt, password
	dim sql, rs
	if Request.ServerVariables("Content_Length") > 0 and not IsCancelRequest() then
		code     = Trim(Request.Form("code"))
		username = Trim(Request.Form("username"))
		email    = Trim(Request.Form("email"))
		badChar  = CheckUsername(username)

		'Check the invitaion code field, if used.
		if SIGN_UP_INVITATION_CODE <> "" then
			if code = "" then
				FormFieldErrors.Add "code", "The invitation code is required."
			elseif code <> SIGN_UP_INVITATION_CODE then
				FormFieldErrors.Add "code", "The invitation code is incorrect."
			end if
		end if

		'Check the username field.
		if username = "" then
			FormFieldErrors.Add "username", "A username is required."
		elseif badChar <> "" then
			FormFieldErrors.Add "username", "Usernames may not contain a '" & Server.HtmlEncode(badChar) & "' character."
		elseif Len(username) > USERNAME_MAX_LEN then
			FormFieldErrors.Add "username", "Usernames may not exceed " & USERNAME_MAX_LEN & " characters."
		else
			sql = "SELECT * FROM Users WHERE Username = '" & SqlEscape(username) & "'"
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				FormFieldErrors.Add "username", "Username '" & username & "' is already taken, try another."
			end if
		end if

		'Check the email field.
		if email = "" then
			FormFieldErrors.Add "email", "An email address is required."
		elseif not IsValidEmailAddress(email) then
			FormFieldErrors.Add "email", "'" & email & "' does not appear to be a valid email address."
		end if

		'Handle the case where server-side email is not available.
		if not SERVER_EMAIL_ENABLED then

			'Check the password fields.
			password1 = Trim(Request.Form("password1"))
			password2 = Trim(Request.Form("password2"))
			if password1 = "" or password2 = "" then
				FormFieldErrors.Add "password1", "A password is required."
				FormFieldErrors.Add "password2", "You must enter your password twice, where indicated."
			elseif password1 <> password2 then
				FormFieldErrors.Add "password1", "Passwords fields do not match."
				FormFieldErrors.Add "password2", ""
			elseif Len(password1) < PASSWORD_MIN_LEN then
				FormFieldErrors.Add "password1", "Password must be at least " & PASSWORD_MIN_LEN & " characters long."
			end if
		end if

		'If the input data is good, add the user.
		if FormFieldErrors.Count = 0 then
			if SERVER_EMAIL_ENABLED then
				password = CreatePassword()
			else
				password = password1
			end if
			salt = CreateSalt()
			sql = "INSERT INTO Users" _
			   & " (Username, EmailAddress, Salt, [Password])" _
			   & " VALUES('" & SqlEscape(username) & "'," _
			   & " '" & Encrypt(email) & "'," _
			   & " '" & salt & "'," _
			   & " '" & Hash(salt & password) & "')"
			call DbConn.Execute(sql)

			'If enabled, send the emails.
			if SERVER_EMAIL_ENABLED then

				'Send emails, one to the user and one to the administrator.
				dim mailSubj, mailMsg, errMsg
				mailSubj = "Football Pool Sign Up"
				mailMsg = "Thanks for signing up. You may login at " & POOL_URL & " with the username and password below." & vbCrLf _
				       & vbCrLf _
				       & "Username: " & username & vbCrLf _
				       & "Password: " & password & vbCrLf _
			    	   & vbCrLf
				errMsg = SendMail(email, mailSubj, mailMsg)
				if errMsg = "" then
					call DisplaySuccessMessage("Username '" & username & "' added. Please check your email for the password.")
					mailMsg = "A new user has signed up for the pool." & vbCrLf _
					        & vbCrLf _
					        & "Username: " & username & vbCrLf _
					        & "Email: " & email & vbCrLf _
					        & vbCrLf
					errMsg = SendMail(ADMIN_EMAIL, mailSubj, mailMsg)
					username = ""
					email = ""
				else
					call DisplayErrorMessage("Email send failed with '" & errMsg & "' Please contact <a href=""mailto:" & ADMIN_EMAIL & """>" & ADMIN_EMAIL & "</a> for help.")
					sql = "DELETE FROM Users WHERE Username = '" & SqlEscape(username) & "'"
					call DbConn.Execute(sql)
				end if

			'Otherwise, show a message indicating the user may now log in.
			else
				call DisplaySuccessMessage("Username '" & username & "' added. You may now <a href=""userLogin.asp"">login</a>.")
			end if

		end if

		'Show form field errors, if any.
		if FormFieldErrors.Count > 0 then
			call DisplayFormFieldErrorsMessage("Sign up failed, see below.")
		end if

	end if %>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<table class="main fixed" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge">
				<th align="left">User Sign Up</th>
			</tr>
			<tr>
				<td class="freeForm">
					<p>To sign up, enter
<%	if SIGN_UP_INVITATION_CODE <> "" then %>
					the invitation code,
<%	end if
	if SERVER_EMAIL_ENABLED then %>
					your name and email address	and hit the <code>Submit</code> button.
					An account will	be created for you using a randomly generated password which will be sent to your email address.
<%	else %>
					your name, email address and a password (twice, for confirmation) hit the <code>Submit</code> button.
<%	end if %>
					</p>
					<table class="form" border="0" cellpadding="0" cellspacing="0">
<%	if SIGN_UP_INVITATION_CODE <> "" then %>
						<tr valign="middle">
							<td><strong>Invitation code:</strong></td>
							<td><input type="password" name="code" value="" class="<% = StyleFormField("", "code") %>" /></td>
						</tr>
<%	end if %>
						<tr valign="middle">
							<td><strong>Username:</strong></td>
							<td><input type="text" name="username" value="<% = username %>" class="<% = StyleFormField("", "username") %>" /></td>
						</tr>
						<tr valign="middle">
							<td><strong>Email address:</strong></td>
							<td><input type="text" name="email" value="<% = email %>" class="<% = StyleFormField("", "email") %>" /></td>
						</tr>
<%	if not SERVER_EMAIL_ENABLED then %>
						<tr valign="middle">
							<td><strong>Password:</strong></td>
							<td><input type="password" name="password1" value="" class="<% = StyleFormField("", "password1") %>" /></td>
						</tr>
						<tr valign="middle">
							<td><strong>Confirm password:</strong></td>
							<td><input type="password" name="password2" value="" class="<% = StyleFormField("", "password1") %>" /></td>
						</tr>
<%	end if %>					
					</table>
<%	if SERVER_EMAIL_ENABLED then %>
					<p>If you don't receive your email within a few hours, please contact the Administrator at <a href="mailto:<% = ADMIN_EMAIL %>"><% = ADMIN_EMAIL %></a> for assistance.</p>
<%	end if %>
					<p>You can review the <a href="helpRules.asp">pool rules</a> before joining.</p>
				</td>
			</tr>
		</table>
		<p><input type="submit" name="submit" value="Submit" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></p>
	</form>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
