<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" -->
<!-- #include file="includes/common.asp" -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/form.asp" -->
<!-- #include file="includes/weekly.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'Open the database.
	call OpenDB() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Weekly Pool Entry Form"
	if not USE_CONFIDENCE_POINTS then
		call BuildPageHeader("", "")
	else
		call BuildPageHeader("confPtsStatus.css", "confPtsStatus.js") %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Initialize the confidence points status display on page load.
	//=========================================================================
	domUtils.onready(function () {
		confPtsStatus.update(document.getElementById("entryForm"));
	});
	//]]></script>
<%	end if
	if ENABLE_QUICK_PICKS then %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Module: quickPick
	//
	// Used to set quick picks.
	//=========================================================================
	var quickPick = function () {

		// The entry form.
		var formEl = null;

		// The number of games.
		var numGames = 0;

		// Player's team rankings, if any.
		var teamRanks = [];

		// Define an array to hold the pick fields for each game.
		var pickFields = [];
<%		if USE_CONFIDENCE_POINTS then %>
		// Define an array to hold the confidence points fields for each game.
		var confFields = [];
<%		end if
		if USE_POINT_SPREADS or SHOW_POINT_SPREADS then %>
		// Define an array to hold the point spreads for each game.
		var pointSpreads = [];
<%		end if %>
		//---------------------------------------------------------------------
		// Initializes the quick pick feature.
		//---------------------------------------------------------------------
		function init() {

			// Get the entry form.
			formEl = document.getElementById("entryForm");
			if (formEl == null)
				return;

			// Get the number of games.
			numGames = formEl.elements["<% if USE_CONFIDENCE_POINTS then Response.Write("confPtsNumGames") else Response.Write("numGames") end if %>"].value;

			// Get the player's team rankings.
			var s = formEl.elements["teamRankings"].value;
			if (s.length > 0)
				teamRanks = s.split(",");

			// Get the pick fields for each game.
			var i;
			var el;
			for (i = 1; i <= numGames; i++) {
				el = formEl.elements["pick-" + i];
				pickFields.push(el);
			}
<%		if USE_CONFIDENCE_POINTS then %>
			// Get the confidence point fields for each game.
			for (var i = 1; i <= numGames; i++) {
				el = formEl.elements["conf-" + i];
				if (el == null)
					el = formEl.elements["lockedConf-" + i];
				confFields.push(el);
			}
<%		end if
		if USE_POINT_SPREADS or SHOW_POINT_SPREADS then %>
			// Get the point spreads for each game.
			for (var i = 1; i <= numGames; i++) {
				var n = 0;
				if ((el = formEl.elements["pointSpread-" + i]) != null)
					n = el.value;
				if (isNaN(n))
					n = 0;
				pointSpreads.push(n);
			}
<%		end if %>
			// Show the links.
			if ((el = document.getElementById("quickPicksDisplay")) != null)
				el.style.display = "";
		}

		//---------------------------------------------------------------------
		// Returns the rank of the given team.
		//---------------------------------------------------------------------
		function getTeamRank(teamID) {

			for (var i = 0; i < teamRanks.length; i++)
				if (teamRanks[i] == teamID)
					return i + 1;

			return 0;
		}

		//---------------------------------------------------------------------
		// Returns an array of confidence points available for assignment.
		//---------------------------------------------------------------------
		function getAvailablePoints() {

				// Build a list of confidence points available for assignment.
				var points = [];
				var i, j;
				var locked;
				for (i = 1; i <= numGames; i++) {

					// If the point value is not locked and the pick is not set
					// to be kept, add it to the list.
					locked = false;
					for (j = 0; j < numGames && !locked; j++) {
						if ((confFields[j].type == "hidden" || keepPick(j + 1)) && confFields[j].value == i)
						locked = true;
					}
					if (!locked)
						points.push(i);
				}

				return points;
		}

		//---------------------------------------------------------------------
		// Returns true if the keep option for a given pick is checked.
		//---------------------------------------------------------------------
		function keepPick(n) {
			var el = formEl.elements["keep-" + n];
			if (el != null && el.checked != null)
				return el.checked;
			return false;
		}

		//=====================================================================
		// Initialization code.
		//=====================================================================

		// Initialize on page load.
		domUtils.onready(init);

		//=====================================================================
		// Public properties and methods.
		//=====================================================================
		return {
<%		if USE_CONFIDENCE_POINTS then
			if USE_POINT_SPREADS or SHOW_POINT_SPREADS then %>
			//-----------------------------------------------------------------
			// Assigns confidence points based on the point spread and player's
			// pick.
			//-----------------------------------------------------------------
			pointsBySpread : function () {

				// Create a list of objects to hold information for each pick
				// (excluding those checked for keeping).
				var list = [];
				for (var i = 0; i < numGames; i++)
					if (pickFields[i] != null && !keepPick(i + 1))
						list.push({
							pickField:   pickFields[i],
							confField:   confFields[i],
							pointSpread: pointSpreads[i],
							sortValue:   null
						});

				// Calculate a sort value for each of those games based on the
				// current pick and point spread.
				for (i = 0; i < list.length; i++) {
					list[i].sortValue = 0;

					// If the favorite is picked, use a positive value based on
					// the spread.		
					if ((list[i].pickField[0].checked && list[i].pointSpread < 0) || (list[i].pickField[1].checked && list[i].pointSpread >= 0))
						list[i].sortValue = Math.abs(list[i].pointSpread);

					// If the underdog is picked, use a negative value based on
					// the spread.		
					if ((list[i].pickField[1].checked && list[i].pointSpread < 0) || (list[i].pickField[0].checked && list[i].pointSpread >= 0))
						list[i].sortValue = -Math.abs(list[i].pointSpread);
				}

				// Now sort the games by those values. This will order them
				// from most confident to least confident based on the point
				// spread.
				list = list.sort(function (a, b) {
					return b.sortValue - a.sortValue;
				});

				// Get a list of available confidence points and sort them
				// from high to low.
				var points = getAvailablePoints();
				points = points.sort(function (a, b) {
					return b - a;
				});

				// Now assign the points to the picks.
				for (i = 0; i < list.length; i++)
					list[i].confField.value = points.shift();

				// Update the confidence points status display.
				confPtsStatus.update(formEl);

				return false;
			},
<%		    end if %>
			//-----------------------------------------------------------------
			// Assigns confidence points based on the player's team rankings
			// and pick.
			//-----------------------------------------------------------------
			pointsByRank : function () {

				// Create a list of objects to hold information for each pick
				// (excluding those checked for keeping).
				var list = [];
				for (var i = 0; i < numGames; i++)
					if (pickFields[i] != null && !keepPick(i + 1))
						list.push({
							pickField: pickFields[i],
							confField: confFields[i],
							sortValue: null
						});

				// Calculate a sort value for each of those games based on the
				// current pick and relative team ranking.
				for (i = 0; i < list.length; i++) {
					list[i].sortValue = 0;

					// Get the difference between visiting and home team ranks.
					var rankDiff = getTeamRank(list[i].pickField[0].value) - getTeamRank(list[i].pickField[1].value);

					// If the higher ranked team is picked, use a positive
					// value based on the difference.
					if ((list[i].pickField[0].checked && rankDiff < 0) || (list[i].pickField[1].checked && rankDiff >= 0))
						list[i].sortValue = Math.abs(rankDiff);

					// If the lower ranked is picked, use a negative value
					// based on the difference.		
					if ((list[i].pickField[1].checked && rankDiff < 0) || (list[i].pickField[0].checked && rankDiff >= 0))
						list[i].sortValue = -Math.abs(rankDiff);
				}
					
				// Now sort the games by those values. This will order them
				// from most confident to least confident based on the
				// difference in team ranking.
				list = list.sort(function (a, b) {
					return b.sortValue - a.sortValue;
				});

				// Get a list of available confidence points and sort them
				// from high to low.
				var points = getAvailablePoints();
				points = points.sort(function (a, b) {
					return b - a;
				});

				// Now assign the points to the picks.
				for (i = 0; i < list.length; i++)
					list[i].confField.value = points.shift();

				// Update the confidence points status display.
				confPtsStatus.update(formEl);

				return false;
			},

			//-----------------------------------------------------------------
			// Assigns confidence points at random.
			//-----------------------------------------------------------------
			pointsByRandom : function () {

				// Get a list of available confidence points.
				var points = getAvailablePoints();

				// Find any locked games that have no pick/point assignment and
				// for each one, remove the lowest available confidence points
				// value.
				var locked = 0;
				for (var i = 0; i < numGames; i++)
					if (confFields[i].type == "hidden" && confFields[i].value == "")
						locked++;
				for (i = 0; i < locked; i++)
					points.shift(0);

				// Randomize the remaining list.
				var m = points.length;
				var n = m * m;
				var p, q, temp;
				for (i = 0; i < n; i++) {
					p = Math.floor(Math.random() * m );
					q = Math.floor(Math.random() * m );
					if (p != q) {
						temp = points[p];
						points[p] = points[q];
						points[q] = temp;
					}
				}

				// Assign those points to the open picks.
				for (i = 0; i < numGames; i++) {
					if (confFields[i].type != "hidden" && !keepPick(i + 1))
						confFields[i].value = points.pop();
				}

				// Update the confidence points status display.
				confPtsStatus.update(formEl);

				return false;
			},

			//-----------------------------------------------------------------
			// Clears all confidence points.
			//-----------------------------------------------------------------
			clearPoints : function () {

				// Clear the confidence point selection on all open picks.
				for (var i = 0; i < numGames; i++)
					if (confFields[i].type != "hidden" && !keepPick(i + 1))
						confFields[i].selectedIndex = 0;

				// Update the confidence points status display.
				confPtsStatus.update(formEl);

				return false;
			},
<%		end if %>
			//-----------------------------------------------------------------
			// Picks all visiting teams.
			//-----------------------------------------------------------------
			pickAllAway : function () {

				// Select the visiting team;s radio button on all open picks.
				for (var i = 0; i < numGames; i++)
					if (pickFields[i] != null && !keepPick(i + 1)) {
						pickFields[i][0].checked = true;
						pickFields[i][1].checked = false;
					}

				return false;
			},

			//-----------------------------------------------------------------
			// Picks all home teams.
			//-----------------------------------------------------------------
			pickAllHome : function () {

				// Select the home team's radio button on all open picks.
				for (var i = 0; i < numGames; i++)
					if (pickFields[i] != null && !keepPick(i + 1)) {
						pickFields[i][0].checked = false;
						pickFields[i][1].checked = true;
					}

				return false;
			},
<%		if USE_POINT_SPREADS or SHOW_POINT_SPREADS then %>
			//-----------------------------------------------------------------
			// Picks all favorites based on the point spread (the home team is
			// picked if there is no favorite).
			//-----------------------------------------------------------------
			pickAllFavorites : function () {

				// Select the favored team on all open picks.
				for (var i = 0; i < numGames; i++)
					if (pickFields[i] != null && !keepPick(i + 1)) {
						pickFields[i][0].checked = false;
						pickFields[i][1].checked = true;
						if (pointSpreads[i] < 0)
							pickFields[i][0].checked = true;
						else
							pickFields[i][1].checked = true;
					}

				return false;
			},

			//-----------------------------------------------------------------
			// Picks all underdogs based on the point spread (the visiting team
			// is picked if there is no favorite).
			//-----------------------------------------------------------------
			pickAllUnderdogs : function () {

				// Select the underdog team on all open picks.
				for (var i = 0; i < numGames; i++)
					if (pickFields[i] != null && !keepPick(i + 1)) {
						pickFields[i][0].checked = false;
						pickFields[i][1].checked = true;
						if (pointSpreads[i] >= 0)
							pickFields[i][0].checked = true;
						else
							pickFields[i][1].checked = true;
					}

				return false;
			},
<%		end if %>
			//-----------------------------------------------------------------
			// Picks teams based on the player's rankings.
			//-----------------------------------------------------------------
			pickByRank : function () {

				// Select the better ranked team on all open picks.
				for (var i = 0; i < numGames; i++)
					if (pickFields[i] != null && !keepPick(i + 1)) {
						var found = false;
						for (var j = 0; j < teamRanks.length && !found; j++) {
							if (pickFields[i][0].value == teamRanks[j]) {
								pickFields[i][0].checked = true;
								pickFields[i][1].checked = false;
								found = true;
							}
							else if (pickFields[i][1].value == teamRanks[j]) {
								pickFields[i][0].checked = false;
								pickFields[i][1].checked = true;
								found = true;
							}
						}
					}

				return false;
			},

			//-----------------------------------------------------------------
			// Picks teams at random.
			//-----------------------------------------------------------------
			pickByRandom : function () {

				// Select a team at random on all open picks.
				for (var i = 0; i < numGames; i++)
					if (pickFields[i] != null && !keepPick(i + 1)) {
						pickFields[i][0].checked = false;
						pickFields[i][1].checked = true;
						if (Math.random() < 0.5)
							pickFields[i][0].checked = true;
						else
							pickFields[i][1].checked = true;
					}

				return false;
			},

			//-----------------------------------------------------------------
			// Clears all picks.
			//-----------------------------------------------------------------
			clearPicks : function () {

				// Clear the team selection on all open picks.
				for (var i = 0; i < numGames; i++)
					if (pickFields[i] != null && !keepPick(i + 1)) {
						pickFields[i][0].checked = false;
						pickFields[i][1].checked = false;
					}

				return false;
			}
		}
	}();

	//]]></script>
<%	end if %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Get the week to display.
	dim week
	week = GetRequestedWeek()

	'If the user is the Administrator, check for a user name in the request.
	'Otherwise, show data for the current user.
	dim username
	username = Session(SESSION_USERNAME_KEY)
	if IsAdmin() then
		username = Trim(Request("username"))
	end if

	'For the Administrator, build a user selection list.
	if IsAdmin() then %>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<table class="main" border="0" cellpadding="0" cellspacing="0">
		<tr class="header bottomEdge">
			<th align="left">Administrator Access</th>
		</tr>
		<tr>
			<td class="adminSection freeForm">
				<p>You may view or edit any player's entry form by selecting a username below.<br />
				Use the links at the bottom of the page to switch to a specific week.</p>
				<table border="0" cellpadding="0" cellspacing="0">
					<tr valign="middle">
						<td><strong>Select user:</strong></td>
						<td>
							<input type="hidden" name="week" value="<% = week %>" />
							<select name="username">
								<% call DisplayUserSelectList(GetUserList(true), username) %>
							</select>
						</td>
						<td><input type="submit" name="submit" value="Select" class="button" /></td>
					</tr>
				</table>
			</td>
		</tr>
		</table>
	</form>
<%		if username <> "" then %>
	<h2>Entry Form for <% = username %></h2>
<%		end if
	end if

	'Determine if the user has an entry for the given week (so we can display
	'the Delete button).
	dim hasEntry
	hasEntry = false
	if username <> "" and InWeeklyPool(username, week) then
		hasEntry = true
	end if

	'Initialize lock flags.
	dim allLocked, anyLocked
	allLocked = IsWeekLocked(week)
	anyLocked = allLocked

	'Create an array of game objects.
	dim games, rs, n
	dim i
	n = GetGameCount(week)
	redim games(n - 1)
	set rs = GetGamesRecordset(week)
	if not (rs.EOF and rs.BOF) then
		i = 0
		do while not rs.EOF
			set games(i) = new GameObj
			games(i).setData(rs)
			i = i + 1
			rs.MoveNext
		loop
	end if

	'If there is form data, process it.
	dim sql
	dim needDeleteConfirmation, entryDeleted
	dim pick, conf, tb
	dim pickMissingMsg, confMissingMsg
	dim confUsed
	needDeleteConfirmation = false
	entryDeleted = false

	'Process a delete request.
	if Request.Form("submit") = "Delete" then

		if not IsAdmin() and anyLocked then
			call DisplayErrorMessage("Error: One or more games for this week have been locked, entry cannot be deleted.")
		elseif LCase(Request.Form("confirmDelete")) <> "true" then
			needDeleteConfirmation = true
			call DisplayWarningMessage("To confirm deletion, check the box below and press <code>Delete</code> again. Pressing any other button will cancel the deletion.")
		elseif GetCompletedGameCount(week) = GetGameCount(week) then
			call DisplayErrorMessage("Error: Cannot delete entries for completed weeks.")
		else

			'Delete the player's entry.
			for i = 0 to UBound(games)
				sql = "DELETE FROM WeeklyPicks" _
				   & " WHERE Username = '" & SqlEscape(username) & "'" _
				   & " AND GameID = " & games(i).id
				call DbConn.Execute(sql)
			next
			sql = "DELETE FROM WeeklyScoring" _
			    & " WHERE Week = " & week _
			    & " AND Username = '" & SqlEscape(username) & "'"
			call DbConn.Execute(sql)
			entryDeleted = true
			hasEntry = false

			'Clear any saved weekly results data.
			call ClearWeeklyResultsCache(week)

			'Clear pick and confidence point assignments for each game.
			for i = 0 to UBound(games)
				games(i).storedPick = ""
				games(i).storedConf = ""
			next

			call DisplaySuccessMessage("Entry has been deleted.")
		end if

	'Process an update request.
	elseif Request.Form("submit") = "Update" then

		'Prevent entries by the Admin.
		if username = ADMIN_USERNAME then
			call DisplayErrorMessage("Error: User '" & ADMIN_USERNAME & "' may not make picks.")

		'If the user is disabled, prevent the entry.
		elseif IsDisabled() then
			call DisplayErrorMessage("Error: Your account has been disabled, changes not accepted. Please contact the Administrator.")

		'If all games have been locked, prevent any updates (except by the Admin).
		elseif not IsAdmin() and allLocked then
			call DisplayErrorMessage("Error: All games for this week have been locked, changes not accepted.")

		'Otherwise, process the request.
		else

			'Validate the pick and confidence point fields.
			pickMissingMsg = "You must make a pick to set your confidence points."
			confMissingMsg = "You must enter your confidence points when making a pick for a game."
			if USE_CONFIDENCE_POINTS then
				for i = 0 to UBound(games)
					pick = Trim(Request.Form("pick-" & (i + 1)))
					conf = Trim(Request.Form("conf-" & (i + 1)))

					'Make sure that if a pick was made, confidence points were
					'entered and vice-versa.
					if pick = "" and conf <> "" then
						FormFieldErrors.Add "pick-" & (i + 1), pickMissingMsg
						pickMissingMsg = ""
					end if
					if pick <> "" and conf = "" then
						FormFieldErrors.Add "conf-" & (i + 1), confMissingMsg
						confMissingMsg = ""
					end if

					'Validate the confidence points entered, if any.
					if conf <> "" then
						if not IsValidInteger(conf) then
							FormFieldErrors.Add "conf-" & (i + 1), "'" & conf & "' is not a valid confidence point value."
						elseif CInt(conf) < 1 or CInt(conf) > UBound(games) + 1 then
							FormFieldErrors.Add "conf-" & (i + 1), "'" & conf & "' is not a valid confidence point value."
						end if
					end if

				next

				'Make sure the confidence points for each pick are unique.
				redim confUsed(UBound(games) + 1)
				for i = 0 to UBound(games)
					confUsed(i) = false
				next
				for i = 0 to UBound(games)
					conf = GetFieldValue("conf-" & (i + 1), games(i).storedConf)
					if conf <> "" then
						if confUsed(conf) then
							FormFieldErrors.Add "conf-" & (i + 1), "'" & conf & "' is already assigned to a different game."
						else
							confUsed(conf) = true
						end if
					end if
				next

			end if

			'Validate the tiebreaker field.
			tb = Trim(Request.Form("tb-" & week))
			if tb = "" then
				FormFieldErrors.Add "tb-" & week, "You must enter a point total for the tiebreaker."
			elseif not IsValidInteger(tb) then
				FormFieldErrors.Add "tb-" & week, "'" & tb & "' is not a valid point total."
			elseif CInt(tb) < 0 then
				FormFieldErrors.Add "tb-" & week, "'" & tb & "' is not a valid point total."
			end if

			'Make sure no picks were made for locked games.
			if not IsAdmin() and not allLocked then
				for i = 0 to UBound(games)
					if Request.Form("pick-" & (i + 1)) <> "" and games(i).isLocked then
						FormFieldErrors.Add "pick-" & (i + 1), "The " & games(i).visitorName & " at " & games(i).homeName & " game has been locked and cannot be changed."
					end if
				next
			end if

			'If there were any errors, display the error messages. Otherwise, do
			'the updates.
			if FormFieldErrors.Count > 0 then
				call DisplayFormFieldErrorsMessage("Error: Invalid fields. Please correct and resubmit.")
			else
				for i = 0 to UBound(games)
					if not IsAdmin() and games(i).isLocked then
						pick = GetFieldValue("pick-" & (i + 1), games(i).storedPick)
						conf = GetFieldValue("conf-" & (i + 1), games(i).storedConf)
					else
						pick = GetFieldValue("pick-" & (i + 1), "")
						conf = GetFieldValue("conf-" & (i + 1), "NULL")
					end if
					if not IsNumeric(conf) then
						conf = "NULL"
					end if
					sql = "DELETE FROM WeeklyPicks" _
					   & " WHERE Username = '" & SqlEscape(username) & "'" _
					   & " AND GameID = " & games(i).id
					call DbConn.Execute(sql)
					sql = "INSERT INTO WeeklyPicks" _
					   & " (Username, GameID, Pick, Confidence)" _
					   & " VALUES('" & SqlEscape(username) & "'," _
					   & " " & games(i).id & ", " _
					   & " '" & pick & "'," _
					   & conf & ")"
					call DbConn.Execute(sql)
				next
				sql = "DELETE FROM WeeklyScoring" _
				    & " WHERE Week = " & week _
				    & " AND Username = '" & SqlEscape(username) & "'"
				call DbConn.Execute(sql)   
				sql = "INSERT INTO WeeklyScoring" _
				   & " (Week, Username, Tiebreaker)" _
				   & " VALUES(" & week & ", " _
				   & "'" & SqlEscape(username) & "', " _
				   & tb & ")"
				call DbConn.Execute(sql)

				'Clear any saved weekly results data.
				call ClearWeeklyResultsCache(week)

				'Updates complete, redirect to the results page.
				if IsAdmin() then
					Response.Redirect("weeklyResults.asp?week=" & week & "&username=" & Server.URLEncode(username))
				else
					Response.Redirect("weeklyResults.asp?week=" & week)
				end if
			end if
		end if
	end if

	'Get the user's current team rankings.
	dim ranks
	dim j
	ranks = ""
	if username <> "" then
		sql = "SELECT TeamRankings FROM Users WHERE Username = '" & SqlEscape(username) & "'"
		set rs = DbConn.Execute(sql)
		if not (rs.EOF and rs.BOF) then
			ranks = rs.Fields("TeamRankings").Value
		end if
	end if

	'Build the entry form for that week.
	if username <> "" then
		dim cols
		cols = 8
		if ENABLE_QUICK_PICKS or anyLocked then
			cols = cols + 1
		end if
		if ALLOW_TIE_PICKS then
			cols = cols + 2
		end if
		if USE_CONFIDENCE_POINTS then
			cols = cols + 1
		end if
		if USE_POINT_SPREADS or SHOW_POINT_SPREADS then
			cols = cols + 1
		end if
		if ENABLE_QUICK_PICKS and IsAdmin() then
				cols = cols + 1
		end if %>
	<form id="entryForm" action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
		<div>
<%		if IsAdmin() then %>
			<input type="hidden" name="username" value="<% = username %>" />
<%		end if %>
			<input type="hidden" name="week" value="<% = week %>" />
<%		'Add form fields for client-side scripts as needed.
		if USE_CONFIDENCE_POINTS then %>
			<input type="hidden" name="confPtsNumGames" value="<% = UBound(games) + 1 %>" />
			<input type="hidden" name="confPtsStatusID" value="confPtsStatus" />
<%		elseif ENABLE_QUICK_PICKS then %>
			<input type="hidden" name="numGames" value="<% = UBound(games) + 1 %>" />
<%		end if
		if ENABLE_QUICK_PICKS then %>
			<input type="hidden" name="teamRankings" value="<% = ranks %>" />
<%		end if %>
		</div>
		<table border="0" cellpadding="0" cellspacing="0"><tr><td style="padding: 0px;">
		<table class="main" border="0" cellpadding="0" cellspacing="0">
			<tr class="header bottomEdge">
				<th align="left" colspan="<% = cols %>">Week <% = week %></th>
			</tr>
<%		if ENABLE_QUICK_PICKS and (IsAdmin() or not allLocked ) then %>
			<tr id="quickPicksDisplay" class="subHeader bottomEdge" style="display: none;">
				<th><span class="small">Keep</span></th>
				<th align="right" colspan="<% = cols - 1 %>">
				<span class="small">
					Pick:
					<a href="#" onclick="return quickPick.pickAllAway();">All Away</a>
					&middot;
					<a href="#" onclick="return quickPick.pickAllHome();">All Home</a>
					&middot;
<%			if USE_POINT_SPREADS or SHOW_POINT_SPREADS then %>
					<a href="#" onclick="return quickPick.pickAllFavorites();">All Favorites</a>
					&middot;
					<a href="#" onclick="return quickPick.pickAllUnderdogs();">All Underdogs</a>
					&middot;
<%			end if
			if ranks <> "" then %>
					<a href="#" onclick="return quickPick.pickByRank();">By Rank</a>
					&middot;
<%			end if %>
					<a href="#" onclick="return quickPick.pickByRandom();">Random</a>
					&middot;
					<a href="#" onclick="return quickPick.clearPicks();">Clear</a>
<%			if USE_CONFIDENCE_POINTS then %>
					&nbsp;&nbsp;
					Confidence:
<%				if USE_POINT_SPREADS or SHOW_POINT_SPREADS then %>
					<a href="#" onclick="return quickPick.pointsBySpread();">By Spread</a>
					&middot;
<%				end if
				if ranks <> "" then %>
					<a href="#" onclick="return quickPick.pointsByRank();">By Rank</a>
					&middot;
<%				end if %>
					<a href="#" onclick="return quickPick.pointsByRandom();">Random</a>
					&middot;
					<a href="#" onclick="return quickPick.clearPoints();">Clear</a>
<%			end if %>
				</span>
				</th>
			</tr>
<%		end if

		dim visitor, home, tie
		dim vpicked, hpicked, tpicked
		dim correctPick, giveTie
		dim lockedConf
		dim alt
		alt = false
		for i = 0 to UBound(games)
			if alt then %>
			<tr align="right" class="alt singleLine">
<%			else %>
			<tr align="right" class="singleLine">
<%			end if
			alt = not alt

			'Handle the leftmost columns shown to the Admin.
			if IsAdmin() then

				'If quick picks are enabled, show the checkbox in one column.
				if ENABLE_QUICK_PICKS then %>
					<td align="center"><input type="checkbox" name="keep-<% = (i + 1) %>" value="true"<% if games(i).storedPick <> "" and games(i).isLocked then Response.Write(" checked=""checked""") end if %> /></td>
<%				end if

				'If any games are locked, show the game lock status in another
				'column.
				if anyLocked then
					if games(i).isLocked then %>
					<td align="center"><img src="graphics/locked.png" alt="Locked" /></td>
<%					else %>
					<td>&nbsp;</td>
<%					end if
				end if

			'Handle the leftmost column shown to players.
			else

				'Add at most one column to show either the quick picks
				'checkbox or the game lock status.
				if games(i).isLocked then %>
					<td align="center"><img src="graphics/locked.png" alt="Locked" /></td>
<%				elseif ENABLE_QUICK_PICKS then %>
					<td align="center"><input type="checkbox" name="keep-<% = (i + 1) %>" value="true" /></td>
<%				elseif anyLocked then %>
					<td>&nbsp;</td>
<%				end if
			end if %>
				<td align="left"><% = WeekdayName(Weekday(games(i).dateTime), true) %></td>
				<td><% = FormatDate(games(i).dateTime) %></td>
				<td><% = FormatTime(games(i).dateTime) %></td>
<%			'Get team names.
			visitor = games(i).visitorName
			home    = games(i).homeName
			tie     = "&nbsp;"

			'Get the player's pick data for this game.
			if (not IsAdmin() and games(i).isLocked) or entryDeleted then
				pick = games(i).storedPick
				conf = games(i).storedConf
			else
				pick = GetFieldValue("pick-" & (i + 1), games(i).storedPick)
				conf = GetFieldValue("conf-" & (i + 1), games(i).storedConf)
			end if

			'Highlight fields based on the game result.
			if games(i).result = games(i).visitorID then
				visitor = FormatWinner(visitor)
			elseif games(i).result = games(i).homeID then
				home = FormatWinner(home)
			elseif games(i).result = TIE_STR then
				tie = FormatWinner(TIE_STR)
			end if
			if USE_POINT_SPREADS then
				if games(i).atsResult = games(i).visitorID then
					visitor = FormatATSWinner(visitor)
				elseif games(i).atsResult = games(i).homeID then
					home = FormatATSWinner(home)
				elseif games(i).atsResult = TIE_STR then
					tie = FormatATSWinner(TIE_STR)
				end if
			end if

			'Handle the display for a locked game.
			if not IsAdmin() and games(i).isLocked then

				'Save the raw confidence points value (used by the client-side script).
				lockedConf = conf

				'Determine the correct pick.
				if USE_POINT_SPREADS then
					correctPick = games(i).atsResult
				else
					correctPick = games(i).result
				end if

				'Set the pick displays.
				vpicked = "&nbsp;"
				hpicked = "&nbsp;"
				tpicked = "&nbsp;"
				if pick = games(i).visitorID then
					vpicked = "X"
				elseif pick = games(i).homeID then
					hpicked = "X"
				elseif pick = TIE_STR then
					tpicked = "X"
				end if

				'If tie picks are not allowed and the game result was a tie,
				'give the player the pick.
				giveTie = false
				if not ALLOW_TIE_PICKS and correctPick = TIE_STR and pick <> "" then
					giveTie = true
					if pick = games(i).visitorID then
						vpicked = FormatTie(vpicked)
					else
						hpicked = FormatTie(hpicked)
					end if
				end if

				'Format a correct/incorrect pick.
				if correctPick <> "" and not giveTie then
					if pick = correctPick then
						if pick = games(i).visitorID then
							vpicked = FormatCorrectPick(vpicked)
						elseif pick = games(i).homeID then
							hpicked = FormatCorrectPick(hpicked)
						else
							tpicked = FormatCorrectPick(tpicked)
						end if
					else
						if pick = games(i).visitorID then
							vpicked = FormatIncorrectPick(vpicked)
						elseif pick = games(i).homeID then
							hpicked = FormatIncorrectPick(hpicked)
						else
							tpicked = FormatIncorrectPick(tpicked)
						end if
					end if
				end if

				'Format the confidence points display.
				if USE_CONFIDENCE_POINTS then
					if conf <> "" then
						conf = conf & "&nbsp;pts."
						if giveTie then
							conf = FormatTie(conf)
						end if
						if pick = correctPick then
							conf = FormatCorrectPick(conf)
						end if
					end if
				end if

				'Pad the pick and confidence point displays.
				if not giveTie then
					vpicked = vpicked & "&nbsp;&nbsp;"
					hpicked = hpicked & "&nbsp;&nbsp;"
					tpicked = tpicked & "&nbsp;&nbsp;"
					conf    = conf    & "&nbsp;&nbsp;"
				end if
				vpicked = "&nbsp;&nbsp;" & vpicked
				hpicked = "&nbsp;&nbsp;" & hpicked
				tpicked = "&nbsp;&nbsp;" & tpicked
				conf    = "&nbsp;" & conf %>
				<td><% = vpicked %></td>
				<td align="left"><% call DisplayTeamLogo(games(i).visitorID) %><% = visitor %><% call DisplayTeamRecord(games(i).visitorID, week, USE_POINT_SPREADS or SHOW_POINT_SPREADS) %></td>
<%				if USE_POINT_SPREADS or SHOW_POINT_SPREADS then %>
				<td><% = FormatPointSpread(games(i).pointSpread) %></td>
<%				end if %>
				<td>at</td>
				<td><% = hpicked %></td>
				<td align="left"><% call DisplayTeamLogo(games(i).homeID) %><% = home %><% call DisplayTeamRecord(games(i).homeID, week, USE_POINT_SPREADS or SHOW_POINT_SPREADS) %></td>
<%				if ALLOW_TIE_PICKS then %>
				<td><% = tpicked %></td>
				<td><% = tie %></td>
<%				end if

				'Add the confidence points assigned to the locked game as a
				'form field (used by the client-side script).
				if USE_CONFIDENCE_POINTS then %>
				<td><input type="hidden" name="lockedConf-<% = (i + 1) %>" value="<% = lockedConf %>" /><% = conf %></td>
<%				end if

			'Handle the display for an unlocked game.
			else %>
				<td align="center"><span class="<% = StyleFormField("fieldWrapper", "pick-" & (i + 1)) %>"><input type="radio" id="pick-<% = (i + 1) %>-V" name="pick-<% = (i + 1) %>" value="<% = games(i).visitorID %>"<% if pick = games(i).visitorID then Response.Write(CHECKED_ATTRIBUTE) end if %> /></span></td>
				<td align="left"><label for="pick-<% = (i + 1) %>-V"><% call DisplayTeamLogo(games(i).visitorID) %><% = visitor %><% call DisplayTeamRecord(games(i).visitorID, week, USE_POINT_SPREADS or SHOW_POINT_SPREADS) %></label></td>
<%				if USE_POINT_SPREADS or SHOW_POINT_SPREADS then %>
				<td>
<%					'Add the point spread as a form field (used by the
					'client-side script).
					if ENABLE_QUICK_PICKS and (IsAdmin() or not allLocked ) then %>
					<input type="hidden" name="pointSpread-<% = (i + 1) %>" value="<% = games(i).pointSpread %>" />
<%					end if %>
					<label for="pick-<% = (i + 1) %>-V"><% = FormatPointSpread(games(i).pointSpread) %></label>
				</td>
<%				end if %>
				<td>at</td>
				<td align="center"><span class="<% = StyleFormField("fieldWrapper", "pick-" & (i + 1)) %>"><input type="radio" id="pick-<% = (i + 1) %>-H" name="pick-<% = (i + 1) %>" value="<% = games(i).homeID %>"<% if pick = games(i).homeID then Response.Write(CHECKED_ATTRIBUTE) end if %> /></span></td>
				<td align="left"><label for="pick-<% = (i + 1) %>-H"><% call DisplayTeamLogo(games(i).homeID) %><% = home %><% call DisplayTeamRecord(games(i).homeID, week, USE_POINT_SPREADS or SHOW_POINT_SPREADS) %></label></td>
<%				if ALLOW_TIE_PICKS then %>
				<td align="center"><span class="<% = StyleFormField("fieldWrapper", "pick-" & (i + 1)) %>"><input type="radio" id="pick-<% = (i + 1) %>-T" name="pick-<% = (i + 1) %>" value="<% = TIE_STR %>"<% if pick = TIE_STR then Response.Write(CHECKED_ATTRIBUTE) end if %> /></span></td>
				<td><label for="pick-<% = (i + 1) %>-T">Tie</label></td>
<%				end if
				if USE_CONFIDENCE_POINTS then %>
				<td align="right">
					<select name="conf-<% = (i + 1) %>" class="<% = StyleFormField("numeric", "conf-" & (i + 1)) %>" onchange="confPtsStatus.update(this.form);">
<%					call DisplayConfidencePointsList(UBound(games) + 1, conf) %>
					</select>&nbsp;pts.&nbsp;&nbsp;
				</td>
<%				end if
			end if %>
			</tr>
<%		next

		'Add a row for dynamically displaying the available confidence points.
		if USE_CONFIDENCE_POINTS and (IsAdmin() or not allLocked) then %>
			<tr class="subHeader topEdge" style="display: none;">
				<th id="confPtsStatus" colspan="<% = cols %>"></th>
			</tr>
<%		end if

		'Build the player's score display, when available.
		dim score, numGames, pctStr, scoreStr
		numGames = GetCompletedGameCount(week)
		scoreStr = ""
		pctStr = ""
		if numGames > 0 then
			score = GetWeeklyPickScore(username, week)
			if IsNumeric(score) and IsNumeric(numGames) then
				scoreStr = score & "/" & numGames
				pctStr = " (" & FormatPercentage(score / numGames) & ")"
				if USE_CONFIDENCE_POINTS then
					score = GetWeeklyConfidenceScore(username, week)
					if IsNumeric(score) then
						scoreStr = scoreStr & pctStr & "&nbsp;&nbsp;<strong>" & FormatScore(score, false) & " pts. </strong>"
					end if
				else
					scoreStr = "<strong>" & scoreStr & "</strong>" & pctStr
				end if
			end if 
		end if
		if scoreStr <> "" then %>
			<tr class="header topEdge bottomEdge">
				<th align="left" colspan="<% = cols %>">Score</th>
			</tr>
			<tr>
				<td align="right" colspan="<% = cols %>"><% = scoreStr %></td>
			</tr>
<%		end if

		'Get the tiebreaker game (the last scheduled game of the week).
		dim tbTitle, tbStr
		tbTitle = "Total points in the <strong>" & games(UBound(games)).visitorName & " at " & games(UBound(games)).homeName & "</strong> game"

		 'Get the user's tiebreaker guess for this week.
		dim storedTb
		storedTb = GetWeeklyTiebreakerGuess(username, week)
		if (not IsAdmin() and allLocked) then
			tb = storedTb
		else
			tb = GetFieldValue("tb-" & week, storedTb)
		end if
		if entryDeleted then
			tb = ""
		end if

		'Get the tiebreaker data.
		if allLocked then

			'Check for a tiebreaker point total.
			dim tbTarget
			tbTarget = GetWeeklyTiebreakerActual(week)
			if IsNumeric(tb) and IsNumeric(tbTarget) then
				tbStr = tb & "&nbsp;<strong>(" & Abs(tbTarget - tb) & ")</strong>"
			elseif tb = "" then
				tbStr = "n/a"
			else
				tbStr = tb
			end if
			if IsNumeric(tbTarget) then
				tbTitle = tbTitle & " <strong>(" & tbTarget & ")</strong>"
			end if

		end if
		tbTitle = tbTitle & ":" %>
			<tr class="header topEdge bottomEdge">
				<th align="left" colspan="<% = cols %>">Tiebreaker</th>
			</tr>
			<tr>
				<td colspan="<% = (cols - 2) %>"><% = tbTitle %></td>
				<td align="right" colspan="2">
<%		'If all the games are locked, display the tiebreaker info. Otherwise,
		'display a form field for it.
		if not IsAdmin() and allLocked then
			Response.Write(String(5, vbTab) & tbStr)
		else %>
					<input type="text" name="tb-<% = week %>" value="<% = tb %>" size="3" class="<% = StyleFormField("numeric", "tb-" & week) %>" />
<%	 end if %>
				</td>
			</tr>
		</table>
<%		'List open dates.
		call DisplayOpenDates(week)

		'Show form buttons, if changes are allowed.
		if IsAdmin() or not allLocked then %>
		<p></p>
		<table border="0" cellpadding="0" cellspacing="0" style="width: 100%;">
			<tr valign="middle">
				<td style="padding: 0px;"><input type="submit" name="submit" value="Update" class="button" />&nbsp;<input type="submit" name="submit" value="Cancel" class="button" /></td>
<%			'If the user has an entry and no games are locked (or the user is the
			'Admin), add a delete button.
			if hasEntry and (IsAdmin() or not anyLocked) then

				'If delete was requested, add a confirmation checkbox.
				if needDeleteConfirmation then %>
				<td align="right" style="padding: 0px;"><input type="checkbox" id="confirmDelete" name="confirmDelete" value="true" /> <label for="confirmDelete">Confirm Deletion</label>&nbsp;</td>
<%				end if %>
				<td align="right" style="padding: 0px;"><input type="submit" name="submit" value="Delete" class="button" /></td>
<%			end if %>
			</tr>
		</table>
<%		end if %>
		</td></tr></table>
	</form>
<%	end if

	'List links to view other weeks.
	dim otherParams
	otherParams = ""
	if IsAdmin() then
		otherParams = "username=" & Server.HtmlEncode(username)
	end if
	call DisplayGoToNavigation("week", GetWeekCount(), otherParams) %>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' GameObj: Holds information for a single game.
	'--------------------------------------------------------------------------
	class GameObj

		public id, dateTime, visitorID, visitorName, homeID, homeName, pointSpread
		public result, atsResult
		public isLocked
		public storedPick, storedConf

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(rs)

			'Set the game properties using the supplied database record.
			id          = rs.Fields("GameID").Value
			dateTime    = CDate(rs.Fields("DateTime").Value)
			visitorID   = rs.Fields("VisitorID").Value
			visitorName = rs.Fields("VCity").Value
			homeID      = rs.Fields("HomeID").Value
			homeName    = rs.Fields("HCity").Value
			pointSpread = rs.Fields("PointSpread").Value
			result      = rs.Fields("Result").Value
			atsResult   = rs.Fields("ATSResult").Value
			isLocked    = false
			storedPick  = ""
			storedConf  = ""

			'Set the team names for display.
			if rs.Fields("VDisplayName").Value <> "" then
				visitorName = rs.Fields("VDisplayName").Value
			end if
			if rs.Fields("HDisplayName").Value <> "" then
				homeName = rs.Fields("HDisplayName").Value
			end if

			'Set the game's lock status.
			if allLocked or IsDateTimePast(dateTime) then
				anyLocked = true
				isLocked = true
			end if

			'Get the user's pick data for this game.
			dim sql, rs2
			sql = "SELECT Pick, Confidence FROM WeeklyPicks" _
			   & " WHERE Username = '" & SqlEscape(username) & "'" _
			   & " AND GameID = " & id
			set rs2 = DbConn.Execute(sql)
			if not (rs2.EOF and rs2.BOF) then
				storedPick = rs2.Fields("Pick").Value
				storedConf = rs2.Fields("Confidence").Value
			end if

		end sub

	end class %>

