<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/weekly.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Weekly Pick Statistics"
	call BuildPageHeader("tableSort.css", "tableSort.js") %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Define the picks table sort commands.
	//=========================================================================
	var picksNameSort = {
		initialSort : true,
		tbodyID     : "picksBody",
		theadID     : "picksHead",
		sortColumns : [
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [],
			headColumns : []
		}
	}
	var picksForSort = {
		tbodyID     : "picksBody",
		theadID     : "picksHead",
		sortColumns : [
			{ column : 2, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [1, 2],
			headColumns : [1]
		}
	}
	var picksAgainstSort = {
		tbodyID     : "picksBody",
		theadID     : "picksHead",
		sortColumns : [
			{ column : 4, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [3, 4],
			headColumns : [2]
		}
	}
	var picksCombinedSort = {
		tbodyID     : "picksBody",
		theadID     : "picksHead",
		sortColumns : [
			{ column : 6, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [5, 6],
			headColumns : [3]
		}
	}
<%	if USE_CONFIDENCE_POINTS then %>
	//=========================================================================
	// Define the confidence points table sort commands.
	//=========================================================================
	var confNameSort = {
		initialSort : true,
		tbodyID     : "confBody",
		theadID     : "confHead",
		sortColumns : [
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [],
			headColumns : []
		}
	}
	var confForSort = {
		tbodyID     : "confBody",
		theadID     : "confHead",
		sortColumns : [
			{ column : 2, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [1, 2],
			headColumns : [1]
		}
	}
	var confAgainstSort = {
		tbodyID     : "confBody",
		theadID     : "confHead",
		sortColumns : [
			{ column : 4, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [3, 4],
			headColumns : [2]
		}
	}
	var confCombinedSort = {
		tbodyID     : "confBody",
		theadID     : "confHead",
		sortColumns : [
			{ column : 6, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [5, 6],
			headColumns : [3]
		}
	}

	//=========================================================================
	// Define the average confidence points table sort commands.
	//=========================================================================
	var avgNameSort = {
		initialSort : true,
		tbodyID     : "avgBody",
		theadID     : "avgHead",
		sortColumns : [
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [],
			headColumns : []
		}
	}
	var avgForSort = {
		tbodyID     : "avgBody",
		theadID     : "avgHead",
		sortColumns : [
			{ column : 1, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [1],
			headColumns : [1]
		}
	}
	var avgAgainstSort = {
		tbodyID     : "avgBody",
		theadID     : "avgHead",
		sortColumns : [
			{ column : 2, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [2],
			headColumns : [2]
		}
	}
	var avgCombinedSort = {
		tbodyID     : "avgBody",
		theadID     : "avgHead",
		sortColumns : [
			{ column : 3, descending : true  },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [3],
			headColumns : [3]
		}
	}
<%	end if %>
	//]]></script>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Get the selected user.
	dim username, headerStr
	username = Trim(Request("username"))
	if username <> "" then
		headerStr = " for " & username
	else
		headerStr = ""
	end if

	'Initialize overall counts.
	dim totalCorrect, totalPicks
	dim totalGained, totalAssigned
	totalCorrect  = 0
	totalPicks    = 0
	totalGained   = 0
	totalAssigned = 0

	'Collect pick/confidence points data for all teams.
	dim teams
	dim n, i
	dim rs

	n = GetTeamCount()
	redim teams(n - 1)
	i = 0
	set rs = GetTeamsRecordset()
	if not (rs.EOF and rs.BOF) then
		do while not rs.EOF
			set teams(i) = new TeamObj
			teams(i).setData(rs.Fields("TeamID").Value)
			i = i + 1
			rs.MoveNext
		loop
	end if

	'Build the display.
	dim alt %>
	<h2>Picks by Team<% = headerStr %> <span class="headerNote">(Correct Picks / Total Picks)</span></h2>
	<table class="main" border="0" cellpadding="0" cellspacing="0" style="width: 100%">
		<thead id="picksHead">
			<tr class="header bottomEdge sortable">
				<th align="left"><a href="#" onclick="this.blur(); return tableSort.sort(picksNameSort);" title="Sort by team name.">Team</a></th>
				<th colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(picksForSort);" title="Sort by correct picks for percentage.">For</a></th>
				<th colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(picksAgainstSort);" title="Sort by correct picks against percentage.">Against</a></th>
				<th colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(picksCombinedSort);" title="Sort by combined correct picks percentage.">Combined</a></th>
			</tr>
		</thead>
		<tfoot>
			<tr class="header topEdge">
				<th align="left" colspan="4">Overall Correct / Total Picks</th>
				<th align="right" colspan="2"><% = FormatProportion(totalCorrect, totalPicks) %></th>
				<th><% = FormatProportionPercentage(totalCorrect, totalPicks) %></th>
			</tr>
		</tfoot>
		<tbody id="picksBody">
<%	alt = false
	for i = 0 to UBound(teams)
		if alt then %>
			<tr class="alt singleLine">
<%		else %>
			<tr class="singleLine">
<%		end if
		alt = not alt %>
				<td align="left"><a href="teamSchedules.asp?id=<% = teams(i).id %>"><% call DisplayTeamLogo(teams(i).id) %><% = teams(i).name %></a></td>
				<td align="right"><% = FormatProportion(teams(i).correctFor, teams(i).picksFor) %></td>
				<td><% = FormatProportionPercentage(teams(i).correctFor, teams(i).picksFor) %></td>
				<td align="right"><% = FormatProportion(teams(i).correctAgainst, teams(i).picksAgainst) %></td>
				<td><% = FormatProportionPercentage(teams(i).correctAgainst, teams(i).picksAgainst) %></td>
				<td align="right"><% = FormatProportion(teams(i).correctFor + teams(i).correctAgainst, teams(i).picksFor + teams(i).picksAgainst) %></td>
				<td><% = FormatProportionPercentage(teams(i).correctFor + teams(i).correctAgainst, teams(i).picksFor + teams(i).picksAgainst) %></td>
<%	next %>
		</tbody>
	</table>
<%	if USE_CONFIDENCE_POINTS then %>
	<h2>Confidence Points by Team<% = headerStr %> <span class="headerNote">(Points Gained / Total Points Assigned)</span></h2>
	<table class="main" border="0" cellpadding="0" cellspacing="0" style="width: 100%">
		<thead id="confHead">
			<tr class="header bottomEdge sortable">
				<th align="left"><a href="#" onclick="this.blur(); return tableSort.sort(confNameSort);" title="Sort by team name.">Team</a></th>
				<th colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(confForSort);" title="Sort by points gained picking for percentage.">For</a></th>
				<th colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(confAgainstSort);" title="Sort by points gained picking against percentage.">Against</a></th>
				<th colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(confCombinedSort);" title="Sort by combined points gained percentage.">Combined</a></th>
			</tr>
		</thead>
		<tfoot>
			<tr class="header topEdge">
				<th align="left" colspan="4">Overall Pts. Gained / Total Assigned</th>
				<th align="right" colspan="2"><% = FormatProportion(totalGained, totalAssigned) %></th>
				<th><% = FormatProportionPercentage(totalGained, totalAssigned) %></th>
			</tr>
		</tfoot>
		<tbody id="confBody">
<%		alt = false
		for i = 0 to UBound(teams)
			if alt then %>
			<tr class="alt singleLine">
<%			else %>
			<tr class="singleLine">
<%			end if
			alt = not alt %>
				<td align="left"><a href="teamSchedules.asp?id=<% = teams(i).id %>"><% call DisplayTeamLogo(teams(i).id) %><% = teams(i).name %></a></td>
				<td align="right"><% = FormatProportion(teams(i).gainedFor, teams(i).pointsFor) %></td>
				<td><% = FormatProportionPercentage(teams(i).gainedFor, teams(i).pointsFor) %></td>
				<td align="right"><% = FormatProportion(teams(i).gainedAgainst, teams(i).pointsAgainst) %></td>
				<td><% = FormatProportionPercentage(teams(i).gainedAgainst, teams(i).pointsAgainst) %></td>
				<td align="right"><% = FormatProportion(teams(i).gainedFor + teams(i).gainedAgainst, teams(i).pointsFor + teams(i).pointsAgainst) %></td>
				<td><% = FormatProportionPercentage(teams(i).gainedFor + teams(i).gainedAgainst, teams(i).pointsFor + teams(i).pointsAgainst) %></td>
			</tr>
<%		next %>
		</tbody>
	</table>
	<h2>Average Confidence Points Assigned per Pick by Team<% = headerStr %></h2>
	<table class="main" border="0" cellpadding="0" cellspacing="0" style="width: 100%">
		<thead id="avgHead">
			<tr align="right" class="header bottomEdge sortable">
				<th align="left"><a href="#" onclick="this.blur(); return tableSort.sort(avgNameSort);" title="Sort by team name.">Team</a></th>
				<th><a href="#" onclick="this.blur(); return tableSort.sort(avgForSort);" title="Sort by average points assigned when picking for.">For</a>&nbsp;&nbsp;&nbsp;</th>
				<th><a href="#" onclick="this.blur(); return tableSort.sort(avgAgainstSort);" title="Sort by average points assigned when picking against.">Against</a></th>
				<th><a href="#" onclick="this.blur(); return tableSort.sort(avgCombinedSort);" title="Sort by combined average points assigned per pick.">Combined</a></th>
			</tr>
		</thead>
		<tbody id="avgBody">
<%		alt = false
		for i = 0 to UBound(teams)
			if alt then %>
			<tr align="right" class="alt singleLine">
<%			else %>
			<tr align="right" class="singleLine">
<%			end if
			alt = not alt %>
				<td align="left"><a href="teamSchedules.asp?id=<% = teams(i).id %>"><% call DisplayTeamLogo(teams(i).id) %><% = teams(i).name %></a></td>
				<td><% = FormatAverage(teams(i).pointsFor, teams(i).picksFor, 3) %></td>
				<td><% = FormatAverage(teams(i).pointsAgainst, teams(i).picksAgainst, 3) %></td>
				<td><% = FormatAverage(teams(i).pointsFor + teams(i).pointsAgainst, teams(i).picksFor + teams(i).picksAgainst, 3) %></td>
			</tr>
<%		next %>
		</tbody>
	</table>
<%	end if

	'List the players for selection. %>
	<p></p>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
	<table border="0" cellpadding="0" cellspacing="0">
		<tr valign="middle">
			<td><strong>Select player:</strong></td>
			<td>
				<select name="username">
					<% call DisplayUserSelectList(GetAllWeeklyPlayersList(), username) %>
				</select>
			</td>
			<td><input type="submit" value="Select" class="button" /></td>
		</tr>
	</table>
	</form>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Returns a formatted string representing the proportion x/y.
	'--------------------------------------------------------------------------
	function FormatProportion(x, y)

		FormatProportion = "&nbsp;"
		if IsNumeric(x) and IsNumeric(y) then
			FormatProportion = x & "/" & y
		end if

	end function

	'--------------------------------------------------------------------------
	' Returns a formatted string representing the proportion x/y as a
	' percentage.
	'--------------------------------------------------------------------------
	function FormatProportionPercentage(x, y)

		FormatProportionPercentage = "&nbsp;"
		if IsNumeric(x) and IsNumeric(y) then
			if y = 0 then
				FormatProportionPercentage = "(" & FormatPercentage(0) & ")"
			else
				FormatProportionPercentage = "(" & FormatPercentage(x / y) & ")"
			end if
		end if

	end function

	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' TeamObj: Holds information for a single team.
	'--------------------------------------------------------------------------
	class TeamObj

		public id
		public name
		public picksFor, picksAgainst
		public correctFor, correctAgainst
		public pointsFor, pointsAgainst
		public gainedFor, gainedAgainst

		private sub Class_Initialize()

			name = ""
			picksFor   = 0 : picksAgainst   = 0
			correctFor = 0 : correctAgainst = 0
			pointsFor  = 0 : pointsAgainst  = 0
			gainedFor  = 0 : gainedAgainst  = 0

		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(teamID)

			dim sql, rs
			dim pts

			'Save the team ID.
			id = teamID

			'Get team name.
			sql = "SELECT * FROM Teams WHERE TeamID = '" & teamID & "'"
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				name = rs.Fields("City").Value & " " & rs.Fields("Name").Value
			end if

			'Determine which result field to use.
			dim resultField
			resultField = "Result"
			if USE_POINT_SPREADS then
				resultField = "ATSResult"
			end if

			'If a username was specified, include only that player's picks.
			dim userFilter
			if username <> "" then
				userFilter =  " AND Username = '" & SqlEscape(username) & "'"
			else
				userFilter = ""
			end if

			'Find total picks for/against and confidence points wagered for/against.
			sql = "SELECT Pick, Confidence" _
			   & " FROM WeeklyPicks, Schedule" _
			   & " WHERE WeeklyPicks.GameID = Schedule.GameID" _
			   & " AND Schedule." & resultField & " IS NOT NULL" _
			   & " AND WeeklyPicks.Pick IS NOT NULL" _
		       & " AND (Schedule.VisitorID = '" & teamID & "' OR Schedule.HomeID = '" & teamID & "')" _
			   & userFilter
			set rs = DbConn.Execute(sql)
			do while not rs.EOF
				pts = rs.Fields("Confidence").Value
				if rs.Fields("Pick").Value = teamID then
					picksFor  = picksFor  + 1
					if IsNumeric(pts) then
						pointsFor = pointsFor + pts
					end if
				else
					picksAgainst  = picksAgainst  + 1
					if IsNumeric(pts) then
						pointsAgainst = pointsAgainst + pts
					end if
				end if
				rs.MoveNext
			loop

			'Find total correct picks for/against and confidence points gained/lost.
			sql = "SELECT Pick, Confidence" _
			   & " FROM WeeklyPicks, Schedule" _
			   & " WHERE WeeklyPicks.GameID = Schedule.GameID" _
			   & " AND Schedule." & resultField & " IS NOT NULL" _
			   & " AND WeeklyPicks.Pick IS NOT NULL" _
		       & " AND (Schedule.VisitorID = '" & teamID & "' OR Schedule.HomeID = '" & teamID & "')" _
			   & " AND Schedule." & resultField & " = WeeklyPicks.Pick" _
			   & userFilter
			set rs = DbConn.Execute(sql)
			do while not rs.EOF
				pts = rs.Fields("Confidence").Value
				if rs.Fields("Pick").Value = teamID then
					correctFor = correctFor + 1
					if IsNumeric(pts) then
						gainedFor  = gainedFor + pts
					end if
				else
					correctAgainst = correctAgainst + 1
					if IsNumeric(pts) then
						gainedAgainst  = gainedAgainst + pts
					end if
				end if
				rs.MoveNext
			loop

			'Handle ties when tie picks are not allowed.
			if not ALLOW_TIE_PICKS then
				sql = "SELECT Pick, Confidence" _
				   & " FROM WeeklyPicks, Schedule" _
				   & " WHERE WeeklyPicks.GameID = Schedule.GameID" _
				   & " AND Schedule." & resultField & " IS NOT NULL" _
				   & " AND WeeklyPicks.Pick IS NOT NULL" _
			       & " AND (Schedule.VisitorID = '" & teamID & "' OR Schedule.HomeID = '" & teamID & "')" _
				   & " AND Schedule." & resultField & " = '" & TIE_STR & "'" _
				   & userFilter
				set rs = DbConn.Execute(sql)
				do while not rs.EOF
					if rs.Fields("Pick").Value = teamID then
						correctFor = correctFor + 0.5
						gainedFor  = gainedFor  + rs.Fields("Confidence").Value / 2
					else
						correctAgainst = correctAgainst + 0.5
						gainedAgainst  = gainedAgainst  + rs.Fields("Confidence").Value / 2
					end if
					rs.MoveNext
				loop
			end if

			'Update the global totals.
			totalCorrect  = totalCorrect  + correctFor
			totalPicks    = totalPicks    + picksFor
			totalGained   = totalGained   + gainedFor
			totalAssigned = totalAssigned + pointsFor

		end sub

	end class %>
