<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/weekly.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Weekly Scoring Charts"
	call BuildPageHeader("barCharts.css", "") %>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>

<%	'Get the selected user.
	dim username
	username = Trim(Request("username"))
	if not IsAdmin() and username = "" then
		username = Session(SESSION_USERNAME_KEY)
	end if

	'Get the total number of weeks.
	dim numWeeks
	numWeeks = GetWeekCount

	'Get a list of usernames.
	dim users
	users = GetAllWeeklyPlayersList()

	'Build the display.
	dim i, j
	dim anyPlayed
	dim score, maxScore, topScore, bottomScore, userScore
	dim barBottom, barHeight
	dim cols
	cols = numWeeks + 1

	dim headerStr
	headerStr = "Scoring Chart"
	if USE_CONFIDENCE_POINTS then
		headerStr = headerStr & "s"
	end if
	if username <> "" then
		headerStr = headerStr & " for " & username
	end if %>
	<h2><% = headerStr %></h2>
	<table class="main" border="0" cellpadding="0" cellspacing="0">
		<tr class="header bottomEdge">
			<th colspan="<% = cols %>">Correct Picks</th>
		</tr>
		<tr class="subHeader bottomEdge">
			<th>&nbsp;</th>
<%	for i = 1 to numWeeks %>
			<th><% = i %></th>
<%	next %>
		</tr>
		<tr class="grid">
			<td>
				<div class="scaleContainer">
					<div class="vertScale" style="top:   0px;">100%</div>
					<div class="vertScale" style="top:  50px;">90%</div>
					<div class="vertScale" style="top: 100px;">80%</div>
					<div class="vertScale" style="top: 150px;">70%</div>
					<div class="vertScale" style="top: 200px;">60%</div>
					<div class="vertScale" style="top: 250px;">50%</div>
					<div class="vertScale" style="top: 300px;">40%</div>
					<div class="vertScale" style="top: 350px;">30%</div>
					<div class="vertScale" style="top: 400px;">20%</div>
					<div class="vertScale" style="top: 450px;">10%</div>
				</div>
			</td>
<%	for i = 1 to numWeeks %>
			<td>
				<div class="barContainer">
<%		anyPlayed = false
		if IsNumeric(GetWeeklyTiebreakerActual(i)) then
			maxScore = GetGameCount(i)
			topScore = -1
			bottomScore = maxScore + 1
			userScore = ""
			for j = 0 to UBound(users)
				score = GetWeeklyPickScore(users(j), i)
				if IsNumeric(score) then
					anyPlayed = true
					if score > topScore then
						topScore = score
					end if
					if score < bottomScore then
						bottomScore = score
					end if
					if users(j) = username then
						userScore = score
					end if
				end if
			next
		end if
		if anyPlayed then
			barBottom = Round(500 * bottomScore / maxScore) - 1
			barHeight = Round(500 * (topScore - bottomScore) / maxScore) - 1
			if not IsNumeric(userScore) then %>
					<div class="bar inactiveRangeBar" style="height: <% = barHeight %>px; bottom: <% = barBottom %>px;" title="<% = GetBarText(maxScore, topScore, bottomScore, "") %>">&nbsp;</div>
<%			else %>
					<div class="bar activeRangeBar" style="height: <% = barHeight %>px; bottom: <% = barBottom %>px;" title="<% = GetBarText(maxScore, topScore, bottomScore, userScore) %>">&nbsp;</div>
<%				if userScore <> bottomScore then
					barHeight = Round(500 * (userScore - bottomScore) / maxScore) - 1 %>
					<div class="bar userBar" style="height: <% = barHeight %>px; bottom: <% = barBottom %>px;" title="<% = GetBarText(maxScore, topScore, bottomScore, userScore) %>">&nbsp;</div>
<%				end if
			end if
		else %>
					&nbsp;
<%		end if %>
				</div>
			</td>
<%	next %>
	</table>
<%	if USE_CONFIDENCE_POINTS then %>
	<h2>&nbsp;</h2>
	<table class="main" border="0" cellpadding="0" cellspacing="0">
		<tr class="header bottomEdge">
			<th colspan="<% = cols %>">Confidence Points</th>
		</tr>
		<tr class="subHeader bottomEdge">
			<th>&nbsp;</th>
<%		for i = 1 to numWeeks %>
			<th><% = i %></th>
<%		next %>
		</tr>
		<tr class="grid">
			<td>
				<div class="scaleContainer">
					<div class="vertScale" style="top:   0px;">100%</div>
					<div class="vertScale" style="top:  50px;">90%</div>
					<div class="vertScale" style="top: 100px;">80%</div>
					<div class="vertScale" style="top: 150px;">70%</div>
					<div class="vertScale" style="top: 200px;">60%</div>
					<div class="vertScale" style="top: 250px;">50%</div>
					<div class="vertScale" style="top: 300px;">40%</div>
					<div class="vertScale" style="top: 350px;">30%</div>
					<div class="vertScale" style="top: 400px;">20%</div>
					<div class="vertScale" style="top: 450px;">10%</div>
				</div>
			</td>
<%		for i = 1 to numWeeks %>
			<td>
				<div class="barContainer">
<%			anyPlayed = false
			if IsNumeric(GetWeeklyTiebreakerActual(i)) then
				j = GetGameCount(i)
				maxScore = (j + 1) * j / 2
				topScore = 0
				bottomScore = maxScore
				userScore = ""
				for j = 0 to UBound(users)
					score = GetWeeklyConfidenceScore(users(j), i)
					if IsNumeric(score) then
						anyPlayed = true
						if score > topScore then
							topScore = score
						end if
						if score < bottomScore then
							bottomScore = score
						end if
						if users(j) = username then
							userScore = score
						end if
					end if
				next
			end if
			if anyPlayed then
				barBottom = Round(500 * bottomScore / maxScore) - 1
				barHeight = Round(500 * (topScore - bottomScore) / maxScore) - 1
				if not IsNumeric(userScore) then %>
					<div class="bar inactiveRangeBar" style="height: <% = barHeight %>px; bottom: <% = barBottom %>px;" title="<% = GetBarText(maxScore, topScore, bottomScore, "") %>">&nbsp;</div>
<%				else %>
					<div class="bar activeRangeBar" style="height: <% = barHeight %>px; bottom: <% = barBottom %>px;" title="<% = GetBarText(maxScore, topScore, bottomScore, userScore) %>">&nbsp;</div>
<%					if userScore <> bottomScore then
						barHeight = Round(500 * (userScore - bottomScore) / maxScore) - 1 %>
					<div class="bar userBar" style="height: <% = barHeight %>px; bottom: <% = barBottom %>px;" title="<% = GetBarText(maxScore, topScore, bottomScore, userScore) %>">&nbsp;</div>
<%					end if
				end if
			else %>
					&nbsp;
<%			end if %>
				</div>
			</td>
<%		next %>
	</table>
<%	end if

	'List the players for selection. %>
	<p></p>
	<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
	<table border="0" cellpadding="0" cellspacing="0">
		<tr valign="middle">
			<td><strong>Select player:</strong></td>
			<td>
				<select name="username">
					<% call DisplayUserSelectList(GetAllWeeklyPlayersList(), username) %>
				</select>
			</td>
			<td><input type="submit" value="Select" class="button" /></td>
		</tr>
	</table>
	</form>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Returns a string describing the given score data.
	'--------------------------------------------------------------------------
	function GetBarText(max, top, bottom, user)

		GetBarText = GetBarText & " Best: " & top & " (out of " & max & ")"
		if Len(user) > 0 and username <> ADMIN_USERNAME then
			GetBarText = GetBarText & ", " & username & ": " & user
		end if
		GetBarText = GetBarText &", Worst: " & bottom

	end function %>
