<%@ LANGUAGE="VBScript" %>
<!-- #include file="includes/config.asp" --><!-- #include file="includes/common.asp" --><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- #include file="includes/weekly.asp" -->
<%	'Require login to access the page.
	call CheckAccess(false)

	'Open the database.
	call OpenDb() %>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<%	PageSubTitle = "Weekly Pool Summary"
	call BuildPageHeader("tableSort.css", "tableSort.js") %>
	<script type="text/javascript">//<![CDATA[
	//=========================================================================
	// Define the winners table sort commands.
	//=========================================================================
	var winnersWeekSort = {
		initialSort : true,
		tbodyID     : "winnersBody",
		theadID     : "winnersHead",
		sortColumns : [
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [],
			headColumns : []
		}
	}
	var winnersWinnersSort = {
		tbodyID     : "winnersBody",
		theadID     : "winnersHead",
		sortColumns : [
			{ column : 1, descending : false },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [1],
			headColumns : [1]
		}
	}
	var winnersScoreSort = {
		tbodyID     : "winnersBody",
		theadID     : "winnersHead",
<%	if USE_CONFIDENCE_POINTS then %>
		sortColumns : [
			{ column : 2, descending : true },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [2],
			headColumns : [2]
		}
<%	else %>
		sortColumns : [
			{ column : 3, descending : true },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [2, 3],
			headColumns : [2]
		}
<%	end if %>
	}
	var winnersPlayersSort = {
		tbodyID     : "winnersBody",
		theadID     : "winnersHead",
		sortColumns : [
			{ column : -2, descending : true },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [-2],
			headColumns : [-2]
		}
	}
	var winnersPotSort = {
		tbodyID     : "winnersBody",
		theadID     : "winnersHead",
		sortColumns : [
			{ column : -1, descending : true },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [-1],
			headColumns : [-1]
		}
	}
	//=========================================================================
	// Define the statistics table sort commands.
	//=========================================================================
	var statisticsNameSort = {
		initialSort : true,
		tbodyID     : "statisticsBody",
		theadID     : "statisticsHead",
		sortColumns : [
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [],
			headColumns : []
		}
	}
	var statisticsPlayedSort = {
		tbodyID     : "statisticsBody",
		theadID     : "statisticsHead",
		sortColumns : [
			{ column : 1, descending : true },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [1],
			headColumns : [1]
		}
	}
	var statisticsWonSort = {
		tbodyID     : "statisticsBody",
		theadID     : "statisticsHead",
		sortColumns : [
			{ column : 2, descending : true },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [2],
			headColumns : [2]
		}
	}
	var statisticsCostSort = {
		tbodyID     : "statisticsBody",
		theadID     : "statisticsHead",
		sortColumns : [
			{ column : 3, descending : true },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [3],
			headColumns : [3]
		}
	}
	var statisticsWinningsSort = {
		tbodyID     : "statisticsBody",
		theadID     : "statisticsHead",
		sortColumns : [
			{ column : 4, descending : true },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [4],
			headColumns : [4]
		}
	}
	var statisticsNetSort = {
		tbodyID     : "statisticsBody",
		theadID     : "statisticsHead",
		sortColumns : [
			{ column : 5, descending : true },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [5],
			headColumns : [5]
		}
	}
	var statisticsPicksSort = {
		tbodyID     : "statisticsBody",
		theadID     : "statisticsHead",
<%	if ENABLE_OVERALL_WEEKLY then %>
		sortColumns : [
			{ column : 6, descending : true },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [6, 7, 8],
			headColumns : [6]
		}
<%	else %>
		sortColumns : [
			{ column : 7, descending : true },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [6, 7],
			headColumns : [6]
		}
<%	end if %>
	}
<%	if USE_CONFIDENCE_POINTS then %>
	var statisticsPointsSort = {
		tbodyID     : "statisticsBody",
		theadID     : "statisticsHead",
<%		if ENABLE_OVERALL_WEEKLY then %>
		sortColumns : [
			{ column : -2, descending : true },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [-2, -1],
			headColumns : [-1]
		}
<%		else %>
		sortColumns : [
			{ column : -1, descending : true },
			{ column : 0, descending : false }
		],
		highlightColumns : {
			bodyColumns : [-1],
			headColumns : [-1]
		}
<%		end if %>
	}
<%	end if %>
	//]]></script>
<!-- #include file="includes/custom.asp" -->
</head>
<body>
<!-- #include file="includes/header.asp" -->
<!-- #include file="includes/menu.asp" -->
	<div id="contentSection">
	<table id="mainWrapper" border="0" cellpadding="0" cellspacing="0"><tr><td>
<%	'Get the current date and time.
	dim dateNow
	dateNow = GetCurrentDateTime()

	'Determine the maximum week to check.
	dim maxWeek
	maxWeek = GetCurrentWeek()
	if dateNow <= GetWeeklyStartDateTime(maxWeek) then
		maxWeek = maxWeek - 1
	end if

	'Create an array of user objects (need to build this first because we will
	'use the weekly pool results to add up each user's winnings).
	dim users, list, i
	list = GetAllWeeklyPlayersList()
	if IsArray(list) then
		redim users(UBound(list))
		for i = 0 to UBound(list)
			set users(i) = new UserObj
			users(i).setData(list(i))
		next
	end if

	'Build the weekly winners display. %>
	<h2>Weekly Pool Winners</h2>
	<table class="main" cellpadding="0" cellspacing="0">
		<thead id="winnersHead">
			<tr align="right" class="header bottomEdge sortable">
				<th align="center"><a href="#" onclick="this.blur(); return tableSort.sort(winnersWeekSort);" title="Sort by week.">Week</a></th>
				<th align="left"><a href="#" onclick="this.blur(); return tableSort.sort(winnersWinnersSort);" title="Sort by winners.">Winner(s)</a></th>
				<th align="center" colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(winnersScoreSort);" title="Sort by score.">Score</a></th>
				<th>Tiebreaker</th>
				<th>Actual</th>
				<th>(Diff.)</th>
				<th><a href="#" onclick="this.blur(); return tableSort.sort(winnersPlayersSort);" title="Sort by number of players.">Players</a></th>
				<th align="center"><a href="#" onclick="this.blur(); return tableSort.sort(winnersPotSort);" title="Sort by amount won.">Pot</a></th>
			</tr>
		</thead>
		<tbody id="winnersBody">
<%	'Determine the latest week we have complete results for.
	dim maxCompWeek, completedGames
	maxCompWeek = maxWeek
	completedGames = GetCompletedGameCount(maxCompWeek)
	do while GetGameCount(maxCompWeek) <> completedGames and maxCompWeek > 0
		maxCompWeek = maxCompWeek - 1
		completedGames = GetCompletedGameCount(maxCompWeek)
	loop

	'If there are no results to show, let the user know.
	if maxCompWeek < 1 then
		completedGames = GetCompletedGameCount(1) %>
			<tr class="noSort">
				<td align="center" colspan="9"><em>No results available.</em></td>
			</tr>
<%	end if

	'Get the pool results for each week.
	dim week, alt
	dim j, n
	dim winners, score, numGames, tb, actual, diff, players, pot
	dim scoreStr, pctStr 
	alt = false
	for week = 1 to maxCompWeek
		list = GetWeeklyWinnersList(week)
		winners = "n/a"
		score = ""
		tb = "n/a"
		actual = GetWeeklyTiebreakerActual(week)
		diff = "&nbsp;"
		players = 0
		pot = 0
		if IsArray(list) then
			winners = Join(list, ", ")
			players = GetWeeklyEntryCount(week)
			numGames = GetGameCount(week)
			if USE_CONFIDENCE_POINTS then
				score = GetWeeklyConfidenceScore(list(0), week)
			else
				score = GetWeeklyPickScore(list(0), week)
			end if
			pot = GetWeeklyPotAmount(week)

			'If there was a tie for highest score, show tiebreaker data.
			if GetTiedScoreCount(week, score) > 1 then
				tb = GetWeeklyTiebreakerGuess(list(0), week)
				diff = " (" & Abs(tb - actual) & ")"
				for i = 1 to UBound(list)
					tb = tb & ", " & GetWeeklyTiebreakerGuess(list(i), week)
				next
			end if

			'Update the win totals for each user in the winners list.
			for i = 0 to UBound(list)
				for j = 0 to UBound(users)
					n = Ubound(list) + 1
					if users(j).name = list(i) then
						users(j).poolsWon = users(j).poolsWon + 1 / n
						users(j).totalWinnings = users(j).totalWinnings + pot / n
						exit for
					end if
				next
			next

		end if

		'Format the score display.
		if USE_CONFIDENCE_POINTS then
			scoreStr = FormatScore(score, true)
		else
			if IsNumeric(score) and numGames > 0 then
				scoreStr = score & "/" & numGames
				pctStr   = "(" & FormatPercentage(score / numGames) & ")"
			else
				scoreStr = "n/a"
				pctStr = ""
			end if
		end if

		if alt then %>
			<tr align="right" class="alt singleLine" valign="top">
<%		else %>
			<tr align="right" class="singleLine" valign="top">
<%		end if
		alt = not alt %>
				<td><a href="weeklyResults.asp?week=<% = week %>"><% = week %></a></td>
				<td align="left"><% = winners %></td>
<%		if USE_CONFIDENCE_POINTS then %>
				<td colspan="2"><% = scoreStr %></td>
<%		else %>
				<td><% = scoreStr %></td>
				<td><% = pctStr %></td>
<%		end if %>
				<td><% = tb %></td>
				<td><% = actual %></td>
				<td><% = diff %></td>
				<td><% = players %></td>
				<td><% = FormatAmount(pot) %></td>
			</tr>
<%	next %>
		</tbody>
	</table>
<%	'Build the individual statistics display.
	dim cost, net
	dim cols
	cols =  8
	if USE_CONFIDENCE_POINTS then
		cols = cols + 1
	end if
	if ENABLE_OVERALL_WEEKLY then
		cols = cols + 1
		if USE_CONFIDENCE_POINTS then
			cols = cols + 1
		end if
	end if

	'If overall awards are enabled, get the current leading score(s).
	dim leadPickScore, leadConfScore
	if IsArray(users) and ENABLE_OVERALL_WEEKLY and completedGames > 0 then
		leadPickScore = 0
		leadConfScore = 0
		for i = 0 to UBound(users)
			if users(i).totalCorrect > leadPickScore then
				leadPickScore = users(i).totalCorrect
			end if
			if USE_CONFIDENCE_POINTS then
				if users(i).totalScore > leadConfScore then
					leadConfScore = users(i).totalScore
				end if
			end if
		next
	end if

	'If confidence points are used, determine if there are any total scores
	'with a half of a point.
	dim anyHalfPts
	anyHalfPts = false
	if IsArray(users) and USE_CONFIDENCE_POINTS then
		for i = 0 to UBound(users)
			if Round(users(i).totalScore) <> users(i).totalScore then
				anyHalfPts = true
			end if
		next
	end if %>
	<h2>Individual Weekly Pool Statistics</h2>
	<table class="main" border="0" cellpadding="0" cellspacing="0">
		<thead id="statisticsHead">
			<tr class="header bottomEdge singleLine sortable">
				<th align="left"><a href="#" onclick="this.blur(); return tableSort.sort(statisticsNameSort);" title="Sort by name.">Name</a></th>
				<th align="right"><a href="#" onclick="this.blur(); return tableSort.sort(statisticsPlayedSort);" title="Sort by pools played.">Played</a></th>
				<th align="right"><a href="#" onclick="this.blur(); return tableSort.sort(statisticsWonSort);" title="Sort by pools won.">Won</a></th>
				<th align="center"><a href="#" onclick="this.blur(); return tableSort.sort(statisticsCostSort);" title="Sort by cost.">Cost</a></th>
				<th align="right"><a href="#" onclick="this.blur(); return tableSort.sort(statisticsWinningsSort);" title="Sort by gross winnings.">Winnings</a></th>
				<th align="center"><a href="#" onclick="this.blur(); return tableSort.sort(statisticsNetSort);" title="Sort by net winnings.">Net</a></th>
<%	if ENABLE_OVERALL_WEEKLY then %>
				<th align="center" colspan="3"><a href="#" onclick="this.blur(); return tableSort.sort(statisticsPicksSort);" title="Sort by total correct picks.">Overall Picks</a></th>
<%	else %>
				<th align="center" colspan="2"><a href="#" onclick="this.blur(); return tableSort.sort(statisticsPicksSort);" title="Sort by overall pick percentage.">Overall Picks</a></th>
<%	end if
	if USE_CONFIDENCE_POINTS then %>
				<th align="center"<% if ENABLE_OVERALL_WEEKLY then Response.Write(" colspan=""2""") end if %>><a href="#" onclick="this.blur(); return tableSort.sort(statisticsPointsSort);" title="Sort by total points.">Total Pts.</a></th>
<%	end if %>
			</tr>
		</thead>
<%	'If overall awards are enabled, show the pot/payout.
	dim pickPot, confPot
	dim str
	if ENABLE_OVERALL_WEEKLY then
		if IsArray(users) then
			pickPot = GetOverallPotAmount()
			str = "Overall"
			if USE_CONFIDENCE_POINTS then
				confPot = pickPot * OVERALL_CONFIDENCE_WEEKLY_SHARE
				pickPot = pickPot - confPot
				str = str & " Picks Pot: " & FormatAmount(pickPot)
				str = str & "<br /> Overall Points Pot: " & FormatAmount(confPot)
			else
				str = str & " Pot: " & FormatAmount(pickPot)
			end if %>
		<tfoot>
<%			if not IsRegularSeasonComplete() then %>
			<tr class="subHeader topEdge">
				<th align="left"<% if USE_CONFIDENCE_POINTS then Response.Write(" class=""small""") end if %> colspan="<% = cols %>"><% = str %></th>
			</tr>
<%			else
				list = GetOverallPickWinnersList()
				if IsArray(list) then
					str = "Overall"
					if USE_CONFIDENCE_POINTS then
						str = str & " Picks"
					end if
					if UBound(list) > 0 then
						str = str & " Winners: " & Join(list, ", ") & " (" & FormatAmount(pickPot / (UBound(list) + 1)) & " each)"
					else
						str = str & " Winner: " & Join(list, ", ") & " (" & FormatAmount(pickPot) & ")"
					end if
					if USE_CONFIDENCE_POINTS then
						list = GetOverallConfidenceWinnersList()
						str = str & "<br /> Overall Points"
						if UBound(list) > 0 then
							str = str & " Winners: " & Join(list, ", ") & " (" & FormatAmount(confPot / (UBound(list) + 1)) & " each)"
						else
							str = str & " Winner: " & Join(list, ", ") & " (" & FormatAmount(confPot) & ")"
						end if
					end if
				end if %>
			<tr class="header topEdge">
				<th align="left"<% if USE_CONFIDENCE_POINTS then Response.Write(" class=""small""") end if %> colspan="<% = cols %>"><% = str %></th>
			</tr>
<%			end if %>
		</tfoot>
<%		end if
	end if %>
		<tbody  id="statisticsBody">
<%	if IsArray(users) then
		dim decimalPlaces
		dim scoreDiff
		decimalPlaces = GetMaxDecimalPlaces()
		for i = 0 to UBound(users)
			if Round(i / 2) * 2 = i then %>
			<tr align="right" class="singleLine" valign="top">
<%			else %>
			<tr align="right" class="alt singleLine" valign="top">
<%			end if
			cost = users(i).poolsPlayed * WEEKLY_ENTRY_FEE
			net = users(i).totalWinnings - cost
			if users(i).totalGames <> 0 then
				pctStr = "(" & FormatPercentage(users(i).totalCorrect / users(i).totalGames) & ")"
			else
				pctStr = "(" & FormatPercentage(0) & ")"
			end if %>
				<td align="left"><% = users(i).name %></td>
				<td><% = users(i).poolsPlayed %></td>
				<td><% = FormatNumber(users(i).poolsWon, decimalPlaces, true) %></td>
				<td><% = FormatAmount(cost) %></td>
				<td><% = FormatAmount(users(i).totalWinnings) %></td>
				<td><% = FormatAmount(net) %></td>
				<td><% = users(i).totalCorrect & "/" & users(i).totalGames %></td>
				<td><% = pctStr %></td>
<%			if ENABLE_OVERALL_WEEKLY then
				scoreDiff = "&nbsp;"
				if users(i).totalCorrect < leadPickScore then
					scoreDiff = "(" & FormatScore(users(i).totalCorrect -leadPickScore, false) & ")"
				end if %>
				<td><span class="small"><% = scoreDiff %></span></td>
<%			end if
			if USE_CONFIDENCE_POINTS then %>
				<td><% = FormatScore(users(i).totalScore, anyHalfPts) %></td>
<%				if ENABLE_OVERALL_WEEKLY then
					scoreDiff = "&nbsp;"
					if users(i).totalScore < leadConfScore then
						scoreDiff = "(" & FormatScore(users(i).totalScore -leadConfScore, false) & ")"
					end if %>
				<td><span class="small"><% = scoreDiff %></span></td>
<%				end if
			end if %>
			</tr>
<%		next
	else %>
			<tr class="noSort">
				<td align="center" colspan="<% = cols %>"><em>No players found.</em></td>
			</tr>
<%	end if %>
		</tbody>
	</table>
	</td></tr></table>
	</div>
<!-- #include file="includes/footer.asp" -->
</body>
</html>
<%	'**************************************************************************
	'* Local functions and subroutines.                                       *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' Determines how many decimal places to show in the pools won column.
	'--------------------------------------------------------------------------
	function GetMaxDecimalPlaces()

		dim i, n, d

		GetMaxDecimalPlaces = 0

		for i = 0 to UBound(users)
			n = users(i).poolsWon - Round(users(i).poolsWon - .5)
			d = Len(n) - 2
			if d > GetMaxDecimalPlaces then
				GetMaxDecimalPlaces = d
				if GetMaxDecimalPlaces > 3 then
					GetMaxDecimalPlaces = 3
					exit function
				end if
			end if
		next

	end function

	'--------------------------------------------------------------------------
	' Returns the number of players who had the given score in the given week.
	'--------------------------------------------------------------------------
	function GetTiedScoreCount(week, score)

		dim scoreField, sql, rs

		GetTiedScoreCount = 0

		scoreField = "PickScore"
		if USE_CONFIDENCE_POINTS then
			scoreField = "ConfidenceScore"
		end if
		sql = "SELECT COUNT(*) AS Total FROM WeeklyScoring" _
		   & " WHERE Week = " & week _
		   & " AND " & scoreField & " = " & score
		set rs = DbConn.Execute(sql)
		if not (rs.EOF and rs.BOF) then
			GetTiedScoreCount = rs.Fields("Total").Value
		end if

	end function

	'**************************************************************************
	'* Local class definitions.                                               *
	'**************************************************************************

	'--------------------------------------------------------------------------
	' UserObj: Holds information for a single user.
	'--------------------------------------------------------------------------
	class UserObj

		public name
		public poolsPlayed
		public poolsWon
		public totalCorrect
		public totalGames
		public totalScore
		public totalWinnings

		private sub Class_Initialize()
		end sub

		private sub Class_Terminate()
		end sub

		public sub setData(username)

			dim sql, rs
			dim i, n
			dim pickScore, confScore

			'Set the user properties.
			name = username

			'Find the number of weeks this user has participated in so far.
			'Note that the current week is included only after the first game
			'has started.
			poolsPlayed = 0
			sql = "SELECT COUNT(*) AS Total" _
			   & " FROM WeeklyScoring" _
			   & " WHERE Username = '" & SqlEscape(username) & "'" _
			   & " AND Week <= " & maxWeek
			set rs = DbConn.Execute(sql)
			if not (rs.EOF and rs.BOF) then
				poolsPlayed = rs.Fields("Total").Value
			end if

			'Get the overall pick stats and score data for this user.
			totalCorrect = 0
			totalGames   = 0
			totalScore   = 0
			sql = "SELECT * FROM WeeklyScoring" _
			   & " WHERE Username = '" & SqlEscape(username) & "'" _
			   & " ORDER BY Week"
			set rs = DbConn.Execute(sql)
			do while not rs.EOF
				week      = rs.Fields("Week").Value
				pickScore = rs.Fields("PickScore").Value
				if IsNull(pickScore) then
					pickScore = GetWeeklyPickScore(username, week)
				end if
				if IsNumeric(pickScore) then
					totalCorrect = totalCorrect + pickScore
				end if
				if USE_CONFIDENCE_POINTS then
					confScore = rs.Fields("ConfidenceScore").Value
					if IsNull(confScore) then
						confScore = GetWeeklyConfidenceScore(username, week)
					end if
					if IsNumeric(confScore) then
						totalScore = totalScore + confScore
					end if
				end if
				totalGames = totalGames + GetCompletedGameCount(week)
				rs.MoveNext
			loop

			'Initialize remaining properties.
			poolsWon = 0
			totalWinnings = 0
		end sub

	end class %>
